SystemOrganization addCategory: #'NXTalk-ST-Kernel'!
SystemOrganization addCategory: #'NXTalk-Building'!
SystemOrganization addCategory: #'NXTalk-ST-Collections'!
SystemOrganization addCategory: #'NXTalk-ST-Tests'!
SystemOrganization addCategory: #'NXTalk-ST-Hardware'!
SystemOrganization addCategory: #'NXTalk-Connections'!
SystemOrganization addCategory: #'NXTalk-ST-Streams'!
SystemOrganization addCategory: #'NXTalk-ST-Programs'!
SystemOrganization addCategory: #'NXTalk-Examples-Snake'!
SystemOrganization addCategory: #'NXTalk-ST-Packaging'!
SystemOrganization addCategory: #'NXTalk-Examples-LineFollower'!

!String methodsFor: '*nxtalk' stamp: 'mab 6/6/2008 11:13'!
asNXTObject
	| string |
	string := NXTString new: self size.
	^ string replaceFrom: 1 to: self size with: self! !

!LargePositiveInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:24'!
asNXTObject
	| size nxtObject |
	size := self digitLength.
	nxtObject := NXTLargePositiveInteger new: size.
	1 to: size do: [ :i | nxtObject at: i put: (self at: i) ].
	^ nxtObject! !

!Symbol methodsFor: '*nxtalk' stamp: 'mab 6/6/2008 11:14'!
asNXTObject
	| symbol |
	symbol := NXTSymbol new: self size.
	^ symbol replaceFrom: 1 to: self size with: self! !

!Symbol methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 14:36'!
asSqueakObject
	^ self! !

Object subclass: #NXTClassCompiler
	instanceVariableNames: 'compilerContext compiledClass superclass nxtClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTClassCompiler commentStamp: 'mab 3/13/2009 11:02' prior: 0!
My instances compile full class.

Instance Variables
	compiledClass:		<Class>
	compilerContext:		<NXTImage>
	nxtClass:		<NXTClass>
	superclass:		<NXTClass>

compiledClass
	- The Squeak class, we're compiling.

compilerContext
	- The context of our compiler, which is indeed the image we're compiling for.

nxtClass
	- The NXTClass object we're filling in with the compiled data.

superclass
	- The NXTClass object, which represents our superclass.
!

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:53'!
classNamed: aClassName
	^ self compilerContext classNamed: aClassName! !

!NXTClassCompiler methodsFor: 'compiling' stamp: 'mab 11/17/2008 18:21'!
compile: aClass into: anNXTClass
	self compiledClass: aClass.
	self superclass: self compileSuperclass.
	self fillEmptyClass: anNXTClass.
! !

!NXTClassCompiler methodsFor: 'compiling' stamp: 'mab 11/17/2008 19:27'!
compileSuperclass
	^ (self compiledClass name = #NXTObject or: [self compiledClass name = #'NXTObject class'])
		ifFalse: [ self compilerContext classNamed: self compiledClass superclass name asSymbol ]
		ifTrue: [ nil asNXTObject ]! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
compiledClass
	^ compiledClass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
compiledClass: anObject
	compiledClass := anObject! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:21'!
compilerContext
	^ compilerContext! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:21'!
compilerContext: anObject
	compilerContext := anObject! !

!NXTClassCompiler methodsFor: 'compiling' stamp: 'mab 2/13/2009 16:54'!
fillEmptyClass: class
	class name: self compiledClass name asSymbol asNXTObject.
	class format: (self compiledClass elementSize bitOr: self instVarNames size << 2).
	self compiledClass isVariable ifTrue: [ class format: (class format bitOr: 1 << 7) ].
	class superclass: self superclass.
	"self compiledClass name asSymbol = #'NXTPackageManager class' ifTrue: [ self halt. ]."
	class subclasses: NXTOrderedCollection new.
	self includeMethodDictionaryOf: self compiledClass in: class.
	self includeClassVariablesOf: self compiledClass in: class.
	self includeInstanceVariablesOf: self compiledClass in: class.
	self includeClassSideInstanceVariablesOf: self compiledClass in: class.
	^ class! !

!NXTClassCompiler methodsFor: 'including references' stamp: 'mab 11/17/2008 13:47'!
includeClassSideInstanceVariablesOf: aClass in: aNXTClass
	self compiledClass isMeta ifTrue: [ ^ self ].
	"self compiledClass class instVarNames do: [ :instVarName |
		self image addObjectGraph: (self compiledClass instVarNamed: instVarName asSymbol) ]."! !

!NXTClassCompiler methodsFor: 'including references' stamp: 'mab 11/19/2008 16:37'!
includeClassVariablesOf: aClass in: aNXTClass
	aNXTClass classPool: nil asNXTObject.
	self compiledClass isMeta ifTrue: [ ^ self ].
	self compiledClass classPool ifNotEmpty: [
		aNXTClass classPool: self compiledClass classPool asNXTObject ].! !

!NXTClassCompiler methodsFor: 'including references' stamp: 'mab 11/17/2008 19:20'!
includeInstanceVariablesOf: aClass in: aNXTClass
	| instVarNames |
	instVarNames := NXTArray new: aClass instVarNames size.
	aNXTClass instVarNames: instVarNames.
	aClass instVarNames doWithIndex: [ :name :index |
		instVarNames at: index put: name asSymbol asNXTObject ]! !

!NXTClassCompiler methodsFor: 'including references' stamp: 'mab 11/17/2008 19:11'!
includeMethodDictionaryOf: aClass in: aNXTClass
	| methodDictionary method index selectors |
	index := 1.
	selectors := aClass selectors reject: [ :selector |
		(aClass organization categoryOfElement: selector) = #'nxt-exclude' ].
	methodDictionary := NXTArray new: selectors size * 2.
	aNXTClass methodDictionary: methodDictionary.
	self nxtClass: aNXTClass.
	selectors do: [ :selector |
		method := NXTMethodCompiler new
			compilerContext: self;
			compileMethod: (aClass compiledMethodAt: selector).
		methodDictionary at: index put: selector asNXTObject.
		methodDictionary at: index + 1 put: method.
		index := index + 2 ].! !

!NXTClassCompiler methodsFor: 'including references' stamp: 'mab 11/17/2008 13:33'!
includeSuperclass
	self compiledClass name = #NXTObject
		ifFalse: [ self classObject 
			superclass: (self compilerContext 
				classAt: self compiledClass superclass name asSymbol) ]
		ifTrue: [ self classObject superclass: nil ].! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/16/2008 16:55'!
instVarNames
	self compiledClass isMeta 
		ifTrue: [ ^ NXTClass allInstVarNames, self compiledClass instVarNames ]
		ifFalse: [ ^ self compiledClass allInstVarNames ]! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/6/2008 02:37'!
nxtClass
	^ nxtClass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/6/2008 02:37'!
nxtClass: anObject
	nxtClass := anObject! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:39'!
superclass
	^ superclass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:39'!
superclass: anObject
	superclass := anObject! !

Object subclass: #NXTImage
	instanceVariableNames: 'specialObjects symbols classes metaclasses objectTable packageManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImage commentStamp: 'mab 3/13/2009 11:14' prior: 0!
My instances represent a complete NXTalk image and can write its contents in the correct byte format onto a stream.

Instance Variables
	classes:		<Dictionary>
	metaclasses:		<Dictionary>
	objectTable:		<NXTObjectTable>
	packageManager:		<NXTPackageManager>
	specialObjects:		<Dictionary>
	symbols:		<Dictionary>

classes
	- Maps from class names to NXTClass objects.

metaclasses
	- Maps from NXTClass objects to NXTMetaclass objects.

objectTable
	- Manages the positions of objects in the written stream.

packageManager
	- Manages installed packages and will be included in the image.

specialObjects
	- Maps from names of special objects like #nil to their NXTObjects

symbols
	- Maps from Squeak symbols to NXTSymbols in order to keep them unique.
!

!NXTImage class methodsFor: 'constants' stamp: 'mab 3/11/2009 17:23'!
specialClasses
	^ { 
		#NXTSmallInteger.
		#NXTLargePositiveInteger.
		#NXTLargeNegativeInteger.
		#NXTString.
		#NXTMethod.
		#NXTBlock.
		#NXTSymbol.
		#NXTMethodFrame.
		#NXTBlockFrame.
		#NXTArray.
		#NXTProcess.
		#NXTMessage.
		#NXTWeakArray.
		#NXTClass.
		#NXTMetaclass
	 }! !

!NXTImage class methodsFor: 'constants' stamp: 'mab 10/3/2008 12:50'!
specialObjects
	^ {
	#System -> #NXTSystem.
	#nil -> #NXTUndefinedObject.
	#true -> #NXTTrue. 
	#false -> #NXTFalse.
	#Processor -> #NXTProcessorScheduler.
	#Smalltalk -> #NXTSystemDictionary.
	}! !

!NXTImage methodsFor: 'package inclusion' stamp: 'mab 11/19/2008 19:43'!
addClass: class from: aPackage
	self classes at: class name asSqueakObject put: class.
	self metaclasses at: class put: (aPackage metaclasses at: class).! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 3/13/2009 11:09'!
addObject: anNXTObject
	anNXTObject class = SmallInteger ifTrue: [ ^ anNXTObject ].
	anNXTObject isNXTObject
		ifTrue: [ ^ self objectTable addObject: anNXTObject ]
		ifFalse: [ Error signal: 'Attempt to insert non-NXTObject into image' ]! !

!NXTImage methodsFor: 'package inclusion' stamp: 'mab 11/19/2008 19:28'!
addPackage: aPackage
	aPackage classes valuesDo: [ :class |
		class isClassProxy 
			ifTrue: [ self error: 'No class proxies allowed here' ]
			ifFalse: [ self addClass: class from: aPackage ]].
	self packageManager packages add: aPackage.! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/18/2008 09:25'!
classNamed: aClassName
	^ self classNamed: aClassName ifAbsent: [ self error: 'Class not found' ]! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/19/2008 19:24'!
classNamed: aClassName ifAbsent: aBlock
	^ self classes at: aClassName ifAbsent: [
		(aClassName endsWith: ' class') ifFalse: [ ^ aBlock value ].
		^ self metaclasses at: (self classes at: (aClassName allButLast: 6) asSymbol) ifAbsent: aBlock]! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 14:09'!
classes
	^ classes! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 12/12/2008 21:03'!
collectObjectRecursively: anNXTObject
	(self objectTable objects identityIncludes: anNXTObject) ifFalse: [
		anNXTObject isNXTObject ifFalse: [ self error: 'No NXTObject' ].
		anNXTObject isClassProxy ifTrue: [ self error: 'Class proxies are not allowed in image' ].
		self addObject: anNXTObject.
		anNXTObject referencesDo: [ :reference | self collectObjectRecursively: reference ]].
! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 3/5/2009 19:58'!
collectObjects
	self rootObjects do: [ :object |
		self collectObjectRecursively: object ].
! !

!NXTImage methodsFor: 'compiling' stamp: 'mab 11/19/2008 22:22'!
compileClass: aClassName
	| newClass newMetaclass |
	(self classes includesKey: aClassName) ifTrue: [ self error: 'Double class' ].
	newClass := self classes at: aClassName put: NXTClass new.
	newMetaclass := self metaclasses at: newClass put: NXTMetaclass new.
	newMetaclass thisClass: newClass.
	NXTClassCompiler new
		image: self;
		compile: (Smalltalk at: aClassName) into: newClass.
	NXTClassCompiler new
		image: self;
		compile: (Smalltalk at: aClassName) class into: newMetaclass.! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 10:08'!
convertObject: anObject
	anObject isNXTObject ifTrue: [ ^ anObject ].
	anObject ifNil: [ ^ self specialObjectAt: #nil ].
	self error: 'Could not convert for image'.! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 11/17/2008 17:24'!
createClassRelationships
	self createMetaclassRelationship.
	self createSubclassRelationships.! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 3/5/2009 19:09'!
createMetaSubclassRelationshipsFor: metaclass
	| subclasses |
	subclasses := self metaclasses values select: [ :subclass | subclass superclass = metaclass ].
	subclasses := NXTOrderedCollection withAll: subclasses.
	metaclass subclasses: subclasses.! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 3/5/2009 15:47'!
createMetaclassRelationship
	| theMetaclass |
	theMetaclass := self classes at: #NXTMetaclass.
	self metaclasses values do: [ :metaclass |
		self metaclasses at: metaclass put: theMetaclass ] displayingProgress: 'Establishing metaclass relationships'.
	"NXTObject class superclass = NXTClass"
	(self metaclasses at: (self classes at: #NXTObject)) superclass: (self classes at: #NXTClass).! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 3/5/2009 19:58'!
createSubclassRelationships
	self classes values do: [ :class |
		self createSubclassRelationshipsFor: class ].
	self metaclasses values do: [ :metaclass |
		self createMetaSubclassRelationshipsFor: metaclass ].! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 3/5/2009 18:46'!
createSubclassRelationshipsFor: class
	| subclasses |
	subclasses := self classes values select: [ :subclass | subclass superclass = class ].
	subclasses := NXTOrderedCollection withAll: subclasses.
	class subclasses: subclasses.! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 11/19/2008 15:36'!
createSystemDictionary
	self classes valuesDo: [ :class |
		self systemDictionary at: class name put: class ].
	self systemDictionary packageManager: self packageManager.
! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 3/13/2009 11:10'!
finalizeImage
	'Finishing image'
		displayProgressAt: Sensor cursorPoint
		from:  0 to:  7
		during: [ :bar |
			self includeSpecialObjects. bar value: 1.
			self createSystemDictionary. bar value: 2.
			self unifyUniqueObjects. bar value: 3.
			self resolveClassProxies. bar value: 4.
			self createClassRelationships. bar value: 5.
			self collectObjects. bar value: 6.
			self rehashDictionaries. bar value: 7 ].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 10:58'!
findAssociationOrNil: anObject in: array
	| element start finish |
	finish := array size.
	start := ((self hashFor: anObject) \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil or: [element key = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil or: [element key = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 10:59'!
findElementOrNil: anObject in: array
	| element start finish |
	finish := array size.
	start := ((self hashFor: anObject) \\ finish) + 1.
	
	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 11:10'!
hashFor: anObject
	"Retrieves NXTalk hash for anObject by replacing NXTObject>>identityHash"
	| identityHashMethod replacement hash |
	identityHashMethod := NXTObject >> #identityHash.
	[
		replacement := NXTObject >> #identityHashReplacement.
		replacement literalAt: 2 put: self objectTable.
		NXTObject methodDict at: #identityHash put: replacement.
		hash := anObject hash.
	] ensure: [ NXTObject methodDict at: #identityHash put: identityHashMethod ].
	^ hash! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 1/3/2009 11:12'!
includeSpecialObjects
	self specialObjects at: #startup put: (self symbolAt: #startup).
	self specialObjects at: #doesNotUnderstand: put: (self symbolAt: #doesNotUnderstand:).
	self specialObjects at: #onNonLocalReturnsDo: put: (self symbolAt: #onNonLocalReturnsDo:).
	self class specialObjects do: [ :assoc |
		self specialObjectAt: assoc key ].! !

!NXTImage methodsFor: 'testing' stamp: 'mab 11/17/2008 14:04'!
includesClass: aClassName
	^ (classes includesKey: aClassName) or: [ metaclasses anySatisfy: [ :metaclass | metaclass name asSqueakObject = aClassName ]]! !

!NXTImage methodsFor: 'initializing' stamp: 'mab 11/17/2008 14:04'!
initialize
	objects := OrderedCollection new.
	specialObjects := Dictionary new.
	symbols := Dictionary new.
	classes := Dictionary new.
	paddings := 0.
	metaclasses := Dictionary new.
	finished := false.! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 4/28/2008 23:31'!
isSpecialObject: aSymbol
	^ self class specialObjects detect: [ :each |
		each key = aSymbol ] ifNone: [ false ].! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 15:15'!
metaclasses
	^ metaclasses! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 12/12/2008 20:52'!
objectTable
	^ objectTable ifNil: [ objectTable := NXTObjectTable new ]! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 16:14'!
packageManager
	^ packageManager ifNil: [ packageManager := NXTPackageManager new ]! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 3/5/2009 20:00'!
rehashDictionaries
	| visited |
	visited := Set new.
	self rootObjects do: [ :object |
		self rehashDictionariesRecursively: object visited: visited ].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 11:05'!
rehashDictionariesRecursively: anNXTObject visited: visited
	(visited identityIncludes: anNXTObject) ifFalse: [
		visited add: anNXTObject.
		anNXTObject referencesDo: [ :object |
			object isDictionary 
				ifTrue: [ self rehashDictionary: object ]
				ifFalse: [ (object isKindOf: NXTSet) ifTrue: [ self rehashSet: object ]].
			self rehashDictionariesRecursively: object visited: visited ]].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 13:22'!
rehashDictionary: dict
	"Rehashes dictionary in place using NXTalk hashes"
	| array associations |
	associations := OrderedCollection new.
	array := dict instVarNamed: #array.
	array doWithIndex: [ :assoc :index | 
		assoc isNil ifFalse: [ associations add: assoc ].
		array at: index put: (self specialObjectAt: #nil) ].
	associations do: [ :assoc |
		array at: (self findAssociationOrNil: assoc key in: array) put: assoc ].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 11:08'!
rehashSet: dict
	"Rehashes dictionary in place using NXTalk hashes"
	| array elements |
	elements := OrderedCollection new.
	array := dict instVarNamed: #array.
	array doWithIndex: [ :element :index | 
		element isNil ifFalse: [ elements add: element ].
		array at: index put: (self specialObjectAt: #nil) ].
	elements do: [ :element |
		array at: (self findElementOrNil: element in: array) put: element ].! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 3/5/2009 20:00'!
resolveClassProxies
	| visited |
	visited := Set new.
	self rootObjects do: [ :object |
		self resolveClassProxiesRecursively: object visited: visited ].! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 11/20/2008 10:13'!
resolveClassProxiesRecursively: anNXTObject visited: visited
	(visited identityIncludes: anNXTObject) ifFalse: [
		visited add: anNXTObject.
		anNXTObject referencesDo: [ :object |
			object isClassProxy ifTrue: [ self resolveClassProxy: object ].
			self resolveClassProxiesRecursively: object visited: visited ]].! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 11/20/2008 10:21'!
resolveClassProxy: aClassProxy
	| name newObject |
	name := aClassProxy name asSqueakObject.
	newObject := self specialObjects at: name ifAbsent: [
		self classNamed: name ifAbsent: [ self error: 'Could not resolve class proxy' ]].
	aClassProxy becomeForward: newObject copyHash: false.! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 11/18/2008 12:15'!
rootObjects
	^ self classes values, self metaclasses values, self specialObjects values, {self packageManager. self systemDictionary}
! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 11/18/2008 14:18'!
specialObjectAt: aSymbol
	| specialObject specialClass|
	^ specialObjects at: aSymbol ifAbsentPut: [
		specialClass := Smalltalk at: (self specialObjectClassAt: aSymbol).
		specialObject := specialClass new.
		specialClass allInstVarNames do: [ :name |
			(specialObject instVarNamed: name) ifNil: [
				specialObject instVarNamed: name put: (self specialObjectAt: #nil) ]]. specialObject ]! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 4/28/2008 23:36'!
specialObjectClassAt: aSymbol
	^ (self class specialObjects detect: [ :each | each key = aSymbol ]) value! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:06'!
specialObjects
	^ specialObjects! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:06'!
specialObjects: anObject
	specialObjects := anObject! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/18/2008 13:59'!
symbolAt: aSymbol
	^ symbols at: aSymbol ifAbsentPut: [ aSymbol asNXTObject ]! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 10/3/2008 12:51'!
systemDictionary
	^ self specialObjectAt: #Smalltalk! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 11/19/2008 10:11'!
unifyUniqueObject: oldValue
	oldValue isSymbol ifTrue: [ ^ self symbolAt: oldValue asSqueakObject ].
	oldValue class = NXTTrue ifTrue: [ ^ self specialObjectAt: #true ].
	oldValue class = NXTFalse ifTrue: [ ^ self specialObjectAt: #false ].
	oldValue isNil ifTrue: [ ^ self specialObjectAt: #nil ].
	^ oldValue! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 3/5/2009 20:00'!
unifyUniqueObjects
	| visited |
	visited := Set new.
	self rootObjects do: [ :object |
		self unifyUniqueObjectsRecursively: object visited: visited ].! !

!NXTImage methodsFor: 'image finalizing' stamp: 'mab 11/19/2008 10:12'!
unifyUniqueObjectsRecursively: object visited: visited
	object isNXTObject ifFalse: [ self error: 'NXTObject expected' ].
	(visited identityIncludes: object) ifFalse: [ 
		visited add: object.
		object referencesReplace: [ :oldValue | 
			self unifyUniqueObject: oldValue ].
		object referencesDo: [ :reference |
			self unifyUniqueObjectsRecursively: reference visited: visited ]].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 12/15/2008 09:00'!
writeHeaderTo: aByteStream
	aByteStream littleEndianWord: 16r4242.
	aByteStream littleEndianWord: self objectTable objects size.! !

!NXTImage methodsFor: 'private' stamp: 'mab 6/2/2008 18:04'!
writeImageToStream: aByteStream
	self writeHeaderTo: aByteStream.
	self writeSpecialObjectsTo: aByteStream.
	self writeObjectsTo: aByteStream.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 3/5/2009 20:41'!
writeObjectTableToStream: aByteStream
	self objectTable positions do: [ :each |
		aByteStream nextLittleEndianNumber: 4 put: each ].
	aByteStream flush.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 3/13/2009 11:10'!
writeObjectsTo: aByteStream
	self objectTable objects do: [ :each | 
		self objectTable update: each position: aByteStream position.
		each writeOn: aByteStream withImage: self.
		aByteStream position odd ifTrue: [ "padding"
			aByteStream nextPut: 0 ]] displayingProgress: 'Creating byte stream'.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 1/3/2009 11:12'!
writeSpecialObjectsTo: aByteStream
	(self specialObjects at: #startup) 
		writeAsReferenceOn: aByteStream 
		within: self.
	self class specialObjects do: [ :objectToClass |
		(self specialObjectAt: objectToClass key) 
			writeAsReferenceOn: aByteStream within: self ].
	(self specialObjects at: #doesNotUnderstand:) 
		writeAsReferenceOn: aByteStream 
		within: self.
	(self specialObjects at: #onNonLocalReturnsDo:)
		writeAsReferenceOn: aByteStream
		within: self.
	self class specialClasses do: [ :className |
		(self classes at: className)
			writeAsReferenceOn: aByteStream within: self ].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 3/13/2009 11:09'!
writeToStream: aByteStream 
	self writeImageToStream: aByteStream! !

Object subclass: #NXTImageBuilder
	instanceVariableNames: 'image packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageBuilder commentStamp: 'mab 3/13/2009 11:21' prior: 0!
My instance is used to build standard and specified images.

Instance Variables
	image:		<NXTImage>
	packages:		<OrderedCollection>

image
	- The image I'm building up

packages
	- The packages I'm supposed to include.
!

!NXTImageBuilder class methodsFor: 'standard images' stamp: 'mab 3/16/2009 10:17'!
standardPackages
	^ { NXTBaseLibrary. NXTStreamLibrary. NXTUsbManagerApp. NXTBluetoothTesterApp. } asOrderedCollection! !

!NXTImageBuilder methodsFor: 'building' stamp: 'mab 3/10/2009 17:50'!
createImageOn: aByteStream
	'Building image'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: self packages size + 2
		during: [ :bar |
			self packages
				doWithIndex: [ :package :index | 
					self image addPackage: (NXTPackageCompiler compilePackage: package new).
					bar value: index ].
			self image finalizeImage. bar value: self packages size + 1.
			self image writeToStream: aByteStream. bar value: self packages size + 2 ].

! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 3/10/2009 17:49'!
image
	^ image ifNil: [ image := NXTImage new ]! !

!NXTImageBuilder methodsFor: 'initializing' stamp: 'mab 3/10/2009 17:51'!
initialize
	packages := self class standardPackages.! !

!NXTImageBuilder methodsFor: 'packaging' stamp: 'mab 3/10/2009 17:45'!
packages
	^ packages! !

Object subclass: #NXTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTObject commentStamp: 'mab 2/23/2009 10:27' prior: 0!
I am the base class for every class whose instances should be deployable to the NXT brick. I provide a protocol similar to Object, but much smaller. You can use every method defined here on the NXT, but none of my superclasses, as they don't get compiled.

The category 'nxt-exclude' contains methods, which will be omitted by the compiler.

Instance Variables
!

NXTObject subclass: #NXSBoard
	instanceVariableNames: 'view width height board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSBoard class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:11'!
newWithWidth: width height: height numberOfApples: numberOfApples
    | newBoard |
    newBoard := self new.
    newBoard board: (NXTArray new: width).
    newBoard width: width.
    newBoard height: height.
		
    1 to: numberOfApples do: [
      newBoard addApple.
    ].
    ^newBoard! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 16:04'!
add: element
	(self board at: element x) isNil ifTrue: [
      self board at: element x put: (NXTArray new: height).
    ].
    (self board at: element x) at: element y put: element.
    view add: element! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
addApple
	| added x y newApple |
	added := false.
	[ added ] whileFalse: 
		[ x := width atRandom.
		y := height atRandom.
		(self board at: x) isNil ifTrue: 
			[ self board 
				at: x
				put: (NXTArray new: height) ].
		((self board at: x) at: y) isNil ifTrue: 
			[ newApple := NXSApple 
				newWithX: x
				Y: y.
			(self board at: x) 
				at: y
				put: newApple.
			added := true.
			view isNil ifFalse: [ view addApple: newApple ] ] ]! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
board
	^ board! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
board: anObject
	board := anObject! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
height
	^ height! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
height: anObject
	height := anObject! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:50'!
isAppleAtX: x Y: y
	((board at: x) isNil) ifFalse: [
      ((board at: x) at: y) isNil ifFalse: [
        ^((board at: x) at: y) isApple
      ]
    ].
    ^false! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:26'!
isSnakeAtX: x Y: y
    ((board at: x) isNil) ifFalse: [
      ((board at: x) at: y) isNil ifFalse: [
        ^((board at: x) at: y) isSnakeElement
      ]
    ].
    ^false! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:09'!
remove: element
	(self board at: element x) at: element y put: nil.
	self view remove: element.! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
view
	^ view! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:07'!
view: anObject
	view := anObject.
	anObject board: board.
	anObject updateCompletely.! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
width
	^ width! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
width: anObject
	width := anObject! !

NXTObject subclass: #NXSBoardView
	instanceVariableNames: 'width height board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSBoardView class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:18'!
new: board
    | newBoardView |
    newBoardView := self new.
    board view: newBoardView.
    newBoardView width: board width.
    newBoardView height: board height.
    ^newBoardView! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:45'!
add: snakeElement
    self display cursorToX: snakeElement x Y: snakeElement y.
    self display show: '#'.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:45'!
addApple: apple
    self display cursorToX: apple x Y: apple y.
    self display show: 'o'.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:14'!
board: value
	board := value.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:14'!
height: value
	height := value.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:45'!
remove: snakeElement
    self display cursorToX: snakeElement x Y: snakeElement y.
    self display show: ' '.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:45'!
updateCompletely
    board do: [ :y |
      y isNil ifFalse: [
        y do: [ :apple |
          apple isNil ifFalse: [
            self display cursorToX: apple x Y: apple y.
            self display show: 'o'
          ]
        ]
      ]
    ]! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:14'!
width: value
	width := value.! !

NXTObject subclass: #NXSElement
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

NXSElement subclass: #NXSApple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSApple methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:08'!
isApple
	^ true! !

!NXSElement class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:47'!
newWithX: x Y: y
	| newElement |
	newElement := self new.
	newElement x: x.
	newElement y: y.
	^ newElement! !

!NXSElement methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:08'!
isApple
	^ false! !

!NXSElement methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:26'!
isSnakeElement
	^ false! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
x
	^ x! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
x: anObject
	x := anObject! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
y
	^ y! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
y: anObject
	y := anObject! !

NXSElement subclass: #NXSnakeElement
	instanceVariableNames: 'next prev'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:27'!
isSnakeElement
	^ true! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
next
	^ next! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
next: anObject
	next := anObject! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
prev
	^ prev! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
prev: anObject
	prev := anObject! !

NXTObject subclass: #NXSnake
	instanceVariableNames: 'head tail board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSnake class methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:31'!
newWithX: x Y: y andBoard: board 
	| newSnake head |
	newSnake := NXSnake new.
	head := NXSnakeElement 
		newWithX: x
		Y: y.
	newSnake head: head.
	newSnake tail: head.
	newSnake board: board.
	board add: head.
	^ newSnake! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:23'!
board: value
	board := value.! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:23'!
head: value
	head := value.! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 16:00'!
move: newPos
    newPos next: head.
    head prev: newPos.
    head := newPos.

    (board isAppleAtX: newPos x Y: newPos y) ifTrue: [
      board addApple
    ] ifFalse: [

      (board isSnakeAtX: newPos x Y: newPos y) ifTrue: [
        ^false
      ].
      board remove: tail.
      tail := tail prev.
      tail next: nil.
    ].
    board add: newPos.

    ^true! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveDown
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos y: (self 
			overflow: newPos y + 1
			max: board height).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveLeft
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos x: (self 
			overflow: newPos x - 1
			max: board width).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveRight
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos x: (self 
			overflow: newPos x + 1
			max: board width).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveUp
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos y: (self 
			overflow: newPos y - 1
			max: board height).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:50'!
overflow: val max: max
    (val < 1) ifTrue: [ ^ max + val ].
    (val > max) ifTrue: [ ^ val - max ].
	^ val! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:52'!
run
	| aBoard view chr snake dir continue |
	self display scrolling: false.
	self display clear.
	dir := self buttons enter.
	aBoard := NXSBoard 
		newWithWidth: 16
		height: 8
		numberOfApples: 5.
	view := NXSBoardView new: aBoard.
	snake := NXSnake 
		newWithX: 5
		Y: 5
		andBoard: aBoard.
	continue := true.
	[ continue ] whileTrue: 
		[ chr := self buttons read.
		self buttons none ~= chr ifTrue: [ dir := chr ].
		NXTTimer sleepFor: 250.
		self buttons enter = dir ifTrue: [ continue := snake moveUp ].
		self buttons exit = dir ifTrue: [ continue := snake moveDown ].
		self buttons left = dir ifTrue: [ continue := snake moveLeft ].
		self buttons right = dir ifTrue: [ continue := snake moveRight ] ].
	self display clear.
	self display scrolling: true.
	self display show: 'GAME OVER'; cr.! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:23'!
tail: value
	tail := value.! !

NXTObject subclass: #NXTAnyButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTAnyButton methodsFor: 'testing' stamp: 'mab 9/19/2008 17:01'!
ifNotPressed: aBlock
	self isPressed ifFalse: [ ^ aBlock value ]! !

!NXTAnyButton methodsFor: 'testing' stamp: 'mab 9/19/2008 16:59'!
ifPressed: aBlock
	self isPressed ifTrue: [ ^ aBlock value ]! !

!NXTAnyButton methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:08'!
isPressed
	^ self class buttonRead ~= self class noneButton! !

!NXTAnyButton methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:06'!
wait
	self class waitForAnyKey.! !

NXTAnyButton subclass: #NXTButton
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:29'!
buttonRead
	<NXTPrimitive: 6>! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:10'!
enter
	^ self new number:1! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:11'!
exit
	^ self new number: 2! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:11'!
left
	^ self new number: 3! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:17'!
none
	^ self new number: 0! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:12'!
right
	^ self new number: 4! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 22:35'!
waitFor: aButtonNumber 
	Processor activeProcess waitFor: (NXTEventDescription button: aButtonNumber).
	^ aButtonNumber! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:21'!
waitForAnyKey
	[ self buttonRead = 0] whileTrue.
	^ self buttonRead! !

!NXTButton methodsFor: 'testing' stamp: 'mab 3/4/2009 19:21'!
isCancel
	^ self == self buttons exit! !

!NXTButton methodsFor: 'testing' stamp: 'mab 3/4/2009 19:21'!
isLeft
	^ self == self buttons left! !

!NXTButton methodsFor: 'testing' stamp: 'mab 3/4/2009 19:21'!
isOk
	^ self == self buttons enter! !

!NXTButton methodsFor: 'testing' stamp: 'mab 7/22/2008 18:36'!
isPressed
	^ self class buttonRead == self number! !

!NXTButton methodsFor: 'testing' stamp: 'mab 3/4/2009 19:21'!
isRight
	^ self == self buttons right! !

!NXTButton methodsFor: 'accessing' stamp: 'mab 7/22/2008 18:34'!
number
	^ number! !

!NXTButton methodsFor: 'accessing' stamp: 'mab 7/22/2008 18:34'!
number: anObject
	number := anObject! !

!NXTButton methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:27'!
onPressedDo: aBlock
	| ownerFrame ownerProcess |
	ownerFrame := thisContext sender.
	ownerProcess := Processor activeProcess.
	^ [ self wait.
		Processor withoutScheduling: [
			aBlock onNonLocalReturnsDo: [ :value | ownerProcess return: value from: ownerFrame. ownerProcess resume ]]] fork! !

!NXTButton methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:08'!
wait
	self class waitFor: self number! !

NXTObject subclass: #NXTBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBenchmark methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:58'!
run
	self display show: 'Running tiny benchmarks. Will take 5 minutes...'; cr.
	Processor withoutScheduling: [
		0 tinyBenchmarks ].! !

NXTObject subclass: #NXTBluetooth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:30'!
acceptConnection: aBoolean
	<NXTPrimitive: 72>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:31'!
connectionEstablished
	<NXTPrimitive: 73>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:33'!
dataRead
	<NXTPrimitive: 77>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:29'!
isConnectionPending
	<NXTPrimitive: 70>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 15:48'!
isDataWritten
	<NXTPrimitive: 79>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:32'!
isStreamOpen
	<NXTPrimitive: 75>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:29'!
isWaitingForPIN
	<NXTPrimitive: 69>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:31'!
openStream: handle
	<NXTPrimitive: 74>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 16:55'!
read
	"Read an NXTalk packet (needed due to performance issues, see documentation)"
	<NXTPrimitive: 80>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:32'!
readInto: aByteArray
	<NXTPrimitive: 76>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:30'!
sendPIN: aString
	<NXTPrimitive: 71>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 15:48'!
write: aByteArray
	<NXTPrimitive: 78>! !

NXTObject subclass: #NXTBluetoothTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBluetoothTester methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 13:32'!
run
	| handle |
	self display show: 'start'; cr.
	[ NXTButton buttonRead = 0 ] whileTrue: [
		NXTBluetooth isWaitingForPIN ifTrue: [
			self display show: 'pin'.
			NXTBluetooth sendPIN: 'martin' ].
		(NXTBluetooth isConnectionPending) ifTrue: [
			self display show: 'conpen'.
			"[ NXTBluetooth isConnectionPending ] whileFalse."
			NXTBluetooth acceptConnection: true.
			[ (handle := NXTBluetooth connectionEstablished) isNil ] whileTrue.
			self display show: 'accept'.
			NXTBluetooth openStream: handle.
			[ NXTBluetooth isStreamOpen ] whileFalse.
			handle := NXTDataStream on: NXTBluetoothStream new.
			(NXTDispatcher for: Smalltalk packageManager on: handle) receive ]].! !

NXTObject subclass: #NXTBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBoolean commentStamp: 'mab 12/19/2008 19:15' prior: 0!
I am a base class for the two boolean classes of NXTalk. I implement shared behavior and define the available protocol.

Instance Variables
!

!NXTBoolean methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:14'!
ifFalse: falseBlock ifTrue: trueBlock
	"If the receiver is true (i.e., the condition is true), then answer the value 
	of the argument trueAlternativeBlock. If the receiver is false, answer the 
	result of evaluating the argument falseAlternativeBlock. If the receiver 
	is a nonBoolean then create an error notification. Execution does not 
	actually reach here because the expression is compiled in-line."
	^ self ifTrue: trueBlock ifFalse: falseBlock! !

NXTBoolean subclass: #NXTFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTFalse commentStamp: 'mab 12/28/2008 17:27' prior: 0!
My sole instance 'false' represents the global value for the boolean false.

Instance Variables
!

!NXTFalse methodsFor: 'logical operations' stamp: 'mab 3/4/2009 16:20'!
& aBoolean
	"Evaluating conjunction -- answer false since receiver is false."
	^ self! !

!NXTFalse methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:21'!
and: otherBlock
	"Nonevaluating conjunction -- answer with false since the receiver is false."
	^ false! !

!NXTFalse methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:21'!
ifFalse: aBlock
	"Answer the value of alternativeBlock."
	^ aBlock value! !

!NXTFalse methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:21'!
ifTrue: aBlock
	"Since the condition is false, answer the value of the false alternative, 
	which is nil."
	^ nil! !

!NXTFalse methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:22'!
ifTrue: trueBlock ifFalse: falseBlock
	"Answer the value of falseAlternativeBlock."
	^ falseBlock value! !

!NXTFalse methodsFor: 'logical operations' stamp: 'mab 3/4/2009 16:20'!
not
	"Negation -- answer true since the receiver is false."
	^ true! !

!NXTFalse methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:22'!
or: alternativeBlock
	"Nonevaluating disjunction -- answer value of alternativeBlock."
	^ alternativeBlock value! !

NXTBoolean subclass: #NXTTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTTrue methodsFor: 'logical operations' stamp: 'mab 5/7/2008 17:29'!
& aBoolean
	^ aBoolean! !

!NXTTrue methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:22'!
and: otherBlock
	"Nonevaluating conjunction -- answer the value of alternativeBlock since
	the receiver is true."
	^ otherBlock value! !

!NXTTrue methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:23'!
ifFalse: aBlock
	"Since the condition is true, the value is the true alternative, which is nil."
	^ nil! !

!NXTTrue methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:25'!
ifTrue: aBlock
	"Answer the value of trueAlternativeBlock."
	^ aBlock value! !

!NXTTrue methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:25'!
ifTrue: trueBlock ifFalse: falseBlock
	"Answer with the value of trueAlternativeBlock."
	^ trueBlock value! !

!NXTTrue methodsFor: 'logical operations' stamp: 'mab 5/7/2008 17:28'!
not
	^ false! !

!NXTTrue methodsFor: 'controlling' stamp: 'mab 3/4/2009 16:25'!
or: alternativeBlock
	"Nonevaluating disjunction -- answer true since the receiver is true."
	^ self! !

NXTObject subclass: #NXTButtonContainer
	instanceVariableNames: 'left right enter exit any none'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:05'!
any
	^ any! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:26'!
enter
	^ enter! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:26'!
exit
	^ exit! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:17'!
initialize
	enter := NXTButton enter.
	exit := NXTButton exit.
	left := NXTButton left.
	right := NXTButton right.
	none := NXTButton none.
	any := NXTAnyButton new.! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:27'!
left
	^ left! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:17'!
none
	^ none! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:31'!
read
	| key |
	key := NXTButton buttonRead.
	key = self enter number ifTrue: [ ^ self enter ].
	key = self exit number ifTrue: [ ^ self exit ].
	key = self left number ifTrue: [ ^ self left ].
	key = self right number ifTrue: [ ^ self right ].
	^ self none! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:27'!
right
	^ right! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:21'!
waitForAny
	| key |
	key := NXTButton waitForAnyKey.
	NXTTimer waitFor: 1.
	key = self enter number ifTrue: [ ^ self enter ].
	key = self exit number ifTrue: [ ^ self exit ].
	key = self left number ifTrue: [ ^ self left ].
	key = self right number ifTrue: [ ^ self right ].
	self error: 'Unknown key!!'.! !

NXTObject subclass: #NXTClass
	instanceVariableNames: 'methodDictionary superclass name format instVarNames classPool subclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTClass commentStamp: 'mab 12/19/2008 19:01' prior: 0!
A NXTClass is the description of a class on the NXT.

Instance Variables
	classPool:		<NXTDictionary>
	format:		<NXTSmallInteger>
	instVarNames:		<NXTArray>
	methodDictionary:		<NXTDictionary>
	name:		<NXTString>
	subclasses:		<NXTArray>
	superclass:		<NXTClass>

classPool
	- A dictionary mapping from class variable names to their values.

format
	- Contains bit-encoded information about the instances. For instance, whether they are indexed or normal objects. See the method implementations for more details.

instVarNames
	- An array containing the names of the instance variables in their defined order.

methodDictionary
	- A dictionary mapping from method names to their implementations.

name
	- The name of the described class.

subclasses
	- An array of subclasses.

superclass
	- The superclass of this class.
!

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 7/14/2008 15:57'!
allInstances 
	"Answer a collection of all current instances of the receiver."

	| all |
	all := NXTOrderedCollection new.
	self allInstancesDo: [:x | x == all ifFalse: [all add: x]].
	^ all asArray
! !

!NXTClass methodsFor: 'enumerating' stamp: 'mab 7/14/2008 16:11'!
allInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver.
	
	Because aBlock might change the class of inst (for example, using become:),
	it is essential to compute next before aBlock value: inst."
	| inst next |
	self ==  NXTUndefinedObject ifTrue: [^ aBlock value: nil].
	inst := self firstInstance.
	[ inst == nil ] whileFalse: [
		next := inst nextInstance.
		aBlock value: inst.
		inst := next]! !

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 7/24/2008 16:48'!
allSubInstances 
	"Answer a list of all current instances of the receiver and all of its subclasses."
	| aCollection |
	aCollection := NXTOrderedCollection new.
	self allSubInstancesDo:
		[:x | x == aCollection ifFalse: [aCollection add: x]].
	^ aCollection! !

!NXTClass methodsFor: 'enumerating' stamp: 'mab 7/24/2008 16:48'!
allSubInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver and all its subclasses."

	self allInstancesDo: aBlock.
	self allSubclassesDo: [:sub | sub allInstancesDo: aBlock]! !

!NXTClass methodsFor: 'accessing class hierarchy' stamp: 'mab 8/12/2008 17:58'!
allSubclasses
	| classes |
	classes := NXTOrderedCollection new.
	self allSubclassesDo: [ :class |
		classes add: class ].
	^ classes! !

!NXTClass methodsFor: 'enumerating' stamp: 'mab 2/19/2009 16:01'!
allSubclassesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's subclasses."
	self subclassesDo: 
		[:cl | 
		aBlock value: cl.
		cl allSubclassesDo: aBlock]! !

!NXTClass methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 14:10'!
asSqueakObject
	^ Smalltalk at: self name asSqueakObject! !

!NXTClass methodsFor: 'instance creation' stamp: 'mab 5/29/2008 15:55'!
basicNew
	<NXTPrimitive: 15>! !

!NXTClass methodsFor: 'instance creation' stamp: 'mab 5/29/2008 16:56'!
basicNew: sizeRequested
	<NXTPrimitive: 16>! !

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 11/19/2008 10:44'!
classPool
	^ classPool ifNil: [ NXTDictionary new ]! !

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 10/8/2008 21:13'!
classPool: value
	classPool := value! !

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 11/19/2008 16:19'!
classPoolAt: classVar
	^ self classPool at: classVar ifAbsent: [ 
		self superclass ifNil: [ self error: 'Not in class pool' ].
		^ self superclass classPoolAt: classVar ]! !

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 11/19/2008 16:37'!
classPoolAt: classVar put: value
	self classPool at: classVar ifAbsent: [ 
		self superclass ifNil: [ self error: 'Not in class pool' ].
		^ self superclass classPoolAt: classVar put: value ].
	^ self classPool at: classVar put: value.! !

!NXTClass methodsFor: 'naming' stamp: 'mab 9/19/2008 16:40'!
environment
	^ Smalltalk! !

!NXTClass methodsFor: 'accessing instances and variables' stamp: 'mab 7/14/2008 16:12'!
firstInstance
	<NXTPrimitive: 28>! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/5/2008 17:06'!
format
	^ format! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/5/2008 17:06'!
format: anObject
	format := anObject! !

!NXTClass methodsFor: 'testing class hierarchy' stamp: 'mab 8/19/2008 14:23'!
inheritsFrom: aClass 
	"Answer whether the argument, aClass, is on the receiver's superclass 
	chain."

	| aSuperclass |
	aSuperclass := superclass.
	[aSuperclass == nil]
		whileFalse: 
			[aSuperclass == aClass ifTrue: [^true].
			aSuperclass := aSuperclass superclass].
	^false! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:48'!
instSize
	^ format >> 2! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:47'!
instVarNames
	^ instVarNames! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:47'!
instVarNames: anObject
	instVarNames := anObject! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/22/2008 16:35'!
isClass
	^ true! !

!NXTClass methodsFor: 'testing' stamp: 'mab 11/17/2008 14:07'!
isClassProxy
	^ false! !

!NXTClass methodsFor: 'testing' stamp: 'mab 11/16/2008 16:47'!
isMeta
	^ false! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 11/14/2008 19:12'!
isVariable
	^ ((self format >> 7) bitAnd: 1) = 1! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:46'!
methodDictionary
	^ methodDictionary! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:46'!
methodDictionary: anObject
	methodDictionary := anObject! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/29/2008 16:06'!
name
	^ name! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/29/2008 16:06'!
name: aSymbol
	^ name := aSymbol! !

!NXTClass methodsFor: 'instance creation' stamp: 'mab 5/29/2008 15:56'!
new
	^ self basicNew initialize! !

!NXTClass methodsFor: 'instance creation' stamp: 'mab 5/29/2008 16:48'!
new: sizeRequested 
	^ (self basicNew: sizeRequested) initialize  ! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 11/16/2008 14:52'!
selectors
	| c |
	c := NXTOrderedCollection new.
	self methodDictionary pairsDo: [ :selector :method |
		c add: selector ].
	^ c! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 7/25/2008 14:31'!
subclasses
	^ subclasses! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 7/25/2008 14:23'!
subclasses: array
	subclasses := array! !

!NXTClass methodsFor: 'enumerating' stamp: 'mab 7/24/2008 16:50'!
subclassesDo: aBlock
	"Evaluate the argument, aBlock, for each of the receiver's immediate subclasses."
	^self subclasses do: aBlock! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:45'!
superclass
	^ superclass! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:45'!
superclass: anObject
	superclass := anObject! !

!NXTClass methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 14:47'!
writeDataOn: aByteStream withImage: image
	 | class instanceVariable |
	super writeDataOn: aByteStream withImage: image.
	self isMeta ifFalse: [
		"Write metaclass' instance variables"
		class := (Smalltalk at: self name asSqueakObject).
		class class instVarNames do: [ :instVarName |
			instanceVariable :=  class instVarNamed: instVarName asSymbol.
			"instanceVariable ifNil: [" instanceVariable := image specialObjectAt: #nil "]".
			instanceVariable asNXTObject writeAsReferenceOn: aByteStream within: image ]].! !

NXTClass subclass: #NXTMetaclass
	instanceVariableNames: 'thisClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMetaclass commentStamp: 'mab 3/7/2009 22:12' prior: 0!
My instances are the classes of the real classes. See the Smalltalk-80 class model.

Instance Variables
	thisClass:		<Class>

thisClass
	- The class I am the metaclass to
!

!NXTMetaclass methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 14:09'!
asSqueakObject
	^ (Smalltalk at: (name asSqueakObject allButLast: 6) asSymbol) class! !

!NXTMetaclass methodsFor: 'accessing instances and variables' stamp: 'mab 10/9/2008 09:50'!
classPool
	^ thisClass classPool! !

!NXTMetaclass methodsFor: 'testing' stamp: 'mab 10/9/2008 09:50'!
isMeta
	^ true! !

!NXTMetaclass methodsFor: 'accessing' stamp: 'mab 11/17/2008 17:17'!
thisClass
	^ thisClass! !

!NXTMetaclass methodsFor: 'accessing' stamp: 'mab 10/28/2008 15:35'!
thisClass: class
	thisClass := class.! !

NXTObject subclass: #NXTClassProxy
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTClassProxy commentStamp: 'mab 3/16/2009 04:00' prior: 0!
I am used to represent a (hopefully) already existing and thus not fully included class in an NXTDataStream. This means, that I only have the name of the class, and upon deserialization, I am replaced with a reference to the real class.

Instance Variables
	name:		<NXTSymbol>

name
	- Name of the class my instance represents.
!

!NXTClassProxy class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
for: aName
	^ self new name: aName! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 14:06'!
isClassProxy
	^ true! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
name
	^ name! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
name: anObject
	name := anObject! !

NXTObject subclass: #NXTCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTCollection commentStamp: 'mab 3/13/2009 11:37' prior: 0!
I am the abstract superclass of all classes that represent a group of elements in NXTalk.

Instance Variables
!

!NXTCollection class methodsFor: 'instance creation' stamp: 'mab 8/19/2008 14:37'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size)
		addAll: aCollection;
		yourself! !

!NXTCollection methodsFor: 'adding' stamp: 'mab 9/25/2008 19:58'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 8/13/2008 14:06'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!NXTCollection methodsFor: 'converting' stamp: 'mab 8/19/2008 17:06'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := NXTArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!NXTCollection methodsFor: 'converting' stamp: 'mab 8/19/2008 14:26'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ NXTSet withAll: self! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 8/12/2008 18:01'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 3/5/2009 17:58'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 3/5/2009 17:58'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 8/19/2008 13:57'!
doWithIndex: binaryBlock
	| index |
	index := 0.
	self do: [:elt | binaryBlock value: elt value: (index := index + 1)].! !

!NXTCollection methodsFor: 'private' stamp: 'mab 9/15/2008 18:13'!
emptyCheck

	self isEmpty ifTrue: [self errorEmptyCollection]! !

!NXTCollection methodsFor: 'private' stamp: 'mab 9/15/2008 18:13'!
errorEmptyCollection

	self error: 'this collection is empty'! !

!NXTCollection methodsFor: 'private' stamp: 'mab 9/16/2008 10:06'!
errorNotFound: anObject
	"Actually, this should raise a special Exception not just an error."

	self error: 'Object is not in the collection.'! !

!NXTCollection methodsFor: 'testing' stamp: 'mab 8/13/2008 14:06'!
includes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	^ self anySatisfy: [:each | each = anObject]! !

!NXTCollection methodsFor: 'testing' stamp: 'mab 7/25/2008 19:35'!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 7/25/2008 14:35'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!NXTCollection methodsFor: 'removing' stamp: 'mab 9/16/2008 10:05'!
remove: oldObject 
	"Remove oldObject from the receiver's elements. Answer oldObject 
	unless no element is equal to oldObject, in which case, raise an error.
	ArrayedCollections cannot respond to this message."

	^ self remove: oldObject ifAbsent: [self errorNotFound: oldObject]! !

!NXTCollection methodsFor: 'enumerating' stamp: 'mab 6/9/2008 15:09'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [ newCollection add: each]].
	^newCollection! !

NXTCollection subclass: #NXTSequenceableCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSequenceableCollection commentStamp: 'mab 3/13/2009 11:50' prior: 0!
I am an abstract superclass for collections in NXTalk that have a well-defined order associated with their elements. Thus each element is externally-named by integers referred to as indices.!

NXTSequenceableCollection variableSubclass: #NXTArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTArray commentStamp: 'mab 3/16/2009 02:39' prior: 0!
I present a NXTSequencableCollection whose elements are objects.!

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!NXTArray class methodsFor: 'instance creation' stamp: 'mab 7/14/2008 19:24'!
with: anObject 
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 1.
	newCollection at: 1 put: anObject.
	^newCollection! !

!NXTArray class methodsFor: 'instance creation' stamp: 'mab 7/21/2008 14:48'!
with: anObject1 with: anObject2
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 2.
	newCollection at: 1 put: anObject1.
	newCollection at: 2 put: anObject2.
	^newCollection! !

!NXTArray class methodsFor: 'instance creation' stamp: 'mab 7/22/2008 18:09'!
with: anObject1 with: anObject2 with: anObject3
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 3.
	newCollection at: 1 put: anObject1.
	newCollection at: 2 put: anObject2.
	newCollection at: 3 put: anObject3.
	^newCollection! !

!NXTArray methodsFor: 'converting' stamp: 'mab 7/25/2008 14:37'!
asOrderedCollection
	^ NXTOrderedCollection withAll: self! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 5/29/2008 11:46'!
computeSize
	^ self size! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 11/17/2008 18:52'!
referencesDo: aBlock
	self do: aBlock! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 10:07'!
referencesReplace: aBlock
	1 to: self size do: [ :index |
		self at: index put: (aBlock value: (self at: index)) ].! !

!NXTArray methodsFor: 'accessing' stamp: 'mab 6/2/2008 14:58'!
size
	<NXTPrimitive: 17>
	^ super size! !

NXTArray weakSubclass: #NXTWeakArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTWeakArray commentStamp: 'mab 3/16/2009 03:20' prior: 0!
NXTWeakArray is an array which holds only weakly on its elements. This means whenever an object is only referenced by instances of NXTWeakArray it will be garbage collected. The reference in the NXTWeakArray in turn, will be automatically set to nil.!

NXTSequenceableCollection subclass: #NXTLinkedList
	instanceVariableNames: 'firstLink lastLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTLinkedList commentStamp: 'mab 3/16/2009 02:45' prior: 0!
I represent a collection of links, which are containers for other objects. Using the message sequence addFirst:/removeLast causes the receiver to behave as a stack; using addLast:/removeFirst causes the receiver to behave as a queue.

Instance Variables
	firstLink:		<NXTLink>
	lastLink:		<NXTLink>

firstLink
	- The first object in the list.

lastLink
	- The last object in the list.
!

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
add: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	^self addLast: aLink! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
add: link after: otherLink

	"Add otherLink  after link in the list. Answer aLink."

	| savedLink |

	savedLink := otherLink nextLink.
	otherLink nextLink: link.
	link nextLink:  savedLink.
	^link.! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
add: link before: otherLink

	| aLink |
	firstLink == otherLink ifTrue: [^ self addFirst: link].
	aLink := firstLink.
	[aLink == nil] whileFalse: [
		aLink nextLink == otherLink ifTrue: [
			link nextLink: aLink nextLink.
			aLink nextLink: link.
			^ link
		].
		 aLink := aLink nextLink.
	].
	^ self errorNotFound: otherLink! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
addFirst: aLink 
	"Add aLink to the beginning of the receiver's list. Answer aLink."

	self isEmpty ifTrue: [lastLink := aLink].
	aLink nextLink: firstLink.
	firstLink := aLink.
	^aLink! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
addLast: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	self isEmpty
		ifTrue: [firstLink := aLink]
		ifFalse: [lastLink nextLink: aLink].
	lastLink := aLink.
	^aLink! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 16:51'!
at: index

	| i |
	i := 0.
	self do: [:link |
		(i := i + 1) = index ifTrue: [^ link]].
	^ self errorSubscriptBounds: index! !

!NXTLinkedList methodsFor: 'enumerating' stamp: 'mab 11/18/2008 13:40'!
do: aBlock

	| aLink |
	aLink := firstLink.
	[aLink isNil] whileFalse:
		[aBlock value: aLink.
		 aLink := aLink nextLink]! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 16:51'!
first
	"Answer the first link. Create an error notification if the receiver is 
	empty."

	self emptyCheck.
	^firstLink! !

!NXTLinkedList methodsFor: 'testing' stamp: 'mab 9/15/2008 16:51'!
isEmpty

	^firstLink == nil! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 16:51'!
last
	"Answer the last link. Create an error notification if the receiver is 
	empty."

	self emptyCheck.
	^lastLink! !

!NXTLinkedList methodsFor: 'removing' stamp: 'mab 9/15/2008 16:51'!
remove: aLink ifAbsent: aBlock  
	"Remove aLink from the receiver. If it is not there, answer the result of
	evaluating aBlock."

	| tempLink |
	aLink == firstLink
		ifTrue: [firstLink := aLink nextLink.
				aLink == lastLink
					ifTrue: [lastLink := nil]]
		ifFalse: [tempLink := firstLink.
				[tempLink == nil ifTrue: [^aBlock value].
				 tempLink nextLink == aLink]
					whileFalse: [tempLink := tempLink nextLink].
				tempLink nextLink: aLink nextLink.
				aLink == lastLink
					ifTrue: [lastLink := tempLink]].
	aLink nextLink: nil.
	^aLink! !

!NXTLinkedList methodsFor: 'removing' stamp: 'mab 9/15/2008 16:51'!
removeFirst
	"Remove the first element and answer it. If the receiver is empty, create 
	an error notification."

	| oldLink |
	self emptyCheck.
	oldLink := firstLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [firstLink := oldLink nextLink].
	oldLink nextLink: nil.
	^oldLink! !

!NXTLinkedList methodsFor: 'removing' stamp: 'mab 9/15/2008 16:51'!
removeLast
	"Remove the receiver's last element and answer it. If the receiver is 
	empty, create an error notification."

	| oldLink aLink |
	self emptyCheck.
	oldLink := lastLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [aLink := firstLink.
				[aLink nextLink == oldLink] whileFalse:
					[aLink := aLink nextLink].
				 aLink nextLink: nil.
				 lastLink := aLink].
	oldLink nextLink: nil.
	^oldLink! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 18:01'!
size
	"Answer how many elements the receiver contains."

	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^ tally! !

!NXTLinkedList methodsFor: 'enumerating' stamp: 'mab 9/15/2008 16:53'!
species

	^ NXTArray! !

NXTLinkedList subclass: #NXTProcessorScheduler
	instanceVariableNames: 'activeProcess waitingProcesses schedulerProcess initialized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProcessorScheduler commentStamp: 'mab 3/12/2009 16:32' prior: 0!
My sole instance is the scheduler for the NXTalk system.

Instance Variables
	activeProcess:		<NXTProcess>
	schedulerProcess:		<NXTProcess>
	waitingProcesses:		<NXTProcess>

activeProcess
	- The currently interpreted process.

schedulerProcess
	- The process in which the scheduler is running.

waitingProcesses
	- A linked list of blocked processes, waiting for external events.

initialized
	- Indicates, whether this image already has been initialized (and stored afterwards).!

!NXTProcessorScheduler methodsFor: 'comparing' stamp: 'mab 11/18/2008 11:41'!
= anObject
	^ self == anObject! !

!NXTProcessorScheduler methodsFor: 'accessing' stamp: 'mab 9/3/2008 16:08'!
activeProcess
	^ activeProcess! !

!NXTProcessorScheduler methodsFor: 'waiting processes' stamp: 'mab 1/3/2009 09:39'!
addWaitingProcess: aProcess
	self withoutScheduling: [
		self remove: aProcess.
		aProcess nextLink: self waitingProcesses.
		self waitingProcesses: aProcess.
		self activeProcess = aProcess ifTrue: [ self yield ]].
	^ aProcess! !

!NXTProcessorScheduler methodsFor: 'waiting processes' stamp: 'mab 12/31/2008 14:17'!
checkWaitingProcesses
	<NXTPrimitive: 66>! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 2/13/2009 13:39'!
findNextRunnable
	[ self isEmpty or: [ self first isRunnable ]] whileFalse: [ self removeFirst ].
	self isEmpty ifTrue: [ ^ nil ].
	^ self addLast: self removeFirst
! !

!NXTProcessorScheduler methodsFor: 'comparing' stamp: 'mab 11/18/2008 11:41'!
hash
	^ self identityHash! !

!NXTProcessorScheduler methodsFor: 'startup' stamp: 'mab 3/12/2009 16:28'!
initializeClasses
	self display show: 'Initializing classes...'.
	Smalltalk valuesDo: [ :class | class initialize ].! !

!NXTProcessorScheduler methodsFor: 'waiting processes' stamp: 'mab 1/3/2009 11:59'!
removeWaitingProcess: process ifAbsent: aBlock
	| last current |
	last := nil.
	current := self waitingProcesses.
	[ current isNil ] whileFalse: [
		current == process ifTrue: [
			last 
				ifNil: [ self waitingProcesses: current nextLink ]
				ifNotNil: [ last nextLink: current nextLink ].
			current nextLink: nil.
			^ process ].
		last := current.
		current := current nextLink ].
	^ aBlock value
	! !

!NXTProcessorScheduler methodsFor: 'controlling' stamp: 'mab 1/4/2009 13:28'!
resumeProcess: aProcess
	self withoutScheduling: [
		(self includes: aProcess) ifFalse: [ self addLast: aProcess ].
		self removeWaitingProcess: aProcess ifAbsent: []].
	^ aProcess! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 12/31/2008 13:41'!
schedule
	self scheduleTo: (self findNextRunnable ifNil: [ ^ false ]).
	^ true! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 12/31/2008 14:17'!
scheduleLoop
	[ self checkWaitingProcesses.
	self schedule or: [ self waitingProcesses isNil not ]] whileTrue.! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 9/12/2008 17:54'!
scheduleTo: process
	<NXTPrimitive: 47>! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 9/15/2008 16:25'!
schedulingEnabled: aBoolean
	<NXTPrimitive: 48>! !

!NXTProcessorScheduler methodsFor: 'startup' stamp: 'mab 3/12/2009 16:27'!
startup
	initialized ifNil: [ self initializeClasses. initialized := true ].
	[ NXTSystem new run ] fork.
	self scheduleLoop.! !

!NXTProcessorScheduler methodsFor: 'controlling' stamp: 'mab 1/4/2009 13:26'!
suspendProcess: aProcess
	self withoutScheduling: [
		self remove: aProcess.
		self activeProcess = aProcess ifTrue: [ self yield ]].
	^ aProcess! !

!NXTProcessorScheduler methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:52'!
waitingProcesses
	^ waitingProcesses! !

!NXTProcessorScheduler methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:52'!
waitingProcesses: anObject
	waitingProcesses := anObject! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 9/16/2008 09:28'!
withoutScheduling: aBlock
	self schedulingEnabled: false.
	aBlock value.
	self schedulingEnabled: true.! !

!NXTProcessorScheduler methodsFor: 'scheduling' stamp: 'mab 12/30/2008 13:10'!
yield
	<NXTPrimitive: 65>! !

NXTLinkedList subclass: #NXTSemaphore
	instanceVariableNames: 'excessSignals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSemaphore commentStamp: 'mab 3/12/2009 16:47' prior: 0!
My instances are for managing access from multiple processes. I may block the calling, ressource-requesting process, if my signals are excessed.

Instance Variables
	excessSignals:		<NXTSmallInteger>

excessSignals
	- How many signals are left.
!

!NXTSemaphore class methodsFor: 'instance creation' stamp: 'mab 9/16/2008 09:37'!
forMutualExclusion
	"Answer an instance of me that contains a single signal. This new 
	instance can now be used for mutual exclusion (see the critical: message 
	to Semaphore)."

	^self new signal! !

!NXTSemaphore methodsFor: 'mutual exclusion' stamp: 'mab 9/16/2008 09:34'!
critical: aBlock
	| blockValue |
	self wait.
	blockValue := aBlock value.
	self signal.
	^ blockValue! !

!NXTSemaphore methodsFor: 'initialize-release' stamp: 'mab 9/16/2008 09:36'!
initSignals
	"Consume any excess signals the receiver may have accumulated."

	excessSignals := 0.! !

!NXTSemaphore methodsFor: 'initialize-release' stamp: 'mab 9/16/2008 09:40'!
initialize
	self initSignals! !

!NXTSemaphore methodsFor: 'testing' stamp: 'mab 9/16/2008 09:33'!
isSignaled
	"Return true if this semaphore is currently signaled"
	^excessSignals > 0! !

!NXTSemaphore methodsFor: 'communication' stamp: 'mab 9/16/2008 09:28'!
signal
	Processor withoutScheduling: [
		self isEmpty
			ifTrue: [ excessSignals := excessSignals + 1 ]
			ifFalse: [ self removeFirst resume ]].! !

!NXTSemaphore methodsFor: 'communication' stamp: 'mab 9/16/2008 09:47'!
wait
	Processor withoutScheduling: [
		excessSignals > 0
			ifTrue: [ excessSignals := excessSignals - 1 ]
			ifFalse: [ (self addLast: Processor activeProcess) suspend ]].! !

NXTSequenceableCollection subclass: #NXTOrderedCollection
	instanceVariableNames: 'array firstIndex lastIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTOrderedCollection commentStamp: 'mab 3/16/2009 02:51' prior: 0!
I represent a collection of objects ordered by the collector.

Instance Variables
	array:		<NXTArray>
	firstIndex:		<NXTInteger>
	lastIndex:		<NXTInteger>

array
	- My internal array of elements

firstIndex
	- The first index, where the real elements start.

lastIndex
	- The index of the last element in my collection. This may be wrapped through the end of my internal array.
!

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 5/29/2008 15:59'!
new
	^ self new: 10! !

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 5/29/2008 16:00'!
new: anInteger 
	^ self basicNew setCollection: (NXTArray new: anInteger)! !

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 7/25/2008 15:17'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) addAll: aCollection! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 6/9/2008 15:30'!
add: newObject
	^self addLast: newObject! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 10/3/2008 22:39'!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!NXTOrderedCollection methodsFor: 'accessing' stamp: 'mab 7/25/2008 15:46'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"
	
	(anInteger < 1 or: [anInteger + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^ array at: anInteger + firstIndex - 1]! !

!NXTOrderedCollection methodsFor: 'accessing' stamp: 'mab 7/25/2008 15:36'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	| index |
	index := anInteger asInteger.
	(index < 1 or: [index + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: index + firstIndex - 1 put: anObject]! !

!NXTOrderedCollection methodsFor: 'enumerating' stamp: 'mab 8/15/2008 10:02'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 8/20/2008 16:10'!
errorNoSuchElement
	self error: 'attempt to index non-existent element in an ordered collection'! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 16:00'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray := NXTArray new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
growSize
	^ array size max: 2! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 10/3/2008 22:39'!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!NXTOrderedCollection methodsFor: 'removing' stamp: 'mab 3/5/2009 18:04'!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject = (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!NXTOrderedCollection methodsFor: 'removing' stamp: 'mab 3/5/2009 18:04'!
removeAt: index
	| removed |
	removed := self at: index.
	self removeIndex: index + firstIndex - 1.
	^removed! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 3/5/2009 18:04'!
removeIndex: removedIndex
  "  removedIndex is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection.
    Never use this method in your code, it is meant for private use by OrderedCollection only.
     The method for public use is:
        #removeAt: "

	array 
		replaceFrom: removedIndex 
		to: lastIndex - 1 
		with: array 
		startingAt: removedIndex+1.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 5/29/2008 15:53'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 5/29/2008 15:53'!
setCollection: anArray
	array := anArray.
	self reset! !

!NXTOrderedCollection methodsFor: 'accessing' stamp: 'mab 6/6/2008 15:52'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!NXTSequenceableCollection class methodsFor: 'instance creation' stamp: 'mab 7/25/2008 14:39'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) replaceFrom: 1 to: aCollection size with: aCollection! !

!NXTSequenceableCollection methodsFor: 'copying' stamp: 'mab 11/14/2008 17:47'!
, other
	| oldSize newSize c |
	newSize := self size + other size.
	c := self species new: newSize.
	1 to: self size do: [ :index | c at: index put: (self at: index) ].
	oldSize := self size.
	1 to: other size do: [ :index | c at: index + oldSize put: (other at: index) ].
	^ c
	! !

!NXTSequenceableCollection methodsFor: 'comparing' stamp: 'mab 6/6/2008 16:30'!
= otherCollection 
	"Answer true if the receiver is equivalent to the otherCollection.
	First test for identity, then rule out different species and sizes of
	collections. As a last resort, examine each element of the receiver
	and the otherCollection."

	self == otherCollection ifTrue: [^ true].
	self species == otherCollection species ifFalse: [^ false].
	^ self hasEqualElements: otherCollection! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 7/15/2008 14:56'!
allButFirst: n
	"Answer a copy of the receiver containing all but the first n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: n + 1 to: self size! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 11/20/2008 15:28'!
allButLast: n
	"Answer a copy of the receiver containing all but the last n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: self size - n! !

!NXTSequenceableCollection methodsFor: 'converting' stamp: 'mab 7/24/2008 16:59'!
asArray
	"Answer an Array whose elements are the elements of the receiver."

	^ NXTArray withAll: self! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 9/8/2008 15:42'!
atAllPut: anObject 
	"Put anObject at every one of the receiver's indices."

	| size |
	(size := self size) > 26 "first method faster from 27 accesses and on"
		ifTrue: [self from: 1 to: size put: anObject]
		ifFalse: [1 to: size do: [:index | self at: index put: anObject]]! !

!NXTSequenceableCollection methodsFor: 'testing' stamp: 'mab 7/25/2008 19:33'!
beginsWith: aSequenceableCollection

	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	aSequenceableCollection withIndexDo: [:each :index | (self at: index) ~= each ifTrue: [^false]].
	^true! !

!NXTSequenceableCollection methodsFor: 'enumerating' stamp: 'mab 8/12/2008 18:41'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!NXTSequenceableCollection methodsFor: 'copying' stamp: 'mab 6/6/2008 16:14'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!NXTSequenceableCollection methodsFor: 'enumerating' stamp: 'mab 6/5/2008 14:36'!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!NXTSequenceableCollection methodsFor: 'enumerating' stamp: 'mab 8/15/2008 17:43'!
doWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexDo: elementAndIndexBlock! !

!NXTSequenceableCollection methodsFor: 'testing' stamp: 'mab 11/15/2008 17:22'!
endsWith: aSequenceableCollection

	| start |
	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	start := self size - aSequenceableCollection size.
	aSequenceableCollection withIndexDo: [:each :index | (self at: start + index) ~= each ifTrue: [^false]].
	^true! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 7/25/2008 15:21'!
first
	^ self at: 1! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 6/6/2008 16:14'!
first: n
	"Answer the first n elements of the receiver.
	Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: n! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 9/8/2008 15:45'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. Answer anObject"

	| written toWrite thisWrite |

	startIndex > endIndex ifTrue: [^self].
	self at: startIndex put: anObject.
	written := 1.
	toWrite := endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[
			thisWrite := written min: toWrite - written.
			self 
				replaceFrom: startIndex + written
				to: startIndex + written + thisWrite - 1
				with: self startingAt: startIndex.
			written := written + thisWrite
		].
	^anObject! !

!NXTSequenceableCollection methodsFor: 'comparing' stamp: 'mab 6/6/2008 16:30'!
hasEqualElements: otherCollection
	"Answer whether the receiver's size is the same as otherCollection's
	size, and each of the receiver's elements equal the corresponding 
	element of otherCollection.
	This should probably replace the current definition of #= ."

	| size |
	"(otherCollection isKindOf: SequenceableCollection) ifFalse: [^ false]."
	(size := self size) = otherCollection size ifFalse: [^ false].
	1 to: size do:
		[:index |
		(self at: index) = (otherCollection at: index) ifFalse: [^ false]].
	^ true! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self indexOf: anElement ifAbsent: [0]! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the 
	result of evaluating the argument, exceptionBlock."

	^ self indexOf: anElement startingAt: 1 ifAbsent: exceptionBlock! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

	start to: self size do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 8/12/2008 18:43'!
last
	"Answer the last element of the receiver"

	^ self at: self size! !

!NXTSequenceableCollection methodsFor: 'enumerating' stamp: 'mab 6/6/2008 15:39'!
pairsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time.  If there's an odd number of items, ignore the last one.  Allows use of a flattened array for things that naturally group into pairs.  See also pairsCollect:"

	1 to: self size // 2 do:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 6/5/2008 16:14'!
replaceFrom: start to: stop with: replacement 
	"This destructively replaces elements from start to stop in the receiver. 
	Answer the receiver itself. Use copyReplaceFrom:to:with: for 
	insertion/deletion which may alter the size of the result."

	replacement size = (stop - start + 1)
		ifFalse: [self error: 'Size of replacement doesnt match'].
	^self replaceFrom: start to: stop with: replacement startingAt: 1! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 5/29/2008 15:50'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[(index := index + 1) <= stop]
		whileTrue: [self at: index put: (replacement at: repOff + index)]! !

!NXTSequenceableCollection methodsFor: 'testing' stamp: 'mab 6/6/2008 15:12'!
startsWith: start 
	| comp |
	self size < start size ifTrue: [^ false].
	comp := true.
	(self first: start size) with: start
		do: [:ea :ea2 | ea = ea2 ifFalse: [comp := false]].
	^ comp! !

!NXTSequenceableCollection methodsFor: 'accessing' stamp: 'mab 3/5/2009 19:54'!
swap: oneIndex with: anotherIndex 
	"Move the element at oneIndex to anotherIndex, and vice-versa."

	| element |
	element := self at: oneIndex.
	self at: oneIndex put: (self at: anotherIndex).
	self at: anotherIndex put: element! !

!NXTSequenceableCollection methodsFor: 'enumerating' stamp: 'mab 6/6/2008 15:12'!
with: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do:
		[:index |
		twoArgBlock value: (self at: index)
				value: (otherCollection at: index)]! !

!NXTSequenceableCollection methodsFor: 'enumerating' stamp: 'mab 8/15/2008 17:42'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

NXTSequenceableCollection variableByteSubclass: #NXTString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTString commentStamp: 'mab 3/16/2009 03:02' prior: 0!
A NXTString is an indexed collection of characters. In NXTalk, however, characters are currently usual bytes.!

!NXTString class methodsFor: 'constants' stamp: 'mab 6/9/2008 16:38'!
cr
	| string |
	string := self new: 1.
	string at: 1 put: 10.
	^ string! !

!NXTString class methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:12'!
elementSize
	^ 1! !

!NXTString methodsFor: 'comparing' stamp: 'mab 8/19/2008 15:51'!
= other
	other isString ifFalse: [ ^ false ].
	self size = other size ifFalse: [ ^ false ].
	1 to: self size do: [ :index |
		(self at: index) = (other at: index) ifFalse: [ ^ false ]].
	^ true
	! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 7/15/2008 10:47'!
asByteArray
	^ self! !

!NXTString methodsFor: 'converting' stamp: 'mab 7/15/2008 10:56'!
asString
	^ self! !

!NXTString methodsFor: 'converting' stamp: 'mab 7/16/2008 14:41'!
asSymbol
	^ NXTSymbol intern: self! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 9/10/2008 14:34'!
at: index
	<primitive: 63>
	<NXTPrimitive: 20>! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 9/10/2008 14:33'!
at: index put: aCharacter
	<primitive: 64>
	<NXTPrimitive: 21>! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:17'!
computeSize
	^ self size! !

!NXTString methodsFor: 'comparing' stamp: 'mab 12/15/2008 13:19'!
hash
	<NXTPrimitive: 62>
	| hash |
	hash := 0.
	self do: [ :character |
		hash := character asInteger + (hash << 6) + (hash << 16) - hash ].
	^ hash \\ (NXTSmallInteger maxVal + 1)! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 11/20/2008 14:25'!
isByteString
	^ true! !

!NXTString methodsFor: 'testing' stamp: 'mab 8/19/2008 15:57'!
isString
	^ true! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 6/6/2008 14:36'!
printOn: aStream
	aStream nextPutAll: 'an NXTString('''.
	aStream nextPutAll: self.
	aStream nextPutAll: ''')'.! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 7/21/2008 18:38'!
writeDataOn: aByteStream withImage: image
	1 to: self size do: [ :index |
		aByteStream nextPut: (self at: index) asInteger ].! !

NXTString variableByteSubclass: #NXTSymbol
	instanceVariableNames: ''
	classVariableNames: 'SymbolTable'
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSymbol commentStamp: 'mab 3/16/2009 03:03' prior: 0!
I represent NXTStrings that are created uniquely. Thus, someString asSymbol == someString asSymbol.!

!NXTSymbol class methodsFor: 'class initialization' stamp: 'mab 3/16/2009 09:59'!
initialize
	super initialize.
	Smalltalk isNXTalk ifTrue: [
		SymbolTable := NXTWeakSet withAll: self allInstances ].! !

!NXTSymbol class methodsFor: 'instance creation' stamp: 'mab 10/29/2008 11:55'!
intern: aStringOrSymbol
	^ (self lookup: aStringOrSymbol) ifNil: [
		| aSymbol |
		aStringOrSymbol isSymbol ifTrue: [
			aSymbol := aStringOrSymbol
		] ifFalse: [
			aSymbol := NXTSymbol new: aStringOrSymbol size.
			aSymbol string: aStringOrSymbol.
		].
		SymbolTable add: aSymbol.
	].! !

!NXTSymbol class methodsFor: 'instance creation' stamp: 'mab 10/29/2008 11:49'!
lookup: aStringOrSymbol
	^ SymbolTable like: aStringOrSymbol! !

!NXTSymbol methodsFor: 'comparing' stamp: 'mab 8/19/2008 15:48'!
= aSymbol
	"Compare the receiver and aSymbol." 
	self == aSymbol ifTrue: [^ true].
	self class == aSymbol class ifTrue: [^ false].
	"Use String comparison otherwise"
	^ super = aSymbol! !

!NXTSymbol methodsFor: 'converting' stamp: 'mab 7/25/2008 19:50'!
asMutator
	^ (self, ':') asSymbol! !

!NXTSymbol methodsFor: 'nxt-exclude' stamp: 'mab 11/16/2008 15:05'!
asSqueakObject
	^ (String withAll: self) asSymbol! !

!NXTSymbol methodsFor: 'converting' stamp: 'mab 11/16/2008 14:49'!
asString
	| string |
	string := NXTString new: self size.
	string replaceFrom: 1 to: self size with: self.
	^ string! !

!NXTSymbol methodsFor: 'testing' stamp: 'mab 7/25/2008 19:16'!
isSymbol
	^ true! !

!NXTSymbol methodsFor: 'nxt-exclude' stamp: 'mab 6/6/2008 14:36'!
printOn: aStream
	aStream nextPutAll: 'an NXTSymbol(#'.
	aStream nextPutAll: self.
	aStream nextPut: $).! !

!NXTSymbol methodsFor: 'private' stamp: 'mab 11/14/2008 15:04'!
species
	^ NXTString! !

!NXTSymbol methodsFor: 'private' stamp: 'mab 10/29/2008 11:58'!
string: aString

	1 to: aString size do: [:j | super at: j put: (aString at: j)].
	^self  ! !

NXTCollection subclass: #NXTSet
	instanceVariableNames: 'tally array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSet commentStamp: 'mab 3/16/2009 03:09' prior: 0!
I represent a set of objects without duplicates.  I can hold anything that responds to
#hash and #=, except for nil.  My instances will automatically grow, if necessary,
Note that I rely on #=, not #==.  If you want a set using #==, use IdentitySet.

Instance structure:

  array	An array whose non-nil elements are the elements of the set,
		and whose nil elements are empty slots.  There is always at least one nil.
		In fact I try to keep my "load" at 75% or less so that hashing will work well.

  tally	The number of elements in the set.  The array size is always greater than this.

The core operation is #findElementOrNil:, which either finds the position where an
object is stored in array, if it is present, or finds a suitable position holding nil, if
its argument is not present in array,!

NXTSet subclass: #NXTDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTDictionary commentStamp: 'mab 3/16/2009 03:11' prior: 0!
I represent a set of elements that can be viewed from one of two perspectives: a set of associations, or a container of values that are externally named where the name can be any object that responds to =. The external name is referred to as the key.  I inherit many operations from Set.!

!NXTDictionary class methodsFor: 'instance creation' stamp: 'mab 8/15/2008 16:44'!
new
	^ super new! !

!NXTDictionary class methodsFor: 'instance creation' stamp: 'mab 11/18/2008 09:02'!
newFrom: aDict 
	"Answer an instance of me containing the same associations as aDict.
	 Error if any key appears twice."
	| newDictionary |
	newDictionary := self new: aDict size.
	aDict associationsDo:
		[:x |
		(newDictionary includesKey: x key)
			ifTrue: [self error: 'Duplicate key: ', x key printString]
			ifFalse: [newDictionary add: x]].
	^ newDictionary

"	NewDictionary newFrom: {1->#a. 2->#b. 3->#c}
	{1->#a. 2->#b. 3->#c} as: NewDictionary
	NewDictionary newFrom: {1->#a. 2->#b. 1->#c}
	{1->#a. 2->#b. 1->#c} as: NewDictionary
"! !

!NXTDictionary methodsFor: 'comparing' stamp: 'mab 8/15/2008 17:08'!
= aDictionary
	aDictionary isDictionary ifFalse: [^false].
	self size = aDictionary size ifFalse: [^false].
	self associationsDo: [:assoc|
	(aDictionary at: assoc key ifAbsent: [^false]) = assoc value
		ifFalse: [^false]].
	^true! !

!NXTDictionary methodsFor: 'adding' stamp: 'mab 8/15/2008 14:56'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!NXTDictionary methodsFor: 'adding' stamp: 'mab 8/15/2008 14:57'!
addAll: aDictionary
	aDictionary == self ifFalse: [aDictionary associationsDo: [:assoc | self add: assoc]].
	^aDictionary.! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/15/2008 14:49'!
associationAt: key
	^self associationAt: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 11/18/2008 12:08'!
associationAt: key ifAbsent: aBlock
	"Answer the association with the given key.  If key is not found,
	return the result of evaluating aBlock."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	^ assoc
		ifNil:  [aBlock value]
		ifNotNil: [assoc]! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 14:57'!
associationsDo: aBlock
	super do: aBlock! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/19/2008 14:17'!
associationsSelect: aBlock 
	"Evaluate aBlock with each of my associations as the argument. Collect
	into a new dictionary, only those associations for which aBlock evaluates
	to true."

	| newCollection |
	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/19/2008 13:42'!
at: key
	"Answer the value associated with the key."
	^self at: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 11/18/2008 12:08'!
at: key ifAbsent: aBlock
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."
	| assoc |
	assoc := array at: (self findElementOrNil: key).
	^ assoc
		ifNil:  [aBlock value]
		ifNotNil: [assoc value]! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:20'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| v |
	v := self at: key ifAbsent: [^ nil].
	^ aBlock value: v
! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/19/2008 13:48'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (NXTAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 15:38'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := NXTOrderedCollection new: self size.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 14:58'!
do: aBlock
	super do: [:assoc | aBlock value: assoc value]! !

!NXTDictionary methodsFor: 'private' stamp: 'mab 8/15/2008 15:01'!
errorKeyNotFound
	self error: 'key not found'! !

!NXTDictionary methodsFor: 'private' stamp: 'mab 8/15/2008 15:01'!
errorValueNotFound
	self error: 'value not found'! !

!NXTDictionary methodsFor: 'testing' stamp: 'mab 8/19/2008 15:07'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!NXTDictionary methodsFor: 'testing' stamp: 'mab 8/15/2008 14:56'!
includesKey: key
	self at: key ifAbsent: [^false].
	^true! !

!NXTDictionary methodsFor: 'testing' stamp: 'mab 8/15/2008 16:55'!
isDictionary
	^ true! !

!NXTDictionary methodsFor: 'private' stamp: 'mab 8/15/2008 15:02'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	| assoc |
	assoc := array at: index.
	^nil == assoc ifFalse: [assoc key]! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/19/2008 14:02'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound]! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/19/2008 14:02'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	: Use =, not ==, so stings like 'this' can be found.  Note that MethodDictionary continues to use == so it will be fast."
 
	self associationsDo: 
		[:association | value = association value ifTrue: [^association key]].
	^exceptionBlock value! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/15/2008 14:54'!
keys
	| keySet |
	keySet := NXTSet new: self size.
	self keysDo: [:key | keySet add: key].
    ^keySet! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 14:58'!
keysAndValuesDo: aBlock
	^self associationsDo: [:assoc | aBlock value: assoc key value: assoc value]! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 14:58'!
keysDo: aBlock
	self associationsDo: [:association | aBlock value: association key]! !

!NXTDictionary methodsFor: 'private' stamp: 'mab 8/15/2008 15:02'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject key) put: anObject.
	tally := tally + 1.! !

!NXTDictionary methodsFor: 'testing' stamp: 'mab 8/19/2008 14:04'!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| count |
	count := 0.
	self do: [:each | anObject = each ifTrue: [count := count + 1]].
	^count! !

!NXTDictionary methodsFor: 'private' stamp: 'mab 8/15/2008 15:03'!
rehash	
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!NXTDictionary methodsFor: 'removing' stamp: 'mab 8/15/2008 15:07'!
removeKey: key
	^self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'removing' stamp: 'mab 3/5/2009 19:49'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!NXTDictionary methodsFor: 'private' stamp: 'mab 11/18/2008 12:09'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil
	(indicating an empty slot) or an element that matches
	anObject. Answer the index of that slot or zero if no slot is
	found. This method will be overridden in various subclasses that
	have different interpretations for matching elements."
	| element start finish |
	start := (anObject hash \\ array size) + 1.
	finish := array size.
	"Search from (hash mod size) to the end."
	start to: finish do: [:index |
	((element := array at: index) isNil or: [element key = anObject])
		ifTrue: [^index]].
	"Search from 1 to where we started."
	1 to: start - 1 do: [:index |
		((element := array at: index) isNil or: [element key = anObject])
			ifTrue: [^index]].
	^0! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 14:59'!
select: aBlock
	"Evaluate aBlock with each of my values as the argument.  Collect into a
	new Dictionary all associations for which aBlock evaluates to true."
	| newCollection |
	newCollection := self species new.
	self associationsDo: [:assoc | (aBlock value: assoc value) ifTrue: [newCollection add: assoc]].
	^newCollection! !

!NXTDictionary methodsFor: 'accessing' stamp: 'mab 8/15/2008 14:55'!
values	
	| valueArray |
	valueArray := NXTArray new: self size.
	self doWithIndex: [:value :index | valueArray at: index put: value].
	^valueArray! !

!NXTDictionary methodsFor: 'enumerating' stamp: 'mab 8/15/2008 15:00'!
valuesDo: aBlock
	self associationsDo: [:assoc | aBlock value: assoc value]! !

NXTDictionary subclass: #NXTIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTIdentityDictionary commentStamp: 'mab 3/16/2009 03:18' prior: 0!
Like a NXTDictionary, except that keys are compared with #== instead of #= .!

!NXTIdentityDictionary methodsFor: 'accessing' stamp: 'mab 2/19/2009 15:52'!
keys
	"This was taking some time in publishing and we didn't really need a Set"
	| answer index |
	answer := NXTArray new: self size.
	index := 0.
	self keysDo: [:key | answer at: (index := index + 1) put: key].
	^ answer! !

!NXTIdentityDictionary methodsFor: 'private' stamp: 'mab 2/19/2009 15:51'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish hash start element |
	finish := array size.
	finish > 4096
		ifTrue: [hash := anObject identityHash * (finish // 4096)]
		ifFalse: [hash := anObject identityHash].
	start := (hash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

NXTDictionary subclass: #NXTSystemDictionary
	instanceVariableNames: 'display motors buttons sensors speaker packageManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSystemDictionary commentStamp: 'mab 3/12/2009 16:56' prior: 0!
My sole instance Smalltalk manages all classes and the hardware environment.

Instance Variables
	buttons:		<NXTButtonPanel>
	display:		<NXTDisplay>
	motors:		<NXTArray>
	packageManager:		<NXTPackageManager>
	sensors:		<NXTArray>

buttons
	- The button panel.

display
	- The display.

motors
	- An array of the three motors.

packageManager
	- The package manager.

sensors
	- An array for four sensors.
!

!NXTSystemDictionary methodsFor: 'class management' stamp: 'mab 11/20/2008 15:35'!
addClass: class
	class superclass isNil ifFalse: [ 
		class superclass subclasses add: class ].
	class class superclass isNil ifFalse: [
		class class superclass subclasses add: class class ].
	^ Smalltalk at: class name put: class! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 9/19/2008 16:48'!
buttons
	^ buttons ifNil: [ buttons := NXTButtonContainer new ]! !

!NXTSystemDictionary methodsFor: 'class management' stamp: 'mab 11/20/2008 15:23'!
classNamed: aClassName
	^ self at: aClassName ifAbsent: [
		(aClassName endsWith: ' class') ifFalse: [ ^ nil ].
		^ (self at: (aClassName allButLast: 6) asSymbol ifAbsent: [ ^ nil ]) class ]! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 9/19/2008 16:42'!
display
	^ display ifNil: [ display := NXTDisplay new ]! !

!NXTSystemDictionary methodsFor: 'system primitives' stamp: 'mab 10/28/2008 13:49'!
garbageCollect
	<NXTPrimitive: 52>! !

!NXTSystemDictionary methodsFor: 'testing' stamp: 'mab 11/19/2008 17:53'!
isNXTalk
	^ true! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/12/2008 17:51'!
motorA
	^ self motors at: 1! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/12/2008 17:51'!
motorB
	^ self motors at: 2! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/12/2008 17:51'!
motorC
	^ self motors at: 3! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/12/2008 17:48'!
motors
	^ motors ifNil: [ motors := NXTMotor all ]! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/19/2008 15:35'!
packageManager
	^ packageManager! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/19/2008 15:35'!
packageManager: anObject
	packageManager := anObject.! !

!NXTSystemDictionary methodsFor: 'class management' stamp: 'mab 3/5/2009 19:50'!
removeClass: class
	class allInstances size > 0 ifTrue: [ self error: 'Instances of old class existing' ].
	class superclass isNil ifFalse: [
		class superclass subclasses remove: class ].
	class class superclass isNil ifFalse: [
		class class superclass subclasses remove: class class ].
	self removeKey: class name.! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/13/2008 09:05'!
sensorAt: port put: sensor
	sensor port: port.
	^ self sensors at: port put: sensor.! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 11/13/2008 09:04'!
sensors
	^ sensors ifNil: [ sensors := NXTArray new: 4 ]! !

!NXTSystemDictionary methodsFor: 'system primitives' stamp: 'mab 3/10/2009 10:48'!
shutdown: aBoolean
	"Shutdown with an image save or not"
	<NXTPrimitive: 51>! !

!NXTSystemDictionary methodsFor: 'accessing' stamp: 'mab 3/12/2009 17:20'!
speaker
	^ speaker ifNil: [ speaker := NXTSpeaker new ]! !

!NXTSet class methodsFor: 'instance creation' stamp: 'mab 8/15/2008 14:32'!
new
	^ self new: 2! !

!NXTSet class methodsFor: 'instance creation' stamp: 'mab 11/13/2008 17:22'!
new: nElements
	^ super new initialize: (self sizeFor: nElements)! !

!NXTSet class methodsFor: 'instance creation' stamp: 'mab 11/13/2008 17:21'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	nElements <= 0 ifTrue: [^ 1].
	^ nElements+1*4//3! !

!NXTSet methodsFor: 'comparing' stamp: 'mab 8/19/2008 16:08'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: NXTSet) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!NXTSet methodsFor: 'adding' stamp: 'mab 8/15/2008 14:36'!
add: newObject
	| index |
	newObject isNil ifTrue: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) isNil ifTrue: [self atNewIndex: index put: newObject].
	^newObject! !

!NXTSet methodsFor: 'accessing' stamp: 'mab 8/19/2008 17:03'!
array
	^ array! !

!NXTSet methodsFor: 'private' stamp: 'mab 8/15/2008 14:37'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck.! !

!NXTSet methodsFor: 'enumerating' stamp: 'mab 8/15/2008 14:42'!
do: unaryBlock
	tally = 0 ifFalse: [array do: [:element | element isNil ifFalse: [unaryBlock value: element]]]! !

!NXTSet methodsFor: 'private' stamp: 'mab 11/13/2008 17:19'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!NXTSet methodsFor: 'private' stamp: 'mab 11/18/2008 12:06'!
fixCollisionsFrom: index
	"The element at index has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"
	| length oldIndex newIndex element |
	oldIndex := index.
	length := array size.
	[oldIndex = length
		ifTrue: [oldIndex := 1]
		ifFalse: [oldIndex := oldIndex + 1].
	(element := self keyAt: oldIndex) isNil]
		whileFalse: 
			[newIndex := self findElementOrNil: element.
			oldIndex = newIndex ifFalse: [self swap: oldIndex with: newIndex]].! !

!NXTSet methodsFor: 'private' stamp: 'mab 8/15/2008 14:38'!
fullCheck
	"Keep array at least 1/4 free for decent hash behaviour."
	(array size - tally) < (1 max: (array size // 4)) ifTrue: [self grow]! !

!NXTSet methodsFor: 'private' stamp: 'mab 8/15/2008 17:40'!
grow
	"Grow the elements array and reinsert the old elements."
	| oldElements oldSize |
	oldElements := array.
	oldSize := array size.
	array := NXTArray new: oldSize + self growSize.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

!NXTSet methodsFor: 'adding' stamp: 'mab 8/15/2008 14:38'!
growSize
	^ array size! !

!NXTSet methodsFor: 'initialization' stamp: 'mab 8/15/2008 14:34'!
initialize: size
	tally := 0.
	array := NXTArray new: size.! !

!NXTSet methodsFor: 'testing' stamp: 'mab 12/15/2008 10:54'!
isSet
	^ true! !

!NXTSet methodsFor: 'private' stamp: 'mab 8/15/2008 14:41'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	^ array at: index! !

!NXTSet methodsFor: 'accessing' stamp: 'mab 8/15/2008 14:43'!
like: anObject
	| index |
	index := self scanFor: anObject.
	^index < 1 ifFalse: [array at: index]! !

!NXTSet methodsFor: 'private' stamp: 'mab 8/15/2008 14:39'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1.! !

!NXTSet methodsFor: 'removing' stamp: 'mab 11/19/2008 10:29'!
remove: oldObject ifAbsent: aBlock
	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) isNil ifTrue: [^aBlock value].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^oldObject! !

!NXTSet methodsFor: 'private' stamp: 'mab 8/15/2008 14:37'!
scanFor: anObject
	"Scan the array for the first slot containing either a nil
	(indicating an empty slot) or an element that matches anObject.
	Answer the index of that slot or 0 if no slot is found.  This
	method will be overridden in various subtypes that have
	different interpretations for matching elements. "
	| finish start |
	finish := array size.
	start := anObject hash \\ finish + 1.
	"search from (hash mod size) to the end"
	start to: finish do: [:index |
		| element |
		((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^index]].
	"search from start to (hash mod size)"
	1 to: start do: [:index |
		| element |
		((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^index]].
	^0.	"no match AND no empty slot"! !

!NXTSet methodsFor: 'accessing' stamp: 'mab 8/15/2008 14:43'!
size
	^ tally! !

!NXTSet methodsFor: 'accessing' stamp: 'mab 3/5/2009 19:53'!
swap: oneIndex with: otherIndex
	"May be overridden by subclasses so that fixCollisions will work"

	array swap: oneIndex with: otherIndex
! !

NXTSet subclass: #NXTWeakSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTWeakSet commentStamp: 'mab 3/16/2009 03:20' prior: 0!
NXTWeakSet is a set which holds only weakly on its elements. This means whenever an object is only referenced by instances of NXTWeakSet it will be garbage collected.!

!NXTWeakSet methodsFor: 'private' stamp: 'mab 10/28/2008 15:10'!
grow
	"Grow the elements array and reinsert the old elements."
	| oldElements oldSize |
	oldElements := array.
	oldSize := array size.
	array := NXTWeakArray new: oldSize + self growSize.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

!NXTWeakSet methodsFor: 'initialization' stamp: 'mab 10/28/2008 15:06'!
initialize: size
	tally := 0.
	array := NXTWeakArray new: size.! !

!NXTWeakSet methodsFor: 'accessing' stamp: 'mab 11/14/2008 14:56'!
realSize
	| size |
	size := 0.
	array do: [ :each |
		each isNil ifFalse: [ size := size + 1]].
	^ size! !

!NXTWeakSet methodsFor: 'private' stamp: 'mab 10/28/2008 15:14'!
rehash
	"Reinsert the old elements into a new WeakArray."
	| oldElements |
	oldElements := array.
	array := NXTWeakArray new: array size.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

NXTObject subclass: #NXTDelay
	instanceVariableNames: 'delayDuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTDelay commentStamp: 'mab 3/7/2009 22:17' prior: 0!
My instances represent a delay. Sending #wait will suspend the current process for the set delay duration.

Instance Variables
	delayDuration:		<Duration>

delayDuration
	- The exact duration of my delay.
!

!NXTDelay methodsFor: 'converting' stamp: 'mab 12/17/2008 10:52'!
asDelay
	^ self! !

!NXTDelay methodsFor: 'accessing' stamp: 'mab 10/30/2008 13:05'!
setDelay: milliseconds
	delayDuration := milliseconds.! !

!NXTDelay methodsFor: 'delaying' stamp: 'mab 3/7/2009 22:35'!
wait
	Processor activeProcess waitFor: (NXTEventDescription time: NXTTime millisecondClockValue + delayDuration)! !

NXTObject subclass: #NXTDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 11:06'!
closeClaw
	self motorC rotateAt: -75 by: 60 brakingHard: true.
	1 seconds asDelay wait.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:31'!
driveAhead
	self motorA speed: 75.
	self motorB speed: 75.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:31'!
driveBack
	self motorA
		speed: -75.
	self motorB
		speed: -75.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 10:45'!
openClaw
	self motorC rotateAt: 75 by: 30 brakingHard: true.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 11:03'!
run
	| touchSensor |
	touchSensor := (NXTTouchSensor port: 3) enable.
	self openClaw.
	self driveAhead.
	touchSensor waitUntilPressed.
	self stop.
	self closeClaw.
	self driveBack.
	2 seconds asDelay wait.
	self stop.
	touchSensor disable.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 10:34'!
stop
	self motorA stop.
	self motorB stop.
	self motorC stop.
! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:30'!
turnAround
	self driveBack.
	(1000 + 100 atRandom) milliSeconds wait.
	self stop.
	2 * 3 atRandom = 1 
		ifTrue: [ self motorC speed: -75 ]
		ifFalse: [ self motorC speed: 75 ].
	(500 + 500 atRandom) milliSeconds wait.
	self driveAhead.! !

NXTObject subclass: #NXTDispatcher
	instanceVariableNames: 'dataStream localObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTDispatcher commentStamp: 'mab 3/7/2009 22:28' prior: 0!
My instances actively wait for messages incoming from a data stream. The messages are dispatched to a local object.

Instance Variables
	dataStream:		<NXTDataStream>
	localObject:		<NXTObject>

dataStream
	- The stream, from where the incoming message are read

localObject
	- The local object the messages are forwarded to
!

!NXTDispatcher class methodsFor: 'instance creation' stamp: 'mab 11/14/2008 18:27'!
for: localObject on: dataStream
	^ self new
		localObject: localObject;
		dataStream: dataStream! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
dataStream
	^ dataStream! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
dataStream: anObject
	dataStream := anObject! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
localObject
	^ localObject! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
localObject: anObject
	localObject := anObject! !

!NXTDispatcher methodsFor: 'dispatcher loop' stamp: 'mab 3/5/2009 18:33'!
receive
	| message |
	[
		message := self dataStream next.
		message isMessage ifFalse: [ self error: 'Connection out of sync' ].
		self display show: 'Got ', message selector, ' message'; cr.
		message selector = #exit ifTrue: [ ^ self return: #exited ].
		[ self return: (message sendTo: self localObject).
		self display show: 'Answered'; cr ] on: NXTException do: [ :ex | self return: nil. ex signal ].
	] doWhileTrue: [ true ].! !

!NXTDispatcher methodsFor: 'communication' stamp: 'mab 11/14/2008 18:52'!
return: value
	value = self localObject
		ifTrue: [ self dataStream nextPut: nil ]
		ifFalse: [ self dataStream nextPut: value ].
	self dataStream flush.
! !

NXTObject subclass: #NXTDisplay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 13:28'!
clear
	<NXTPrimitive: 35>! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:51'!
cr
	self show: NXTString cr.! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:55'!
cursorToX: x Y: y
	<NXTPrimitive: 45>! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 7/23/2008 16:25'!
scrolling: on
	<NXTPrimitive: 32>! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:10'!
show: anObject
	anObject isSymbol ifTrue: [ self show: '#' ].
	anObject isString ifTrue: [ ^ self showString: anObject ].
	anObject isInteger ifTrue: [
		anObject isSmallInteger ifTrue: [ ^ self showSmallInteger: anObject ].
		self showLargeInteger: anObject ].
	! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:10'!
showLargeInteger: anInteger
	<NXTPrimitive: 13>
	Transcript show: anInteger asString! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:02'!
showSmallInteger: anInteger
	<NXTPrimitive: 4>
	Transcript show: anInteger asString! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 17:26'!
showString: aString
	<NXTPrimitive: 0>
	Transcript show: aString; cr.! !

NXTObject subclass: #NXTDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:10'!
driveAhead
	self motorB 
		speed: 75.
	self motorC
		speed: 75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:05'!
driveBackwards
	self motorB 
		speed: -75.
	self motorC
		speed: -75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:05'!
left
	self motorB 
		speed: 75.
	self motorC
		speed: -75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:05'!
right
	self motorB 
		speed: -75.
	self motorC
		speed: 75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:11'!
stop
	self motorB stop.
	self motorC stop.
! !

NXTObject subclass: #NXTException
	instanceVariableNames: 'messageText signalContext handlerContext outerContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTException commentStamp: 'mab 3/7/2009 23:00' prior: 0!
My instances and instances of my subclasses represent different kind of exceptions. I provide the necessary behavior to modify the stack accordingly if I am asked to signal an exception.

Instance Variables
	handlerContext:		<NXTFrame>
	messageText:		<NXTString>
	outerContext:		<NXTFrame>
	signalContext:		<NXTFrame>

handlerContext
	- The frame context, which handles my instance.

messageText
	- The message text belonging to the exception.

outerContext
	- The frame context, which is one before of the signalling frame context.

signalContext
	- The context, which signalled the exception.
!

NXTException subclass: #NXTError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTError commentStamp: 'mab 3/7/2009 23:09' prior: 0!
My instances represent an error exception.

Instance Variables
!

!NXTError methodsFor: 'exceptionDescription' stamp: 'mab 10/3/2008 17:40'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	NXTUnhandledError signalForException: self! !

!NXTError methodsFor: 'private' stamp: 'mab 10/3/2008 19:18'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

NXTError subclass: #NXTMessageNotUnderstood
	instanceVariableNames: 'message receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMessageNotUnderstood commentStamp: 'mab 3/7/2009 23:19' prior: 0!
A message not understood exception is signalled, if the interpreter could not find a method for a given selector in the class hierarchy of the receiver. Do not change the layout of this class, as it is filled in by the VM.

Instance Variables
	message:		<NXTMessage>
	receiver:		<NXTObject>

message
	- The message which was sent containing the selector and the arguments.

receiver
	- The receiver to whom the message was sent.
!

!NXTMessageNotUnderstood methodsFor: 'testing' stamp: 'mab 10/3/2008 22:52'!
isResumable
	"Determine whether an exception is resumable."

	^true! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:00'!
message
	^ message! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:00'!
message: anObject
	message := anObject! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:50'!
messageText
	"Return an exception's message text."

	^messageText ifNil: [ message isNil
				ifTrue: [super messageText]
				ifFalse: [message lookupClass name, '>>', message selector asString]]
! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:01'!
receiver
	^ receiver! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:01'!
receiver: anObject
	receiver := anObject! !

!NXTException class methodsFor: 'exceptionSelector' stamp: 'mab 9/1/2008 18:32'!
handles: exception
	"Determine whether an exception handler will accept a signaled exception."
	^ exception isKindOf: self! !

!NXTException class methodsFor: 'exceptionInstantiator' stamp: 'mab 10/3/2008 17:48'!
signal
	"Signal the occurrence of an exceptional condition."

	^ self new signal! !

!NXTException class methodsFor: 'exceptionInstantiator' stamp: 'mab 6/9/2008 15:55'!
signal: text
	self new signal: text! !

!NXTException methodsFor: 'priv handling' stamp: 'mab 10/3/2008 17:05'!
defaultAction
	"The default action taken if the exception is signaled."

	self subclassResponsibility! !

!NXTException methodsFor: 'printing' stamp: 'mab 10/3/2008 17:16'!
description
	"Return a textual description of the exception."

	| desc mt |
	desc := self class name asString.
	^(mt := self messageText) == nil
		ifTrue: [desc]
		ifFalse: [desc, ': ', mt]! !

!NXTException methodsFor: 'priv handling' stamp: 'mab 10/3/2008 17:49'!
isResumable
	"Determine whether an exception is resumable."

	^ true! !

!NXTException methodsFor: 'accessing' stamp: 'mab 5/21/2008 18:21'!
messageText
	^ messageText! !

!NXTException methodsFor: 'accessing' stamp: 'mab 5/21/2008 18:21'!
messageText: anObject
	messageText := anObject! !

!NXTException methodsFor: 'handling' stamp: 'mab 10/3/2008 19:32'!
outer
	"Evaluate the enclosing exception action and return to here instead of signal if it resumes (see #resumeUnchecked:)."

	| prevOuterContext currentContext |
	currentContext := thisContext contextTag.
	self isResumable ifTrue: [
		prevOuterContext := outerContext.
		outerContext := currentContext.
	].
	self pass.
! !

!NXTException methodsFor: 'handling' stamp: 'mab 10/3/2008 17:52'!
pass
	"Yield control to the enclosing exception action for the receiver."

	handlerContext nextHandlerContext handleSignal: self! !

!NXTException methodsFor: 'priv handling' stamp: 'mab 10/3/2008 16:54'!
privHandlerContext: aContextTag

	handlerContext := aContextTag! !

!NXTException methodsFor: 'handling' stamp: 'mab 10/3/2008 17:39'!
resume
	"Return from the message that signaled the receiver."

	self resume: nil! !

!NXTException methodsFor: 'handling' stamp: 'mab 11/16/2008 14:49'!
resume: resumptionValue
	"Return resumptionValue as the value of the signal message."

	self isResumable ifFalse: [NXTIllegalResumeAttempt signal].
	self resumeUnchecked: resumptionValue! !

!NXTException methodsFor: 'handling' stamp: 'mab 10/3/2008 17:04'!
resumeUnchecked: resumptionValue
	"Return resumptionValue as the value of #signal, unless this was called after an #outer message, then return resumptionValue as the value of #outer."

	| ctxt |
	outerContext ifNil: [
		signalContext return: resumptionValue
	] ifNotNil: [
		ctxt := outerContext.
		outerContext := ctxt tempAt: 1. "prevOuterContext in #outer"
		ctxt return: resumptionValue
	].
! !

!NXTException methodsFor: 'handling' stamp: 'mab 10/3/2008 17:26'!
return
	"Return nil as the value of the block protected by the active exception handler."

	self return: nil! !

!NXTException methodsFor: 'handling' stamp: 'mab 10/3/2008 17:26'!
return: returnValue
	"Return the argument as the value of the block protected by the active exception handler."

	handlerContext return: returnValue! !

!NXTException methodsFor: 'signaling' stamp: 'mab 10/3/2008 16:50'!
signal
	"Ask ContextHandlers in the sender chain to handle this signal.  The default is to execute and return my defaultAction."
	signalContext := thisContext contextTag.
	^ thisContext nextHandlerContext handleSignal: self! !

!NXTException methodsFor: 'signaling' stamp: 'mab 6/9/2008 16:14'!
signal: text
	self messageText: text.
	self signal! !

!NXTException methodsFor: 'printing' stamp: 'mab 10/3/2008 17:15'!
signalerContext
	"Find the first sender of signal(:)"

	^ signalContext findContextSuchThat: [:ctxt |
		(ctxt receiver == self or: [ctxt receiver == self class]) not]! !

NXTException subclass: #NXTIllegalResumeAttempt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTIllegalResumeAttempt commentStamp: 'mab 3/7/2009 23:12' prior: 0!
Never use this class on your own. It is signaled if an exception shall be resumed, which does not allow this.

Instance Variables
!

!NXTIllegalResumeAttempt methodsFor: 'comment' stamp: 'mab 10/3/2008 17:40'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	NXTUnhandledError signalForException: self! !

!NXTIllegalResumeAttempt methodsFor: 'comment' stamp: 'mab 10/3/2008 17:40'!
isResumable
	
	^ false! !

NXTException subclass: #NXTNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTNotification commentStamp: 'mab 3/7/2009 23:14' prior: 0!
A notification indicates, that something interesting has happend but does not need to be handled separately. It will simply resume the execution.

Instance Variables
!

!NXTNotification methodsFor: 'exceptionDescription' stamp: 'mab 10/3/2008 19:19'!
defaultAction
	"No action is taken. The value nil is returned as the value of the message that signaled the exception."

	^nil! !

!NXTNotification methodsFor: 'exceptionDescription' stamp: 'mab 10/3/2008 19:19'!
isResumable
	"Answer true. Notification exceptions by default are specified to be resumable."

	^true! !

NXTException subclass: #NXTTestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

NXTException subclass: #NXTUnhandledError
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTUnhandledError commentStamp: 'mab 3/7/2009 23:16' prior: 0!
I am a private class and used to handle errors not handle by the applications. I simply print the execution stack on the NXT's display.

Instance Variables
	exception:		<NXTException>

exception
	- The original description, which wasn't handled.
!

!NXTUnhandledError class methodsFor: 'instance creation' stamp: 'mab 10/3/2008 17:06'!
signalForException: anError

	^ self new
		exception: anError;
		signal! !

!NXTUnhandledError methodsFor: 'priv handling' stamp: 'mab 3/12/2009 17:25'!
defaultAction
	(exception signalerContext stackOfSize: 10) do: [ :each |
		each printNl ].
	self display show: 'Unhandled Exception: ', exception description; cr.
	NXTButton waitForAnyKey.
	self environment shutdown: false.! !

!NXTUnhandledError methodsFor: 'accessing' stamp: 'mab 10/3/2008 17:06'!
exception

	^ exception! !

!NXTUnhandledError methodsFor: 'accessing' stamp: 'mab 10/3/2008 17:06'!
exception: anError

	exception := anError! !

!NXTUnhandledError methodsFor: 'priv handling' stamp: 'mab 10/3/2008 17:07'!
isResumable
	
	^ false! !

NXTObject subclass: #NXTFrame
	instanceVariableNames: 'context pc stackPointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTFrame commentStamp: 'mab 3/7/2009 23:44' prior: 0!
I am an abstract base class for the two types of stack frame contexts in NXTalk. 

Instance Variables
	context:		<NXTFrame>
	pc:		<NXTSmallInteger>
	stackPointer:		<NXTSmallInteger>

context
	- The frame context, which created this context.

pc
	- The program counter in the frame's method or block.

stackPointer
	- The stack pointer for the current frame context.
!

NXTFrame variableSubclass: #NXTBlockFrame
	instanceVariableNames: 'block home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBlockFrame commentStamp: 'mab 3/8/2009 00:06' prior: 0!
My instances represent the stack frame for the execution of a block.

Instance Variables
	block:		<NXTBlock>
	home:		<NXTFrame>

block
	- The block, which is executed in this context.

home
	- The frame context, in which the block was instanciated.
!

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
doWhileFalse: conditionBlock
	"Evaluate the receiver once, then again as long the value of conditionBlock is false."
 
	| result |
	[result := self value.
	conditionBlock value] whileFalse.

	^ result! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
doWhileTrue: conditionBlock
	"Evaluate the receiver once, then again as long the value of conditionBlock is true."
 
	| result |
	[result := self value.
	conditionBlock value] whileTrue.

	^ result! !

!NXTBlockFrame methodsFor: 'exceptions' stamp: 'mab 1/12/2009 15:57'!
ensure: aBlock
	"Evaluate a termination block after evaluating the receiver, regardless of whether the receiver's evaluation completes."

	| returnValue b ctx |
	returnValue := self value.
	"aBlock wasn't nil when execution of this method began; it is nil'd out by the unwind machinery, and that's how we know it's already been evaluated ... otherwise, obviously, it needs to be evaluated"
	ctx := thisContext.
	aBlock == nil ifFalse: [
		"nil out aBlock temp before evaluating aBlock so it is not executed again if aBlock remote returns"
		b := aBlock.
		ctx argumentAt: 1 put: nil.  "aBlock _ nil"
		b value.
	].
	^ returnValue! !

!NXTBlockFrame methodsFor: 'scheduling' stamp: 'mab 1/12/2009 15:57'!
fork
	^ NXTProcess forContext: self.! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
home
	^ home! !

!NXTBlockFrame methodsFor: 'testing' stamp: 'mab 1/12/2009 15:57'!
isBlock
	^ true! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
methodClass
	^ self home methodClass! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
numArgs
	^ block numArgs! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
numTemps
	^ block numTemps! !

!NXTBlockFrame methodsFor: 'exceptions' stamp: 'mab 1/12/2009 15:57'!
on: exception do: handlerAction
	"Evaluate the receiver in the scope of an exception handler."
	| handlerActive |
	handlerActive := true.
	^self value! !

!NXTBlockFrame methodsFor: 'non local return handling' stamp: 'mab 1/12/2009 15:57'!
onNonLocalReturnsDo: handler
	"Evaluate the receiver and catch non local returns, Even if target frame has been left (VM support)."
	^ self value! !

!NXTBlockFrame methodsFor: 'printing' stamp: 'mab 3/4/2009 18:38'!
printNl
	self display show: '[] in '.
	self home printNl.! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
receiver
	^ home receiver! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
repeat
	"Evaluate the receiver repeatedly, ending only if the block explicitly returns."

	[self value. true] whileTrue! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
restart
	<NXTPrimitive: 5>
	self restart! !

!NXTBlockFrame methodsFor: 'evaluating' stamp: 'mab 1/12/2009 15:57'!
value
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'evaluating' stamp: 'mab 1/12/2009 15:57'!
value: aValue
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'evaluating' stamp: 'mab 1/12/2009 15:57'!
value: aValue1 value: aValue2
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
whileFalse
	^ self whileFalse: []! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
whileFalse: aBlock
	self value ifTrue: [ ^ nil ].
	aBlock value.
	self restart.! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
whileTrue
	^ self whileTrue: []! !

!NXTBlockFrame methodsFor: 'controlling' stamp: 'mab 1/12/2009 15:57'!
whileTrue: aBlock
	self value ifFalse: [ ^ nil ].
	aBlock value.
	self restart.! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 1/19/2009 14:04'!
argumentAt: index
	^ self at: 5 + index! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 1/19/2009 14:04'!
argumentAt: index put: value
	^ self at: 5 + index put: value! !

!NXTFrame methodsFor: 'query' stamp: 'mab 10/3/2008 17:15'!
findContextSuchThat: testBlock
	"Search self and my sender chain for first one that satisfies testBlock.  Return nil if none satisfy"

	| ctxt |
	ctxt := self.
	[ctxt isNil] whileFalse: [
		(testBlock value: ctxt) ifTrue: [^ ctxt].
		ctxt := ctxt sender.
	].
	^ nil! !

!NXTFrame methodsFor: 'private-exceptions' stamp: 'mab 9/1/2008 16:49'!
findNextHandlerContextStarting
	"Return the next handler marked context, returning nil if there is none.  Search starts with self and proceeds up to nil."
	| ctx |
	ctx := self.
		[ctx isHandlerContext ifTrue:[^ctx].
		(ctx := ctx sender) == nil ] whileFalse.
	^nil! !

!NXTFrame methodsFor: 'private-exceptions' stamp: 'mab 10/3/2008 20:41'!
findNextUnwindContextUpTo: aContext
	"Return the next unwind marked above the receiver, returning nil if there is none.  Search proceeds up to but not including aContext."

	| ctx |
	ctx := self.
		[(ctx := ctx sender) == nil or: [ctx == aContext]] whileFalse:
		[ ctx isUnwindContext ifTrue: [^ctx]].
	^nil! !

!NXTFrame methodsFor: 'private-exceptions' stamp: 'mab 10/3/2008 21:31'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."
	| val |
	(((self argumentAt: 1) handles: exception) and: [self tempAt: 1]) ifFalse: [
		^ self nextHandlerContext handleSignal: exception].
	
	exception privHandlerContext: self contextTag.
	"Disable myself while executing exception handler"
	self tempAt: 1 put: false.
	val := [ (self argumentAt: 2) value: exception ]
		ensure: [ self tempAt: 1 put: true ].
	self return: val.  "return from self if not otherwise directed in handle block"! !

!NXTFrame methodsFor: 'testing' stamp: 'mab 9/1/2008 18:55'!
hasSender: aContext
	"Answer whether the receiver is strictly above context on the stack."

	| s |
	self == aContext ifTrue: [^false].
	s := self sender.
	[s == nil]
		whileFalse: 
			[s == aContext ifTrue: [^true].
			s := s sender].
	^false! !

!NXTFrame methodsFor: 'testing' stamp: 'mab 8/21/2008 15:45'!
isBlock
	^ false! !

!NXTFrame methodsFor: 'testing' stamp: 'mab 10/3/2008 20:49'!
isDead
	"Has self finished"

	^ pc isNil! !

!NXTFrame methodsFor: 'testing' stamp: 'mab 9/1/2008 16:51'!
isHandlerContext
	^ false! !

!NXTFrame methodsFor: 'testing' stamp: 'mab 8/21/2008 15:45'!
isMethod
	^ false! !

!NXTFrame methodsFor: 'testing' stamp: 'mab 9/1/2008 19:13'!
isUnwindContext
	^ false! !

!NXTFrame methodsFor: 'private-exceptions' stamp: 'mab 9/1/2008 16:48'!
nextHandlerContext
	^ self sender findNextHandlerContextStarting! !

!NXTFrame methodsFor: 'printing' stamp: 'mab 3/4/2009 18:27'!
printNl
	| selector class mclass |
	"self method == nil ifTrue: [^ super printOn: aStream]."
	class := self receiver class.
	mclass := self methodClass.
	selector := self selector ifNil:[self method defaultSelector].
	self display show: class name asString.
	mclass == class 
		ifFalse: 	[ self display show: '(', mclass name asString, ')' ].
	self display show: '>>', selector.
	selector = #doesNotUnderstand: ifTrue: [
		self display show: ' ' , (self argumentAt: 1) selector.
	].
	self display cr.! !

!NXTFrame methodsFor: 'controlling' stamp: 'mab 10/3/2008 20:55'!
resume: value
	"Unwind thisContext to self and resume with value as result of last send.  Execute unwind blocks when unwinding.  ASSUMES self is a sender of thisContext"

	| ctxt unwindBlock |
	self isDead ifTrue: [self cannotReturn: value to: self].
	ctxt := thisContext.
	[	ctxt := ctxt findNextUnwindContextUpTo: self.
		ctxt isNil
	] whileFalse: [
		unwindBlock := ctxt tempAt: 1.
		unwindBlock ifNotNil: [
			ctxt argumentAt: 1 put: nil.
			thisContext terminateTo: ctxt.
			unwindBlock value].
	].
	thisContext terminateTo: self.
	^ value
! !

!NXTFrame methodsFor: 'controlling' stamp: 'mab 9/1/2008 18:43'!
return: value
	"Unwind thisContext to self and return value to self's sender.  Execute any unwind blocks while unwinding.  ASSUMES self is a sender of thisContext"

	"context ifNil: [self cannotReturn: value to: sender]."
	self sender resume: value! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 9/1/2008 16:48'!
sender
	^ context! !

!NXTFrame methodsFor: 'debugger access' stamp: 'mab 11/16/2008 14:52'!
stackOfSize: limit 
	"Answer an OrderedCollection of the top 'limit' contexts
		on the receiver's sender chain."

	| a stack |
	stack := NXTOrderedCollection new.
	stack addFirst: (a := self).
	[(a := a sender) ~~ nil and: [stack size < limit]]
		whileTrue: [ stack addFirst: a].
	^ stack! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 1/3/2009 15:49'!
stackPointer
	^ stackPointer! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 1/3/2009 16:23'!
stackStart
	^ stackPointer - self numArgs! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 1/19/2009 14:04'!
tempAt: index
	^ self at: (5 + self numArgs + index)! !

!NXTFrame methodsFor: 'accessing' stamp: 'mab 1/19/2009 14:05'!
tempAt: index put: value
	^ self at: (5 + self numArgs + index) put: value! !

!NXTFrame methodsFor: 'controlling' stamp: 'mab 9/1/2008 18:52'!
terminate
	"Make myself unresumable."
	context := nil.
	pc := nil.
! !

!NXTFrame methodsFor: 'controlling' stamp: 'mab 9/1/2008 18:52'!
terminateTo: previousContext
	"Terminate all the Contexts between me and previousContext, if previousContext is on my Context stack. Make previousContext my sender."

	| currentContext sendingContext |
	(self hasSender: previousContext) ifTrue: [
		currentContext := context.
		[currentContext == previousContext] whileFalse: [
			sendingContext := currentContext sender.
			currentContext terminate.
			currentContext := sendingContext]].
	context := previousContext! !

!NXTFrame methodsFor: 'controlling' stamp: 'mab 10/3/2008 20:47'!
unwindTo: aContext

	| ctx unwindBlock |
	ctx := self.
	[(ctx := ctx findNextUnwindContextUpTo: aContext) isNil] whileFalse: [
		unwindBlock := ctx tempAt: 1.
		unwindBlock == nil ifFalse: [
			ctx tempAt: 1 put: nil.
			unwindBlock value]
	].
! !

NXTFrame variableSubclass: #NXTMethodFrame
	instanceVariableNames: 'method receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMethodFrame commentStamp: 'mab 3/8/2009 01:33' prior: 0!
My instances represent the stack frames for executing methods. Thus, they reference the method and receiver objects. Use them to modify the current execution stack. Do NOT modify my class structure

Instance Variables
	method:		<NXTMethod>
	receiver:		<NXTObject>

method
	- The method executed by this context frame.

receiver
	- The receiver on which the current method is executed.
!

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
contextTag
	"Context tags may be used for referring to contexts instead of contexts themselves as they can be copied and will continue to work in other processes (continuations). By default, we use the context itself to as its tag."
	^self! !

!NXTMethodFrame methodsFor: 'testing' stamp: 'mab 1/12/2009 15:58'!
isHandlerContext
	^ self selector = #on:do: and: [ self owner = NXTBlockFrame ]! !

!NXTMethodFrame methodsFor: 'testing' stamp: 'mab 1/12/2009 15:58'!
isMethod
	^ true! !

!NXTMethodFrame methodsFor: 'testing' stamp: 'mab 1/12/2009 15:58'!
isUnwindContext
	^ self selector = #ensure: and: [ self owner = NXTBlockFrame ]! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
method
	^ method! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
methodClass
	^ method methodClass! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
numArgs
	^ method numArgs! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
numTemps
	^ method numTemps! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
owner
	^ method methodClass! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
receiver
	^ receiver! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
selector
	^ method selector! !

NXTObject subclass: #NXTLineFollower
	instanceVariableNames: 'sweep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 12:39'!
driveIntensity
	^ 55! !

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:01'!
lightSensorPort
	^ 3! !

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 10:58'!
motorPower
	^ 75! !

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 12:39'!
searchIntensity
	^ 45! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 12/8/2008 08:37'!
adjustSweep
	self sweep: self sweep * 2.! !

!NXTLineFollower methodsFor: 'motor control' stamp: 'mab 1/4/2009 10:59'!
driveAhead
	self motorB speed: self class motorPower.
	self motorC speed: self class motorPower.! !

!NXTLineFollower methodsFor: 'motor control' stamp: 'mab 1/4/2009 10:45'!
driveStraightAheadOnLine
	self driveAhead.
	self lightSensor waitUntilLighterThan: self class driveIntensity.
	self stop.! !

!NXTLineFollower methodsFor: 'executing' stamp: 'mab 1/4/2009 12:50'!
exit
	self stop.! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 13:35'!
findLine
	self reset.
	[ self adjustSweep.
	self tryLeft ifTrue: [ ^ self ].
	self adjustSweep.
	self tryRight ifTrue: [ ^ self ]] repeat.! !

!NXTLineFollower methodsFor: 'initialize-release' stamp: 'mab 1/4/2009 12:50'!
initialize
	self lightSensor: NXTLightSensor new.! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 09:01'!
lightSensor
	^ self environment sensorAt: self class lightSensorPort! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 09:03'!
lightSensor: anObject
	^ self environment sensorAt: self class lightSensorPort put: anObject! !

!NXTLineFollower methodsFor: 'initialize-release' stamp: 'mab 12/8/2008 08:35'!
reset
	self sweep: 2.! !

!NXTLineFollower methodsFor: 'executing' stamp: 'mab 3/4/2009 17:03'!
run
	2 seconds asDelay wait.
	"self buttons exit onPressedDo: [ ^ self exit ]."
	20 timesRepeat: [ self reset.
	self findLine.
	self driveStraightAheadOnLine ].
	self display show: 'Huhu'; cr.! !

!NXTLineFollower methodsFor: 'motor control' stamp: 'mab 12/8/2008 09:29'!
stop
	self motorB stop.
	self motorC stop.! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 08:35'!
sweep
	^ sweep! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 08:35'!
sweep: anObject
	sweep := anObject! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 16:29'!
tryForward: aMotor backward: anotherMotor
	| handler |
	handler := self lightSensor onDarkerThan: self class searchIntensity do: [ self stop. ^ true ].
	anotherMotor speed: self class motorPower negated.
	aMotor speed: self class motorPower.
	aMotor rotationSensor waitDegrees: self sweep.
	handler terminate.
	self stop.
	^ false! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 12:48'!
tryLeft
	^ self tryForward: self motorB backward: self motorC! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 12:48'!
tryRight
	^self tryForward: self motorC backward: self motorB! !

NXTObject subclass: #NXTLineFollower2
	instanceVariableNames: 'sweep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
driveIntensity
	^ 55! !

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
lightSensorPort
	^ 3! !

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 17:17'!
motorPower
	^ 75! !

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
searchIntensity
	^ 45! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 13:39'!
adjustSweep
	self sweep: self sweep * 2.! !

!NXTLineFollower2 methodsFor: 'motor control' stamp: 'mab 1/4/2009 13:39'!
driveAhead
	self motorB speed: self class motorPower.
	self motorC speed: self class motorPower.! !

!NXTLineFollower2 methodsFor: 'motor control' stamp: 'mab 1/4/2009 13:40'!
driveStraightAheadOnLine
	self driveAhead.
	[ self lightSensor intensity < self class driveIntensity ] whileTrue.
	self stop.! !

!NXTLineFollower2 methodsFor: 'executing' stamp: 'mab 1/4/2009 13:39'!
exit
	self stop.! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:48'!
findLine
	self reset.
	[ self adjustSweep.
	self tryLeft ifTrue: [ ^ self ].
	self adjustSweep.
	self tryRight ifTrue: [ ^ self ]] repeat.! !

!NXTLineFollower2 methodsFor: 'initialize-release' stamp: 'mab 1/4/2009 13:39'!
initialize
	self lightSensor: NXTLightSensor new.! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
lightSensor
	^ self environment sensorAt: self class lightSensorPort! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
lightSensor: anObject
	^ self environment sensorAt: self class lightSensorPort put: anObject! !

!NXTLineFollower2 methodsFor: 'initialize-release' stamp: 'mab 1/4/2009 13:39'!
reset
	self sweep: 2.! !

!NXTLineFollower2 methodsFor: 'executing' stamp: 'mab 3/12/2009 15:42'!
run
	| end |
	2 seconds asDelay wait.
	end := NXTTimer now + 60.
	[ self reset.
	self findLine.
	self driveStraightAheadOnLine.
	NXTTimer now >= end ifTrue: [ ^ self ].
	self buttons exit isPressed ifTrue: [ ^ self ] ] repeat.! !

!NXTLineFollower2 methodsFor: 'motor control' stamp: 'mab 1/4/2009 13:39'!
stop
	self motorB stop.
	self motorC stop.! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
sweep
	^ sweep! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
sweep: anObject
	sweep := anObject! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:48'!
tryForward: aMotor backward: anotherMotor
	anotherMotor speed: self class motorPower negated.
	aMotor speed: self class motorPower.
	aMotor rotationSensor reset.
	[ aMotor rotationSensor read < self sweep ] whileTrue: [
		self lightSensor intensity < self class searchIntensity ifTrue: [ self stop. ^ true ]].
	self stop.
	^ false! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:47'!
tryLeft
	^ self tryForward: self motorB backward: self motorC! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:47'!
tryRight
	^self tryForward: self motorC backward: self motorB! !

NXTObject subclass: #NXTLink
	instanceVariableNames: 'nextLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTLink commentStamp: 'mab 3/16/2009 03:21' prior: 0!
An instance of me is a simple record of a pointer to another NXTLink. I am an abstract class; my concrete subclasses, for example, NXTProcess, can be stored in a NXTLinkedList structure.!

NXTLink subclass: #NXTEventDescription
	instanceVariableNames: 'type value condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTEventDescription commentStamp: 'mab 3/7/2009 22:54' prior: 0!
My instances are description of certain events like a minimum radar value or a certain time. As my instances are directly used by the VM, you should not change me. Also as a result, my different meanings are encoded as small integers and not explicit subclasses as they actually should be. However, this would consume too much space and add too much complexity to the corresponding VM parts.

Instance Variables
	condition:		<NXTSmallInteger>
	type:		<NXTSmallInteger>
	value:		<NXTSmallInteger>

condition
	- At the moment, we have only two distinct conditions: 0 for greater than and 1 for less than conditions. The condition comes true and thus the event fires, if the current measured value (time, sensor, etc.) becomes greater than or less than the the value stored in this description

type
	- The type describes the kind of measurement: 0, for the system time, 1 for a specific button, 2-5 for the sensors from 1 to 4 and 6-8 for the motors A through C

value
	- The actual value expected to be used with the condition, e.g. the system time or a analog sensor value or the specific button number (see NXTButton)
!

!NXTEventDescription class methodsFor: 'types' stamp: 'mab 12/31/2008 15:06'!
button
	^ 1! !

!NXTEventDescription class methodsFor: 'instance creation' stamp: 'mab 12/31/2008 15:07'!
button: buttonNumber
	^ self new
		type: self button
		value: buttonNumber! !

!NXTEventDescription class methodsFor: 'instance creation' stamp: 'mab 1/4/2009 12:24'!
forRotationSensor: aNumber
	^ self new type: 6 + aNumber! !

!NXTEventDescription class methodsFor: 'instance creation' stamp: 'mab 12/31/2008 15:47'!
forSensor: aNumber
	^ self new type: 1 + aNumber! !

!NXTEventDescription class methodsFor: 'conditions' stamp: 'mab 12/28/2008 19:36'!
greaterThan
	^ 0! !

!NXTEventDescription class methodsFor: 'conditions' stamp: 'mab 12/31/2008 15:35'!
lessThan
	^ 1! !

!NXTEventDescription class methodsFor: 'types' stamp: 'mab 12/28/2008 19:36'!
time
	^ 0! !

!NXTEventDescription class methodsFor: 'instance creation' stamp: 'mab 12/28/2008 19:41'!
time: clockValue
	^ self new
		type: self time
		value: clockValue
		condition: self greaterThan! !

!NXTEventDescription methodsFor: 'accessing' stamp: 'mab 12/31/2008 15:49'!
condition: aCondition
	condition := aCondition! !

!NXTEventDescription methodsFor: 'accessing' stamp: 'mab 12/31/2008 15:47'!
type: aType
	type := aType.! !

!NXTEventDescription methodsFor: 'accessing' stamp: 'mab 12/31/2008 15:07'!
type: aType value: aValue
	self type: aType value: aValue condition: nil
! !

!NXTEventDescription methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:40'!
type: aType value: aValue condition: aCondition
	type := aType.
	value := aValue.
	condition := aCondition.! !

!NXTEventDescription methodsFor: 'accessing' stamp: 'mab 12/31/2008 15:47'!
value: aValue
	value := aValue.! !

!NXTLink class methodsFor: 'instance creation' stamp: 'mab 9/15/2008 17:36'!
nextLink: aLink 
	"Answer an instance of me referring to the argument, aLink."

	^self new nextLink: aLink; yourself! !

!NXTLink methodsFor: 'accessing' stamp: 'mab 9/15/2008 17:36'!
nextLink
	"Answer the link to which the receiver points."

	^nextLink! !

!NXTLink methodsFor: 'accessing' stamp: 'mab 9/15/2008 17:36'!
nextLink: aLink 
	"Store the argument, aLink, as the link to which the receiver refers. 
	Answer aLink."

	^nextLink := aLink! !

NXTLink subclass: #NXTProcess
	instanceVariableNames: 'currentFrame stack stackTopIndex waitsFor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProcess commentStamp: 'mab 3/12/2009 15:19' prior: 0!
My instances represent a running process.

Instance Variables
	currentFrame:		<NXTFrame>
	stack:		<NXTArray>
	stackTopIndex:		<NXTSmallInteger>
	waitsFor:		<NXTEvent>

currentFrame
	- The currently executed frame.

stack
	- The stack of this process.

stackTopIndex
	- The index of the topmost element on the stack.

waitsFor
	- A linked list of events, this process is waiting for.
!

!NXTProcess class methodsFor: 'instance creation' stamp: 'mab 9/16/2008 09:59'!
forContext: aContext
	| newProcess |
	newProcess := self new.
	newProcess currentFrame: aContext.
	Processor resumeProcess: newProcess.
	^ newProcess! !

!NXTProcess class methodsFor: 'constants' stamp: 'mab 9/22/2008 15:10'!
stackSize
	^ 500! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 9/12/2008 18:23'!
currentFrame
	^ currentFrame! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 9/12/2008 18:23'!
currentFrame: aContext
	currentFrame := aContext! !

!NXTProcess methodsFor: 'initializing' stamp: 'mab 9/22/2008 15:12'!
initialize
	stackTopIndex := -1.
	stack := NXTArray new: self class stackSize.! !

!NXTProcess methodsFor: 'testing' stamp: 'mab 9/15/2008 11:48'!
isRunnable
	^ self currentFrame isNil not! !

!NXTProcess methodsFor: 'testing' stamp: 'mab 12/28/2008 19:10'!
isWaiting
	^ self waitsFor isNil not! !

!NXTProcess methodsFor: 'controlling' stamp: 'mab 9/16/2008 10:07'!
resume
	Processor resumeProcess: self.! !

!NXTProcess methodsFor: 'controlling' stamp: 'mab 1/3/2009 20:26'!
return: value from: frame
	"Returns from the given frame. ASSUMES that frame is a sender of currentFrame"
	"Processor activeProcess == self ifTrue: [ self error: 'Not possible' ].
	stackTopIndex := frame stackStart + 1.
	stackTopIndex printNl.
	currentFrame := frame sender.
	self stack at: stackTopIndex + 1 put: 42."
	<NXTPrimitive: 67>! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 9/3/2008 18:11'!
stack
	^ stack! !

!NXTProcess methodsFor: 'controlling' stamp: 'mab 9/16/2008 09:49'!
suspend
	Processor suspendProcess: self.! !

!NXTProcess methodsFor: 'controlling' stamp: 'mab 1/4/2009 16:35'!
terminate
	Processor activeProcess = self ifTrue: [ self error: 'Not allowed' ].
	Processor withoutScheduling: [
		self currentFrame: nil ].! !

!NXTProcess methodsFor: 'event handling' stamp: 'mab 12/30/2008 12:28'!
waitFor: anEvent
	self waitsFor: anEvent.
	Processor addWaitingProcess: self.! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:10'!
waitsFor
	^ waitsFor! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:10'!
waitsFor: anObject
	waitsFor := anObject! !

NXTObject subclass: #NXTLookupKey
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTLookupKey commentStamp: 'mab 3/16/2009 03:22' prior: 0!
I represent a key for looking up entries in a data structure. Subclasses of me, such as Association, typically represent dictionary entries.!

NXTLookupKey subclass: #NXTAssociation
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTAssociation commentStamp: 'mab 3/16/2009 03:26' prior: 0!
I represent a pair of associated objects--a key and a value. My instances can serve as entries in a dictionary.!

!NXTAssociation class methodsFor: 'instance creation' stamp: 'mab 8/19/2008 14:00'!
key: value
	^ self key: value value: nil! !

!NXTAssociation class methodsFor: 'instance creation' stamp: 'mab 8/19/2008 13:48'!
key: aKey value: anObject
	^(super withKey: aKey) value: anObject; yourself! !

!NXTAssociation methodsFor: 'comparing' stamp: 'mab 8/15/2008 15:37'!
= anAssociation
	^super = anAssociation and: [value = anAssociation value]! !

!NXTAssociation methodsFor: 'comparing' stamp: 'mab 8/15/2008 15:37'!
hash
	^key hash bitXor: value hash! !

!NXTAssociation methodsFor: 'accessing' stamp: 'mab 8/15/2008 15:36'!
value
	^value! !

!NXTAssociation methodsFor: 'accessing' stamp: 'mab 8/15/2008 15:36'!
value: anObject
	value := anObject! !

!NXTLookupKey class methodsFor: 'instance creation' stamp: 'mab 8/15/2008 15:12'!
withKey: aKey
	^self new key: aKey; yourself! !

!NXTLookupKey methodsFor: 'comparing' stamp: 'mab 8/15/2008 15:13'!
< aLookupKey
	^key < aLookupKey key! !

!NXTLookupKey methodsFor: 'comparing' stamp: 'mab 11/17/2008 10:02'!
= aLookupKey
	self species = aLookupKey species
		ifTrue: [^key = aLookupKey key]
		ifFalse: [^false]! !

!NXTLookupKey methodsFor: 'testing' stamp: 'mab 8/15/2008 15:14'!
hash
	^key hash! !

!NXTLookupKey methodsFor: 'testing' stamp: 'mab 8/15/2008 15:10'!
isLookupKey
	^ true! !

!NXTLookupKey methodsFor: 'accessing' stamp: 'mab 8/15/2008 15:13'!
key
	^key! !

!NXTLookupKey methodsFor: 'accessing' stamp: 'mab 8/15/2008 15:36'!
key: anObject
	key := anObject! !

NXTObject subclass: #NXTMessage
	instanceVariableNames: 'selector arguments lookupClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMessage commentStamp: 'mab 3/8/2009 01:48' prior: 0!
My instances encapsulate a message sent to an object incorporating selector and arguments.

Instance Variables
	arguments:		<NXTArray>
	lookupClass:		<NXTClass>
	selector:		<NXTSymbol>

arguments
	- An array with the arguments of the message.

lookupClass
	- Usually the class, where the interpreter first searched for the selector/method.

selector
	- The selector send as this message.
!

!NXTMessage class methodsFor: 'instance creation' stamp: 'mab 8/15/2008 13:16'!
selector: aSymbol
	^ self selector: aSymbol arguments: NXTArray new! !

!NXTMessage class methodsFor: 'instance creation' stamp: 'mab 8/15/2008 13:17'!
selector: aSymbol arguments: anArray 
	"Answer an instance of me with selector, aSymbol, and arguments, 
	anArray."

	^self new selector: aSymbol arguments: anArray! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 8/15/2008 11:49'!
arguments
	^ arguments! !

!NXTMessage methodsFor: 'testing' stamp: 'mab 8/15/2008 11:49'!
isMessage
	^ true! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:49'!
lookupClass
	^ lookupClass! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:49'!
lookupClass: anObject
	lookupClass := anObject! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 8/15/2008 11:49'!
selector
	^ selector! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 8/15/2008 11:49'!
selector: aSelector arguments: args
	selector := aSelector.
	arguments := args.! !

!NXTMessage methodsFor: 'sending' stamp: 'mab 8/19/2008 18:28'!
sendTo: aReceiver
	^ self arguments
		ifNil: [ aReceiver perform: self selector ]
		ifNotNil: [ aReceiver perform: self selector withArguments: self arguments ]! !

NXTObject variableSubclass: #NXTMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMethod commentStamp: 'mab 3/8/2009 02:00' prior: 0!
My instances contain the bytecodes of a method. They are very special objects, because they are marked as a bytearray but also hold normal references to the literals of the method. Behind the usual references, my instances contain a reference to the class holding the method and to the selector of the method.

Instance Variables
!

NXTMethod variableSubclass: #NXTBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBlock commentStamp: 'mab 3/8/2009 02:42' prior: 0!
My instances represent the bytecodes of a block. They also contain the necessary literals and the header.

Instance Variables
!

!NXTMethod class methodsFor: 'instance creation' stamp: 'mab 11/20/2008 11:02'!
bytecodes: bytecodes literals: literals header: header
	| method |
	method := self newMethod: bytecodes size numLiterals: literals size.
	method header: header.
	literals doWithIndex: [ :each :index |
		method literalAt: index put: each ].
	bytecodes doWithIndex: [ :each :index |
		method at: index + method initialPC - 1 put: each ].
	^ method! !

!NXTMethod class methodsFor: 'nxt-exclude' stamp: 'mab 11/20/2008 11:03'!
bytecodes: bytecodes literals: literals numTemps: numTemps numArgs: numArgs
	^ self 
		bytecodes: bytecodes 
		literals: literals 
		header: (self calcHeaderFor: literals size numTemps: numTemps numArgs: numArgs)! !

!NXTMethod class methodsFor: 'nxt-exclude' stamp: 'mab 9/17/2008 17:17'!
calcHeaderFor: numLiterals numTemps: numTemps numArgs: numArgs
	^ ((numArgs << 9) bitOr: (numLiterals << 3)) bitOr: numTemps! !

!NXTMethod class methodsFor: 'nxt-exclude' stamp: 'mab 9/17/2008 17:06'!
calcHeaderForPrimitive: numPrim numArgs: numArgs
	^ (numArgs << 9 bitOr: 1 << 8) bitOr: numPrim! !

!NXTMethod class methodsFor: 'nxt-exclude' stamp: 'mab 9/17/2008 10:54'!
elementSize
	^ 1! !

!NXTMethod class methodsFor: 'size calculating' stamp: 'mab 9/17/2008 11:36'!
elementSizeForObjects
	^ Smalltalk isNXTalk ifTrue: [ 2 ] ifFalse: [ 1 ]! !

!NXTMethod class methodsFor: 'instance creation' stamp: 'mab 9/17/2008 17:00'!
newMethod: numBytes numLiterals: numLiterals
	^ super basicNew: self elementSizeForObjects * (1 + numLiterals) + numBytes
	! !

!NXTMethod class methodsFor: 'nxt-exclude' stamp: 'mab 9/17/2008 14:28'!
primitive: primNum numArgs: numArgs
	| method |
	method := self newMethod: 0 numLiterals: 0.
	method header: (self calcHeaderForPrimitive: primNum numArgs: numArgs).
	^ method! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 11/20/2008 11:11'!
bytecodes
	^ (NXTArray new: self numBytecodes) 
		replaceFrom: 1 
		to: self numBytecodes 
		with: self 
		startingAt: self initialPC! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/20/2008 10:54'!
computeSize
	^  (1 + self numLiterals) * 2 + self numBytecodes! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 14:32'!
endPC
	^ self size! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:53'!
header
	"Answer the word containing the information about the form of the 
	receiver and the form of the context needed to run the receiver."

	^self objectAt: 1! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 11:15'!
header: value
	^ self objectAt: 1 put: value! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 11:38'!
initialPC
	"Answer the program counter for the receiver's first bytecode."

	^ (self numLiterals + 1) * self class elementSizeForObjects + 1! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:53'!
literalAt: index 
	"Answer the literal indexed by the argument."

	^self objectAt: index + 1! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:53'!
literalAt: index put: value 
	"Replace the literal indexed by the first argument with the second 
	argument. Answer the second argument."

	^self objectAt: index + 1 put: value! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 11/17/2008 19:13'!
literals
	"Answer an Array of the literals referenced by the receiver."
	| literals numberLiterals |
	literals := NXTArray new: (numberLiterals := self numLiterals).
	1 to: numberLiterals do: [ :index |
		literals at: index put: (self literalAt: index) ].
	^ literals! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 11/6/2008 02:51'!
methodClass
	"answer the class that I am installed in"
	^ self literalAt: self numLiterals! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 10:53'!
numArgs
	"Answer the number of arguments the receiver takes."
	
	^ (self header bitShift: -9) bitAnd: 16r03! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 11/20/2008 10:48'!
numBytecodes
	^ self endPC - self initialPC + 1! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 17:09'!
numLiterals
	"Answer the number of literals used by the receiver."
	self primitive ifNotNil: [ ^ 0 ].
	^ (self header bitShift: -3) bitAnd: 16r1F! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 11/6/2008 00:13'!
numTemps
	"Answer the number of temporaries the receiver takes."
	
	^ self header bitAnd: 16r07! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 10:55'!
objectAt: index 
	<NXTPrimitive: 49>
	^ self at: index! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:55'!
objectAt: index put: value 
	<NXTPrimitive: 50>
	^ self at: index put: value! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 14:24'!
primitive
	(self header >> 8 bitAnd: 16r01) = 0 ifTrue: [ ^ nil ].
	^ self header bitAnd: 16rFF! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/17/2008 18:47'!
referencesDo: aBlock
	self literals do: [ :literal |
		aBlock value: literal ].! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 10:06'!
referencesReplace: aBlock
	1 to: self numLiterals do: [ :index |
		self literalAt: index put: (aBlock value: (self literalAt: index)) ].! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 11/9/2008 15:40'!
selector
	^ self literalAt: self numLiterals - 1.! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/24/2008 12:12'!
writeDataOn: aByteStream withImage: image
	self header writeAsReferenceOn: aByteStream within: image..
	self primitive isNil ifTrue: [
		1 to: self numLiterals do: [ :literalIndex |
			(self literalAt: literalIndex) asNXTObject 
				writeAsReferenceOn: aByteStream within: image ].
		self initialPC to: self endPC do: [ :bytecodeIndex | aByteStream 
			nextPut: (self at: bytecodeIndex) ]].! !

NXTObject subclass: #NXTMotor
	instanceVariableNames: 'number rotationSensor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:09'!
all
	^ NXTArray 
		with: (self number: 0)
		with: (self number: 1)
		with: (self number: 2)! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:55'!
number: number
	^ self new
		number: number! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:53'!
resetTachoCountFor: motorNumber
	<NXTPrimitive: 68>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:56'!
rotate: aNumber at: aSpeed
	<NXTPrimitive: 1>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 16:49'!
rotate: aMotorNumber at: speed by: degrees brakingHard: hardBrake
	<NXTPrimitive: 9>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:40'!
rotate: aMotorNumber at: speed for: milliseconds brakingHard: hardBrake
	<NXTPrimitive: 55>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:24'!
stop: motorNumber brakingHard: hardBrake
	<NXTPrimitive: 54>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:48'!
tachoCountFor: motorNumber
	<NXTPrimitive: 56>! !

!NXTMotor methodsFor: 'accessing' stamp: 'mab 7/22/2008 17:55'!
number
	^ number! !

!NXTMotor methodsFor: 'accessing' stamp: 'mab 7/22/2008 17:55'!
number: anObject
	number := anObject! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:13'!
rotateAt: speed by: degrees
	self rotateAt: speed by: degrees brakingHard: false.! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:13'!
rotateAt: speed by: degrees brakingHard: hardBrake
	self class rotate: self number at: speed by: degrees brakingHard: hardBrake.! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:04'!
rotationSensor
	^ rotationSensor ifNil: [ rotationSensor := NXTRotationSensor port: self number ]! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:56'!
speed: aNumber
	self class rotate: self number at: aNumber! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 12:49'!
stop
	self stop: true.! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:27'!
stop: hardBrake
	self class stop: self number brakingHard: hardBrake.! !

NXTObject subclass: #NXTNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTNumber commentStamp: 'mab 3/12/2009 13:43' prior: 0!
I am an abstract base class for any type of number in NXTalk.

Instance Variables
!

NXTNumber subclass: #NXTInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTInteger commentStamp: 'mab 3/12/2009 13:51' prior: 0!
I am an abstract base class for representing integers.

Instance Variables
!

!NXTInteger class methodsFor: 'instance creation' stamp: 'mab 9/8/2008 17:55'!
new: length neg: neg
	"Answer an instance of a large integer whose size is length. neg is a flag 
	determining whether the integer is negative or not."

	neg 
		ifTrue: [^NXTLargeNegativeInteger new: length]
		ifFalse: [^NXTLargePositiveInteger new: length]! !

!NXTInteger methodsFor: 'comparing' stamp: 'mab 9/8/2008 20:07'!
<= other
	^ self < other or: [ self = other ]! !

!NXTInteger methodsFor: 'comparing' stamp: 'mab 9/8/2008 20:07'!
> other
	^ (self <= other) not! !

!NXTInteger methodsFor: 'comparing' stamp: 'mab 9/8/2008 20:07'!
>= other
	^ (self < other) not! !

!NXTInteger methodsFor: 'benchmarks' stamp: 'mab 10/8/2008 18:32'!
benchFib  "Handy send-heavy benchmark"
	"(result // seconds to run) = approx calls per second"
	" | r t |
	  t _ Time millisecondsToRun: [r _ 26 benchFib].
	  (r * 1000) // t"
	"138000 on a Mac 8100/100"
	<nomacros>
	^ self < 2
		ifTrue: [1] 
		ifFalse: [(self-1) benchFib + (self-2) benchFib + 1]
! !

!NXTInteger methodsFor: 'benchmarks' stamp: 'mab 10/8/2008 18:32'!
benchmark  "Handy bytecode-heavy benchmark"
	"(500000 // time to run) = approx bytecodes per second"
	"5000000 // (Time millisecondsToRun: [10 benchmark]) * 1000"
	"3059000 on a Mac 8100/100"
 	<nomacros>   
	| size flags prime k count |
    size := 8190.
    1 to: self do:
        [:iter |
        count := 0.
		flags := nil.
        flags := (NXTArray new: size) atAllPut: true.
        1 to: size do:
            [:i | (flags at: i) ifTrue:
                [prime := i+1.
                k := i + prime.
                [k <= size] whileTrue:
                    [flags at: k put: false.
                    k := k + prime].
                count := count + 1]]].
    ^ count! !

!NXTInteger methodsFor: 'testing' stamp: 'mab 9/8/2008 17:44'!
isInteger
	"True for all subclasses of Integer."

	^ true! !

!NXTInteger methodsFor: 'converting' stamp: 'mab 10/30/2008 13:32'!
milliSeconds
	^ NXTDelay new setDelay: self! !

!NXTInteger methodsFor: 'testing' stamp: 'mab 9/8/2008 15:46'!
min: aMagnitude 
	"Answer the receiver or the argument, whichever has the lesser 
	magnitude."

	self < aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!NXTInteger methodsFor: 'converting' stamp: 'mab 10/30/2008 13:08'!
seconds
	^ NXTDelay new setDelay: self * 1000! !

!NXTInteger methodsFor: 'enumerating' stamp: 'mab 9/12/2008 15:17'!
timesRepeat: aBlock
	| todo |
	todo := self.
	[ todo > 0 ] whileTrue: [ todo := todo - 1. aBlock value ].! !

!NXTInteger methodsFor: 'benchmarks' stamp: 'mab 3/4/2009 18:22'!
tinyBenchmarks
	"Report the results of running the two tiny Squeak benchmarks.
	ar 9/10/1999: Adjusted to run at least 1 sec to get more stable results"
	"0 tinyBenchmarks"
	"On a 292 MHz G3 Mac: 22727272 bytecodes/sec; 984169 sends/sec"
	"On a 400 MHz PII/Win98:  18028169 bytecodes/sec; 1081272 sends/sec"
	| t1 t2 r n1 n2 |
	n1 := 1.
	[t1 := NXTTime millisecondsToRun: [n1 benchmark].
	t1 < 1000] whileTrue:[n1 := n1 * 2]. "Note: #benchmark's runtime is about O(n)"
	n2 := 28.
	[t2 := NXTTime millisecondsToRun: [r := n2 benchFib].
	t2 < 1000] whileTrue:[n2 := n2 + 1]. 
	"Note: #benchFib's runtime is about O(k^n),
		where k is the golden number = (1 + 5 sqrt) / 2 = 1.618...."
	self display 
		show: n1; show: '-'; "' * 500000 * 1000) // ' print. "
		show: t1; show: '.'; cr; "' bytecodes/sec; ' print."
		show: r; show: '-'; "' * 1000) // ' print."
		show: t2; show: '.'; cr. "' sends/sec ' printNl"! !

!NXTInteger methodsFor: 'intervals' stamp: 'mab 9/8/2008 19:15'!
to: stop by: step do: aBlock 
	"Normally compiled in-line, and therefore not overridable.
	Evaluate aBlock for each element of the interval (self to: stop by: 
step)."
	| nextValue |
	nextValue := self.
	step = 0 ifTrue: [self error: 'step must be non-zero'].
	step < 0
		ifTrue: [[stop <= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]
		ifFalse: [[stop >= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]! !

!NXTInteger methodsFor: 'intervals' stamp: 'mab 9/12/2008 15:15'!
to: stop do: aBlock 
	| nextValue |
	nextValue := self.
	[ nextValue <= stop ]
		whileTrue: 
			[ aBlock value: nextValue.
			nextValue := nextValue + 1 ]! !

NXTInteger variableByteSubclass: #NXTLargePositiveInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTLargePositiveInteger commentStamp: 'mab 3/12/2009 14:15' prior: 0!
My instances represent positive integers too large to be encoded as small integers. The digits are stored in the bytes of my instances and can be accessed via system primitives.

Instance Variables
!

NXTLargePositiveInteger variableByteSubclass: #NXTLargeNegativeInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTLargeNegativeInteger commentStamp: 'mab 3/12/2009 14:16' prior: 0!
I am the class to indicate negative large integers.

Instance Variables
!

!NXTLargePositiveInteger class methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 12:20'!
elementSize
	^ 1! !

!NXTLargePositiveInteger methodsFor: 'arithmetic' stamp: 'mab 9/8/2008 19:42'!
* other
	<NXTPrimitive: 43>! !

!NXTLargePositiveInteger methodsFor: 'arithmetic' stamp: 'mab 9/8/2008 19:56'!
+ other
	<NXTPrimitive: 14>! !

!NXTLargePositiveInteger methodsFor: 'arithmetic' stamp: 'mab 9/8/2008 19:55'!
- other
	<NXTPrimitive: 40>! !

!NXTLargePositiveInteger methodsFor: 'arithmetic' stamp: 'mab 9/8/2008 20:05'!
// other
	| temp n |
	temp := self.
	n := 0.
	[ temp > 0] whileTrue: [ temp := temp - other. n := n + 1 ].
	^ n! !

!NXTLargePositiveInteger methodsFor: 'comparing' stamp: 'mab 9/8/2008 16:41'!
< other
	<NXTPrimitive: 41>! !

!NXTLargePositiveInteger methodsFor: 'comparing' stamp: 'mab 9/8/2008 20:13'!
= other
	<NXTPrimitive: 44>
	^ super = other! !

!NXTLargePositiveInteger methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 13:56'!
computeSize
	^ self size! !

!NXTLargePositiveInteger methodsFor: 'system primitives' stamp: 'mab 9/8/2008 18:06'!
digitAt: index
	^ self at: index! !

!NXTLargePositiveInteger methodsFor: 'system primitives' stamp: 'mab 9/8/2008 18:06'!
digitAt: index put: object
	^ self at: index put: object! !

!NXTLargePositiveInteger methodsFor: 'system primitives' stamp: 'mab 9/8/2008 17:53'!
digitLength
	^ super size! !

!NXTLargePositiveInteger methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 13:56'!
writeDataOn: aByteStream withImage: image
	1 to: self size do: [ :index |
		aByteStream nextPut: (self at: index) asInteger ].! !

NXTInteger subclass: #NXTSmallInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSmallInteger commentStamp: 'mab 3/12/2009 14:28' prior: 0!
I have no real instances, but I am the class for integers small enough to be represented as tagged integers. Thus, these numbers between -16384 and 16383 do not consume any space in memory. Also, my methods are much faster than the ones for large integers.

Instance Variables
!

!NXTSmallInteger class methodsFor: 'constants' stamp: 'mab 9/8/2008 11:44'!
maxVal
	^ 16r3FFF! !

!NXTSmallInteger class methodsFor: 'constants' stamp: 'mab 9/8/2008 11:44'!
minVal
	^ -16r4000! !

!NXTSmallInteger methodsFor: 'arithmetic' stamp: 'mab 6/6/2008 15:40'!
* other
	<NXTPrimitive: 22>! !

!NXTSmallInteger methodsFor: 'arithmetic' stamp: 'mab 4/29/2008 15:25'!
+ other
	<NXTPrimitive: 3>! !

!NXTSmallInteger methodsFor: 'arithmetic' stamp: 'mab 6/2/2008 15:24'!
- aNumber
	<NXTPrimitive: 19>! !

!NXTSmallInteger methodsFor: 'arithmetic' stamp: 'mab 6/2/2008 15:20'!
// aNumber
	<NXTPrimitive: 18>! !

!NXTSmallInteger methodsFor: 'comparing' stamp: 'mab 5/16/2008 21:46'!
< other
	<NXTPrimitive: 11>! !

!NXTSmallInteger methodsFor: 'bit manipulation' stamp: 'mab 9/1/2008 17:50'!
<< shift
	^ self bitShift: shift! !

!NXTSmallInteger methodsFor: 'comparing' stamp: 'mab 12/15/2008 17:47'!
<= other
	<NXTPrimitive: 64>! !

!NXTSmallInteger methodsFor: 'bit manipulation' stamp: 'mab 9/1/2008 17:50'!
>> shift
	^ self bitShift: shift negated! !

!NXTSmallInteger methodsFor: 'arithmetic' stamp: 'mab 8/15/2008 18:31'!
\\ aNumber
	<NXTPrimitive: 37>! !

!NXTSmallInteger methodsFor: 'testing' stamp: 'mab 7/25/2008 14:42'!
asInteger
	^ self! !

!NXTSmallInteger methodsFor: 'randomizing' stamp: 'mab 9/12/2008 15:00'!
atRandom
	<NXTPrimitive: 24>! !

!NXTSmallInteger methodsFor: 'bit manipulation' stamp: 'mab 5/7/2008 17:38'!
bitAnd: other
	<NXTPrimitive: 8>! !

!NXTSmallInteger methodsFor: 'bit manipulation' stamp: 'mab 9/8/2008 19:14'!
bitOr: other
	<NXTPrimitive: 42>! !

!NXTSmallInteger methodsFor: 'bit manipulation' stamp: 'mab 7/22/2008 14:43'!
bitShift: shift
	<NXTPrimitive: 31>! !

!NXTSmallInteger methodsFor: 'bit manipulation' stamp: 'mab 9/11/2008 15:54'!
bitXor: other
	<NXTPrimitive: 23>! !

!NXTSmallInteger methodsFor: 'system primitives' stamp: 'mab 7/29/2008 13:11'!
digitAt: n 
	"Answer the value of an indexable field in the receiver.  LargePositiveInteger uses bytes of base two number, and each is a 'digit' base 256.  Fail if the argument (the index) is not an Integer or is out of bounds."
	n>4 ifTrue: [^ 0].
	self < 0
		ifTrue: 
			[self = NXTSmallInteger minVal ifTrue:
				["Can't negate minVal -- treat specially"
				^ #(0 0 0 64) at: n].
			^ ((0-self) bitShift: (1-n)*8) bitAnd: 16rFF]
		ifFalse: [^ (self bitShift: (1-n)*8) bitAnd: 16rFF]! !

!NXTSmallInteger methodsFor: 'system primitives' stamp: 'mab 9/8/2008 17:52'!
digitLength
	"Answer the number of indexable fields in the receiver. This value is the 
	same as the largest legal subscript. Included so that a SmallInteger can 
	behave like a LargePositiveInteger or LargeNegativeInteger."

	(self < 16r100 and: [self > -16r100]) ifTrue: [^ 1].
	^ 2
! !

!NXTSmallInteger methodsFor: 'testing' stamp: 'mab 3/4/2009 18:01'!
isSmallInteger
	^ true! !

!NXTSmallInteger methodsFor: 'testing' stamp: 'mab 5/7/2008 17:55'!
isZero
	^ self = 0! !

!NXTSmallInteger methodsFor: 'testing' stamp: 'mab 6/2/2008 15:26'!
max: aNumber
	self < aNumber
		ifTrue: [ ^ aNumber ]
		ifFalse: [ ^ self ]! !

!NXTNumber methodsFor: 'arithmetic' stamp: 'mab 9/8/2008 17:42'!
negated
	"Answer a Number that is the negation of the receiver."

	^0 - self! !

!NXTNumber methodsFor: 'testing' stamp: 'mab 9/8/2008 17:42'!
negative
	"Answer whether the receiver is mathematically negative."

	^ self < 0! !

!NXTObject class methodsFor: 'nxt-exclude' stamp: 'mab 3/4/2009 16:12'!
elementSize
	"Return the element size for instances of this class."
	^ 2! !

!NXTObject class methodsFor: 'class initialization' stamp: 'mab 3/4/2009 16:12'!
initialize
	"Initialize this class."! !

!NXTObject methodsFor: 'associating' stamp: 'mab 2/23/2009 10:09'!
-> anObject
	"Create an association between myself and anObject"
	^ NXTAssociation key: self value: anObject! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 2/23/2009 10:09'!
= other
	"Answer whether the receiver and the argument represent the same 
	object. If = is redefined in any subclass, consider also redefining the 
	message hash."
	^ self == other! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 2/23/2009 10:11'!
== other
	"Primitive. Answer whether the receiver and the argument are the same 
	object (have the same object pointer)."
	<NXTPrimitive: 7>
	^ self == other! !

!NXTObject methodsFor: 'converting' stamp: 'mab 2/23/2009 10:11'!
asNXTObject
	"I am already an NXTObject, return myself."
	^ self! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 2/23/2009 10:12'!
at: anInteger
	"Primitive. Access a slot of the object starting with the instance variables."
	<NXTPrimitive: 20>
	^ super at: anInteger! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 2/23/2009 10:13'!
at: anInteger put: anObject
	"Primitive. Modify a slot of the object starting with the instance variables."
	<NXTPrimitive: 21>
	^ super at: anInteger put: anObject! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:14'!
buttons
	"Shortcut for accessing the NXT's button panel."
	^ self environment buttons! !

!NXTObject methodsFor: 'class membership' stamp: 'mab 2/23/2009 10:14'!
class
	"Primitive. Return the receiver's class."
	<NXTPrimitive: 12>! !

!NXTObject methodsFor: 'class membership' stamp: 'mab 2/23/2009 10:14'!
class: anNXTClass
	"Primitive. Modify the receiver's class. USE WITH CAUTION!!"
	<NXTPrimitive: 63>! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:15'!
computeSize
	"Not compiled for NXT. Used by the compiler to compute the size of an object."
	^ self class allInstVarNames size! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:15'!
display
	"Shortcut to access the NXT's display."
	^ self environment display! !

!NXTObject methodsFor: 'error handling' stamp: 'mab 10/3/2008 22:48'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"

	NXTMessageNotUnderstood new 
		message: aMessage;
		receiver: self;
		signal.
	^ aMessage sentTo: self.
! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:16'!
environment
	"Returns the environment (e.g. system dictionary) of the running system."
	^ self class environment! !

!NXTObject methodsFor: 'error handling' stamp: 'mab 2/23/2009 10:17'!
error: aString
	"Throw a generic Error exception."
	NXTError signal: aString.
	! !

!NXTObject methodsFor: 'error handling' stamp: 'mab 2/23/2009 10:20'!
halt
	"For now, this message is used to call a primitive in the VM, which can be 
	breakpointed by a VM debugger. It does not, as might be expected, set a Smalltalk
	breakpoint, as remote-debugging for NXTalk is currently not available."
	<NXTPrimitive: 34>
	super halt.! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 2/23/2009 10:20'!
hash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	May be overridden, and should be overridden in any classes that define = "
	^ self identityHash! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 2/23/2009 10:21'!
identityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	Primitive. Fails if the receiver is a SmallInteger. Essential.
	See Object documentation whatIsAPrimitive.

	Do not override."
	<NXTPrimitive: 36>
	^ super identityHash! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:25'!
identityHashReplacement
	"This method is necessary for the compiler in order to temporarily
	provide an #identityHash method, which returns the correct NXTalk
	identityHash instead of the Squeak one."
	^ #literal hashFor: self! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:26'!
ifNil: aBlock
	"Return self, or evaluate the block if I'm == nil (q.v.)"
	^ self! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:27'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block, unless I'm == nil (q.v.)"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'testing' stamp: 'mab 10/3/2008 21:41'!
ifNotNil: ifNotNilBlock
	"If I got here, I am not nil, so evaluate the block ifNotNilBlock"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:26'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am not nil, so evaluate the block ifNotNilBlock"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'initialize-release' stamp: 'mab 2/23/2009 10:26'!
initialize
	"Subclasses should redefine this method to perform initializations on instance creation"! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 2/23/2009 10:29'!
instVarAt: anInteger
	"Primitive. Access a slot of the object starting with the instance variables."
	<NXTPrimitive: 20>
	^ super instVarAt: anInteger! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 2/23/2009 10:29'!
instVarAt: anInteger put: anObject
	"Primitive. Modify a slot of the object starting with the instance variables."
	<NXTPrimitive: 21>
	^ super instVarAt: anInteger put: anObject! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:32'!
isClass
	"Answers, whether the receiver is a class object."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:33'!
isClassProxy
	"Answers, whether the receiver is a proxy for a class object."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:33'!
isDictionary
	"Answers, whether the receiver is a dictionary."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 14:22'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."

	self class == aClass
		ifTrue: [^true]
		ifFalse: [^self class inheritsFrom: aClass]! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:33'!
isLookupKey
	"Answers, whether the receiver is a NXTLookupKey instance,"
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:34'!
isMessage
	"Answers, whether the receiver is an instance of NXTMessage."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:36'!
isMeta
	"Answers, whether the receiver is a metaclass object."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:37'!
isNXTObject
	"Answers, whether the receiver is an NXTObject. True for all objects on the NXT."
	^ true! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:37'!
isNil
	"Coerces nil to true and everything else to false."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:38'!
isSet
	"Answers, whether the receiver is a set."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 3/4/2009 18:41'!
isSmallInteger
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:38'!
isString
	"Answers, whether the receiver is a string."
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 2/23/2009 10:38'!
isSymbol
	"Answers, whether the receiver is a symbol."
	^ false! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:38'!
motorA
	"Shortcut for accessing motor A."
	^ self environment motorA! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:39'!
motorB
	"Shortcut for accessing motor B."
	^ self environment motorB! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:39'!
motorC
	"Shortcut for accessing motor C."
	^ self environment motorC! !

!NXTObject methodsFor: 'system primitives' stamp: 'mab 2/23/2009 10:40'!
nextInstance
	"Primitive. Returns the next object in object memory having the same class."
	<NXTPrimitive: 29>! !

!NXTObject methodsFor: 'message handling' stamp: 'mab 2/23/2009 10:47'!
perform: aSymbol
	"Primitive. Send the unary selector, aSymbol, to the receiver.
	Fail if the number of arguments expected by the selector is not zero."
	<NXTPrimitive: 25>
	^ super perform: aSymbol! !

!NXTObject methodsFor: 'message handling' stamp: 'mab 2/23/2009 10:49'!
perform: aSymbol with: anObject
	"Primitive. Send the selector, aSymbol, to the receiver and use one argument.
	Fail if the number of arguments expected by the selector is not one."
	<NXTPrimitive: 25>
	^ super perform: aSymbol with: anObject! !

!NXTObject methodsFor: 'message handling' stamp: 'mab 2/23/2009 10:49'!
perform: aSymbol withArguments: anArray
	"Primitive. Send the selector, aSymbol, to the receiver and use the objects in anArray as arguments.
	Fail if the number of arguments expected by the selector is other than anArray size."
	<NXTPrimitive: 38>
	^ super perform: aSymbol withArguments: anArray! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:51'!
referencesDo: aBlock
	"Not compiled for the NXT. Iterates over all references this object has."
	self class allInstVarNames do: [ :instVarName |
		aBlock value: (self instVarNamed: instVarName) ]! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:51'!
referencesReplace: aBlock
	"Not compiled for the NXT. Iterates over all references this object has and uses 
	aBlock's value to replace the reference with a new value."
	self class allInstVarNames do: [ :instVarName |
		self instVarNamed: instVarName put: (aBlock value: (self instVarNamed: instVarName)) ].
! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:52'!
sensorAt: port
	"Shortcut for accessing one of the sensors."
	^ self environment sensors at: port! !

!NXTObject methodsFor: 'environment' stamp: 'mab 2/23/2009 10:52'!
sensorAt: port put: sensor
	"Shortcut for modifying one of the sensors."
	^ self environment sensorAt: port put: sensor! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 2/23/2009 10:53'!
size
	"Answer the number of slots in the receiver."
	<NXTPrimitive: 17>
	^ super size! !

!NXTObject methodsFor: 'environment' stamp: 'mab 3/12/2009 17:24'!
speaker
	^ self environment speaker! !

!NXTObject methodsFor: 'private' stamp: 'mab 2/23/2009 10:55'!
species
	"Answer the preferred class for reconstructing the receiver.  For example, 
	collections create new collections whenever enumeration messages such as 
	collect: or select: are invoked.  The new kind of collection is determined by 
	the species of the original collection.  Species and class are not always the 
	same.  For example, the species of Interval is Array."
	^ self class! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:55'!
subclassResponsibility
	"This message sets up a framework for the behavior of the class' subclasses.
	Announce that the subclass should have implemented this message."
	self error: 'My subclass should have overridden ', thisContext sender selector asString! !

!NXTObject methodsFor: 'evaluating' stamp: 'mab 2/23/2009 10:56'!
value
	"Evaluate this object."
	^ self! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:57'!
writeAsReferenceOn: aByteStream within: image
	"Not compiled for the NXT. Used by the compiler to write a reference to 
	this object into an image bytestream."
	aByteStream littleEndianWord: (((image objectTable idFor: self) bitShift: 1) bitOr: 1)! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:57'!
writeClassOn: aByteStream withImage: image
	"Not compiled for the NXT. Used by the compiler to write the class 
	reference for this object into an image bytestream."
	| class |
	class := image metaclasses at: self ifAbsent: [ image classes at: self class name asSymbol ].
	class writeAsReferenceOn: aByteStream within: image.! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:58'!
writeDataOn: aByteStream withImage: image
	"Not compiled for the NXT. Used by the compiler to write the receiver's
	data into an image bytestream."
	self referencesDo: [ :object |
		object writeAsReferenceOn: aByteStream within: image ].! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 10:59'!
writeOn: aByteStream withImage: image
	"Not compiled for the NXT. Used by the compiler to write a complete object
	into an image bytestream."
	self writeClassOn: aByteStream withImage: image.
	self class isVariable ifTrue: [ self writeSizeOn: aByteStream ].
	self writeDataOn: aByteStream withImage: image.! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 2/23/2009 11:00'!
writeSizeOn: aByteStream
	"Not compiled for the NXT. Used by the compiler to write the receiver's size
	into a bytestream."
	aByteStream littleEndianWord: self computeSize.! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 2/23/2009 11:00'!
yourself
	"Answer self."
	^ self! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 7/25/2008 19:09'!
~= anObject 
	"Answer whether the receiver and the argument do not represent the 
	same object."

	^self = anObject == false! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 9/8/2008 18:18'!
~~ anObject
	"Answer whether the receiver and the argument are not the same object 
	(do not have the same object pointer)."

	self == anObject
		ifTrue: [^ false]
		ifFalse: [^ true]! !

NXTObject subclass: #NXTPackage
	instanceVariableNames: 'name entrypoint classes metaclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTPackage commentStamp: 'mab 3/16/2009 03:50' prior: 0!
My instances contain data to represent a package ready to be transfered to the NXT.

Instance Variables
	classes:		<NXTDictionary>
	entrypoint:		<NXTAssociation>
	metaclasses:		<NXTDictionary>
	name:		<NXTSymbol>

classes
	- A dictionary with all the classes the package contains.

entrypoint
	- An association from the class name to the method name of the applications entrypoint. Nil, if this is a library.

metaclasses
	- A dictionary mapping from the contained classes to the metaclasses. Necessary, because in Squeak, NXT classes are instances of NXTClass instead of their own metaclass.

name
	- The name of the package.
!

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 14:34'!
classes
	^ classes! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:00'!
entrypoint
	^ entrypoint! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:44'!
entrypoint: anObject
	entrypoint := anObject! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 11:21'!
initialize
	classes := NXTDictionary new.
	metaclasses := NXTDictionary new.! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:00'!
isApplication
	^ self entrypoint isNil not! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:00'!
isLibrary
	^ self entrypoint isNil! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 14:34'!
metaclasses
	^ metaclasses! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 15:20'!
name
	^ name! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 15:19'!
name: anObject
	name := anObject.! !

NXTObject subclass: #NXTPackageDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTPackageDescription commentStamp: 'mab 3/16/2009 03:55' prior: 0!
My subclasses represent textual package descriptions and can be used to build NXTPackages, which can be transfered to the NXT. At the moment, I only include a list of classes and a package name.!

NXTPackageDescription subclass: #NXTApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTApplication commentStamp: 'mab 3/16/2009 03:56' prior: 0!
My subclasses represent textual description of application packages for the NXT. They can be used to build real packages ready to be transfered to the NXT.!

NXTApplication subclass: #NXSnakeApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSnakeApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:31'!
classes
	^ #(NXSBoard NXSBoardView NXSElement NXSApple NXSnakeElement NXSnake)! !

!NXSnakeApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:32'!
entrypoint
	^ #NXSnake -> #run! !

!NXSnakeApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:31'!
name
	^ 'Snake'! !

!NXTApplication methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:13'!
entrypoint
	^ self subclassResponsibility! !

!NXTApplication methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:13'!
isApplication
	^ true! !

NXTApplication subclass: #NXTBenchmarkApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBenchmarkApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:52'!
classes
	^ #(NXTBenchmark)! !

!NXTBenchmarkApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:52'!
entrypoint
	^ #NXTBenchmark -> #run! !

!NXTBenchmarkApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:54'!
name
	^ 'Tiny Benchmark'! !

NXTApplication subclass: #NXTBluetoothTesterApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBluetoothTesterApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:17'!
classes
	^ #(NXTBluetoothTester #NXTDriver)! !

!NXTBluetoothTesterApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:14'!
entrypoint
	^ #NXTBluetoothTester -> #run! !

!NXTBluetoothTesterApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:14'!
name
	^ 'Bluetooth'! !

NXTApplication subclass: #NXTDemoApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDemoApp methodsFor: 'as yet unclassified' stamp: 'mab 11/27/2008 10:51'!
classes
	^ #(NXTDemo)! !

!NXTDemoApp methodsFor: 'as yet unclassified' stamp: 'mab 11/27/2008 10:51'!
entrypoint
	^ #NXTDemo -> #run! !

!NXTDemoApp methodsFor: 'as yet unclassified' stamp: 'mab 11/27/2008 10:51'!
name
	^ 'Explorer'! !

NXTApplication subclass: #NXTLineFollowerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollowerApp methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:44'!
classes
	^ #(NXTLineFollower)! !

!NXTLineFollowerApp methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:44'!
entrypoint
	^ #NXTLineFollower -> #run! !

!NXTLineFollowerApp methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:44'!
name
	^ 'Line Follower'! !

NXTApplication subclass: #NXTLineFollowerApp2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollowerApp2 methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
classes
	^ #(NXTLineFollower2)! !

!NXTLineFollowerApp2 methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
entrypoint
	^ #NXTLineFollower2 -> #run! !

!NXTLineFollowerApp2 methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:47'!
name
	^ 'Line Follower2'! !

NXTApplication subclass: #NXTTestRunnerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTTestRunnerApp methodsFor: 'as yet unclassified' stamp: 'mab 3/5/2009 16:45'!
classes
	^ (PackageInfo named: 'NXTalk-ST-Tests') classes select: [ :class | class ~= self class ] thenCollect: [ :class | class name ]! !

!NXTTestRunnerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:55'!
entrypoint
	^ #NXTTestRunner -> #run! !

!NXTTestRunnerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:53'!
name
	^ 'Test Runner'! !

NXTApplication subclass: #NXTThreadTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTThreadTestApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:37'!
classes
	^ #(NXTThreadTest)! !

!NXTThreadTestApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:38'!
entrypoint
	^ #NXTThreadTest -> #run! !

!NXTThreadTestApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:38'!
name
	^ 'Thread Test'! !

NXTApplication subclass: #NXTUsbManagerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTUsbManagerApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 18:17'!
classes
	^ #(NXTUsbManager NXTDriver)! !

!NXTUsbManagerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:05'!
entrypoint
	^ #NXTUsbManager -> #run! !

!NXTUsbManagerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:43'!
name
	^ 'USB Transfer'! !

NXTPackageDescription subclass: #NXTLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTLibrary commentStamp: 'mab 3/16/2009 03:57' prior: 0!
My subclasses represent textual description of library packages for the NXT. They can be used to build real packages ready to be transfered to the NXT.!

NXTLibrary subclass: #NXTBaseLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTBaseLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:55'!
baseCategories
	^ #('NXTalk-ST-Kernel' 'NXTalk-ST-Collections' 'NXTalk-ST-Hardware')! !

!NXTBaseLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 11:47'!
classes
	| classes |
	classes := OrderedCollection new.
	self baseCategories do: [ :category |
		classes addAll: ((PackageInfo named: category) classes collect: [ :class | class name ]) ].
	^ classes , #(NXTSystem NXTPackageManager NXTPackage)! !

!NXTBaseLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 16:31'!
name
	^ 'System Library'! !

!NXTLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:25'!
isLibrary
	^ true! !

NXTLibrary subclass: #NXTStreamLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTStreamLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:46'!
classes
	^ (PackageInfo named: 'NXTalk-ST-Streams') classes collect: [ :class | class name ]! !

!NXTStreamLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:45'!
name
	^ 'Stream Library'! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:18'!
classes
	"All classes to include for deployment on the NXT"
	^ NXTArray new! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:13'!
isApplication
	^ false! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:18'!
isLibrary
	^ false! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:46'!
name
	^ self subclassResponsibility! !

NXTObject subclass: #NXTPackageManager
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

NXTPackageManager class
	instanceVariableNames: 'default'!

!NXTPackageManager commentStamp: 'mab 3/16/2009 03:58' prior: 0!
My instances (and on the NXT sole instance) are used to manage installed packages. Packages can be installed or removed, etc.

Instance Variables
	packages:		<NXTOrderedCollection>

packages
	- The list of installed packages.
!

NXTPackageManager class
	instanceVariableNames: 'default'!

!NXTPackageManager class methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:46'!
default
	^ default ifNil: [ default := self new ]! !

!NXTPackageManager class methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:45'!
default: aDefaultPackageManager
	default := aDefaultPackageManager.! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:43'!
applications
	^ self packages select: [ :package | package isApplication ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 3/5/2009 17:21'!
installClass: class andMetaclass: metaclass
	Smalltalk at: class name ifPresent: [ :oldClass | Smalltalk removeClass: oldClass ].
	class class: metaclass.
	Smalltalk addClass: class.
	class initialize! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 3/5/2009 17:42'!
installPackage: aPackage
	Smalltalk isNXTalk ifFalse: [ self error: 'Package can only be installed on the NXT' ].
	aPackage classes rehash.
	aPackage metaclasses rehash.
	(self packages anySatisfy: [ :package | package name = aPackage name ]) ifTrue: [ self removePackage: aPackage name ].
	aPackage classes valuesDo: [ :class |
		self installClass: class andMetaclass: (aPackage metaclasses at: class) ].
	self packages add: aPackage.! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 16:39'!
libaries
	^ self packages select: [ :package | package isLibrary ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:41'!
packageNames
	^ self packages collect: [ :package | package name ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:25'!
packages
	^ packages ifNil: [ packages := NXTOrderedCollection new ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 3/5/2009 17:47'!
removePackage: aPackageName
	| package |
	package := self packages detect: [ :pkg | pkg name = aPackageName ].
	package ifNil: [ self error: 'Package not found' ].
	package classes valuesDo: [ :class |
		Smalltalk removeClass: class ].
	self packages remove: package.! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 19:02'!
test
	^ 'cool'! !

NXTObject subclass: #NXTProxy
	instanceVariableNames: 'dataStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProxy commentStamp: 'mab 3/12/2009 16:44' prior: 0!
A NXTProxy is message capturing entity, which represent an object at the other end of a stream. Messages are forwarded to it over the stream by serializing them. A dispatcher at the other end has to deserialize the messages and forward them to the local objects.

Instance Variables
	dataStream:		<NXTDataStream>

dataStream
	- The data stream, which shall be used.
!

!NXTProxy class methodsFor: 'instance creation' stamp: 'mab 11/14/2008 16:57'!
on: aDataStream
	^ self new dataStream: aDataStream! !

!NXTProxy methodsFor: 'accessing' stamp: 'mab 11/13/2008 15:37'!
dataStream
	^ dataStream! !

!NXTProxy methodsFor: 'accessing' stamp: 'mab 11/13/2008 15:37'!
dataStream: anObject
	dataStream := anObject! !

!NXTProxy methodsFor: 'error handling' stamp: 'mab 11/14/2008 16:59'!
doesNotUnderstand: aMessage
	self dataStream nextPut: aMessage asNXTObject.
	self dataStream flush.
	^ self dataStream next! !

NXTObject subclass: #NXTSensor
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

NXTSensor subclass: #NXTLightSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:44'!
intensity
	^ self mapFrom: self read! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:43'!
mapFrom: aValue
	^ 700 - aValue // 3! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:44'!
mapTo: aValue
	^ 700 - (aValue * 3)! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:27'!
onDarkerThan: aValue do: aBlock
	| ownerFrame ownerProcess |
	ownerFrame := thisContext sender.
	ownerProcess := Processor activeProcess.
	^ [ self waitUntilAbove: (self mapTo: aValue). 
		Processor withoutScheduling: [
			aBlock onNonLocalReturnsDo: [ :value | ownerProcess return: value from: ownerFrame. ownerProcess resume ]]] fork! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:45'!
waitUntilLighterThan: aValue
	self waitUntilBelow: (self mapTo: aValue).! !

NXTSensor subclass: #NXTRadar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:59'!
disable: portNumber
	<NXTPrimitive: 58>! !

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:54'!
distance: portNumber ofObject: objectNumber
	<NXTPrimitive: 59>! !

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:59'!
enable: portNumber
	<NXTPrimitive: 57>! !

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:56'!
isRadar: portNumber
	<NXTPrimitive: 60>! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 14:19'!
distance
	^ self distanceOfObject: 0! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 14:23'!
distanceOfObject: objectNumber
	^ self class distance: self port ofObject: objectNumber! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 14:32'!
enable
	super enable.
	"(self class isRadar: self port) ifFalse: [ self error: 'No radar at this port' ]."! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 15:06'!
isWithin: distance
	| value |
	value := self distance.
	^ value > 0 and: [ value <= distance ]! !

NXTSensor subclass: #NXTRotationSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTRotationSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:08'!
read
	^ NXTMotor tachoCountFor: self port! !

!NXTRotationSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:54'!
reset
	NXTMotor resetTachoCountFor: self port! !

!NXTRotationSensor methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 22:35'!
waitDegrees: aNumber 
	| event |
	self reset.
	event := NXTEventDescription forRotationSensor: self port.
	event value: aNumber.
	event condition: NXTEventDescription greaterThan.
	Processor activeProcess waitFor: event! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 16:06'!
disable: number
	<NXTPrimitive: 61>! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:57'!
enable: number
	<NXTPrimitive: 30>! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:09'!
port: aNumber
	^ self new port: aNumber! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:58'!
read: number
	<NXTPrimitive: 53>! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:59'!
disable
	self class disable: self port.! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:02'!
enable
	self class enable: self port.! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:16'!
port
	^ port! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:01'!
port: aNumber
	port := aNumber! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:02'!
read
	^ self class read: self port! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 22:35'!
waitUntilAbove: aValue 
	| event |
	event := NXTEventDescription forSensor: self port.
	event value: aValue.
	event condition: NXTEventDescription greaterThan.
	Processor activeProcess waitFor: event! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 22:35'!
waitUntilBelow: aValue 
	| event |
	event := NXTEventDescription forSensor: self port.
	event value: aValue.
	event condition: NXTEventDescription lessThan.
	Processor activeProcess waitFor: event! !

NXTSensor subclass: #NXTSound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

NXTSensor subclass: #NXTTouchSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTTouchSensor methodsFor: 'as yet unclassified' stamp: 'mab 3/7/2009 10:33'!
waitUntilPressed
	^ self waitUntilBelow: 800! !

NXTObject subclass: #NXTSpeaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTSpeaker methodsFor: 'as yet unclassified' stamp: 'mab 3/12/2009 17:04'!
asyncToneAt: frequency for: duration
	<NXTPrimitive: 82>! !

!NXTSpeaker methodsFor: 'as yet unclassified' stamp: 'mab 3/12/2009 17:38'!
click
	self asyncToneAt: 500 for: 100.! !

!NXTSpeaker methodsFor: 'as yet unclassified' stamp: 'mab 3/12/2009 17:03'!
toneAt: frequency for: duration
	<NXTPrimitive: 81>! !

NXTObject subclass: #NXTStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

NXTStream subclass: #NXTDataStream
	instanceVariableNames: 'byteStream readObjects writtenObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTDataStream commentStamp: 'mab 3/16/2009 03:59' prior: 0!
I represent a stream capable of serializing objects to an underlying byte stream.

Instance Variables
	byteStream:		<Object>
	readObjects:		<Object>
	writtenObjects:		<Object>

byteStream
	- xxxxx

readObjects
	- xxxxx

writtenObjects
	- xxxxx
!

!NXTDataStream class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 18:45'!
on: aStream
	^ self new setStream: aStream! !

!NXTDataStream class methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:04'!
typeIDs
	^ #(#NXTSymbol #NXTString #NXTSmallInteger #NXTArray #NXTUndefinedObject #NXTClassProxy #XYZBackReference 
		#NXTMethod #NXTBlock)! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 16:29'!
beginInstance: aClass size: size
	self writeSmallInteger: size.
	self writeSymbol: aClass name.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 14:31'!
classNameFor: anObject
	| name |
	name := anObject class name.
	(name beginsWith: 'NXT') ifFalse: [ name := 'NXT', name ].
	^ name asSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:58'!
close
	^ byteStream close! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/30/2008 11:07'!
flush
	^ byteStream flush! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/24/2008 13:17'!
methodNameFor: anObject
	^ ('write', ((self classNameFor: anObject) allButFirst: 3)) asSymbol asMutator! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 3/2/2009 20:39'!
next
	| type selector |
	type := byteStream next.
	type isZero ifTrue: [ ^ self readInstance ].
	selector := ('read', ((self class typeIDs at: type) allButFirst: 3)) asSymbol.
	^ self perform: selector.
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:24'!
nextPut: anObject
	| nxtObject typeID |
	nxtObject := anObject asNXTObject.
	typeID := self typeIDFor: nxtObject.
	byteStream nextPut: typeID.
	typeID = 7 ifTrue: [ ^ self writeBackReference: nxtObject ].
	typeID isZero 
		ifTrue: [ self writeInstance: nxtObject ]
		ifFalse: [ self perform: (self methodNameFor: nxtObject) with: nxtObject ].
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:46'!
readArray
	| size |
	size := byteStream int16.
	^ self next: size! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:11'!
readBackReference
	^ self readObjects at: self readSmallInteger! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:28'!
readBlock
	^ self readCallable: NXTBlock
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:28'!
readCallable: class
	| header literals bytecodes |
	header := byteStream int16.
	literals := NXTOrderedCollection new.
	bytecodes := NXTOrderedCollection new.
	byteStream int16 timesRepeat: [ literals add: self next ].
	byteStream int16 timesRepeat: [ bytecodes add: byteStream next ].
	^ class bytecodes: bytecodes literals: literals header: header
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/22/2008 17:43'!
readClassProxy
	| name |
	name := self readSymbol.
	name = #Smalltalk ifTrue: [ ^ Smalltalk ].
	name = #Processor ifTrue: [ ^ Processor ].
	^ Smalltalk classNamed: name! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 3/9/2009 14:25'!
readInstance
	| instSize newClass anObject className |
	instSize := self readSmallInteger.
	className := self readSymbol.
	newClass := Smalltalk at: className ifAbsent: [ 
		self display show: className size. self display show: ','. self display show: byteStream inputBufferPos. NXTButton waitForAnyKey ].
	anObject := newClass basicNew.
	self readObjects add: anObject.
	1 to: instSize do: [ :i |
		anObject instVarAt: i put: self next ].
	^ anObject! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:28'!
readMethod
	^ self readCallable: NXTMethod! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:09'!
readObjects
	^ readObjects ifNil: [ readObjects := NXTOrderedCollection new ]! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:11'!
readSmallInteger
	^ byteStream int16! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 20:09'!
readString
	^ byteStream nextString! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:22'!
readSymbol
	^ self readString asSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 16:10'!
readUndefinedObject
	^ nil! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 20:02'!
reset
	byteStream reset! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 18:45'!
setStream: aStream
	aStream binary.
	byteStream := aStream.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:15'!
typeIDFor: anObject
	self writtenObjects at: anObject ifAbsent: [
		^ self class typeIDs indexOf: (self classNameFor: anObject) ].
	^ self class typeIDs indexOf: #XYZBackReference! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 18:13'!
writeArray: array
	byteStream int16: array size.
	self nextPutAll: array.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:16'!
writeBackReference: anObject
	self writeSmallInteger: (self writtenObjects at: anObject).
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:07'!
writeBlock: block
	self writeMethod: block! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 16:56'!
writeClassProxy: aClassProxy
	self writeSymbol: aClassProxy name! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:16'!
writeInstance: anObject
	| instVarCount |
	self writtenObjects at: anObject put: (self writtenObjects size + 1).
	instVarCount := anObject class instSize.
	self beginInstance: anObject class size: instVarCount.
	1 to: instVarCount do: [ :i |
		self nextPut: (anObject instVarAt: i) ].
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:06'!
writeMethod: method
	byteStream int16: method header.
	byteStream int16: method numLiterals.
	method literals do: [ :literal | self nextPut: literal ].
	byteStream int16: method numBytecodes.
	method bytecodes do: [ :bytecode | byteStream nextPut: bytecode ].! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:11'!
writeSmallInteger: int
	byteStream int16: int.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:32'!
writeString: aString
	byteStream nextStringPut: aString! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/24/2008 13:17'!
writeSymbol: aSymbol
	self writeString: aSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 16:10'!
writeUndefinedObject: anObject
	"Nothing to be done here,"! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 2/19/2009 15:53'!
writtenObjects
	^ writtenObjects ifNil: [ writtenObjects := NXTIdentityDictionary new ]! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:41'!
ascii
	"NXT streams are always binary for now"! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:41'!
binary
	"NXT streams are always binary for now"! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:57'!
close! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 16:53'!
next: count
	| array |
	array := NXTArray new: count.
	1 to: count do: [ :i |
		array at: i put: self next ].
	^ array! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:58'!
nextPutAll: aCollection
	aCollection do: [ :each |
		self nextPut: each ].! !

NXTStream subclass: #NXTUsbStream
	instanceVariableNames: 'inputBuffer inputBufferPos outputBuffer outputBufferPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

NXTUsbStream subclass: #NXTBluetoothStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTBluetoothStream methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 16:52'!
fillInputBuffer
	inputBuffer := NXTBluetooth read.
	! !

!NXTBluetoothStream methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 16:43'!
flush
	NXTBluetooth write: (outputBuffer copyFrom: 1 to: outputBufferPos - 1).
	[ NXTBluetooth isDataWritten ] whileFalse.
	self reset.! !

!NXTBluetoothStream methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 16:48'!
readPacket
	| buffer |
	buffer := NXTString new: 64.
	^ buffer copyFrom: 1 to: (self readPacketInto: buffer)
	! !

!NXTBluetoothStream methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 16:48'!
readPacketInto: buffer
	NXTBluetooth readInto: buffer.
	[ NXTBluetooth dataRead isZero ] whileTrue.
	[ NXTBluetooth dataRead = NXTBluetooth dataRead ] whileFalse.
	^ NXTBluetooth dataRead
	! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 11:29'!
fillInputBuffer
	inputBuffer := NXTUsb read.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:13'!
flush
	NXTUsb send: (outputBuffer copyFrom: 1 to: outputBufferPos - 1).
	self reset.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:40'!
initialize
	outputBuffer := NXTString new: 64.
	outputBufferPos := 1.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 3/9/2009 14:24'!
inputBufferPos
	^ inputBufferPos! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:57'!
int16
	"Answer the next signed, 16-bit integer from this (binary) stream."

	| n |
	n := self next.
	n := (n bitShift: 8) + (self next).
	"n >= 16r8000 ifTrue: [n := n - 16r10000]."
	^ n! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 11:52'!
int16: anInteger
	"Store the given signed, 16-bit integer on this (binary) stream."

	| n |
	"(anInteger < -16r8000) | (anInteger >= 16r8000)
		ifTrue: [self error: 'outside 16-bit integer range'].

	anInteger < 0
		ifTrue: [n := 16r10000 + anInteger]
		ifFalse: [n := anInteger]."
	n := anInteger.
	self nextPut: (n digitAt: 2).
	self nextPut: (n digitAt: 1).
! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 16:44'!
next
	| value |
	(inputBuffer isNil or: [ inputBufferPos > inputBuffer size ]) ifTrue: [
		self fillInputBuffer.
		inputBufferPos := 1 ].
	value := inputBuffer at: inputBufferPos.
	inputBufferPos := inputBufferPos + 1.
	^ value! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:12'!
nextPut: anInteger
	outputBuffer at: outputBufferPos put: anInteger.
	(outputBufferPos := outputBufferPos + 1) > NXTUsb packetSize ifTrue: [
		self flush ].! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 17:29'!
nextString
	"Read a string from the receiver. The first byte is the length of the string, unless it is greater than 192, in which case the first four bytes encode the length.  I expect to be in ascii mode when called (caller puts back to binary)."

	| length aByteArray |

	"read the length in binary mode"
	self binary.
	length := self next.		"first byte."
	length >= 192 ifTrue: [length := length - 192.
		1 to: 3 do: [:ii | length := length * 256 + self next]].
	aByteArray := NXTString new: length.

	1 to: length do: [ :i | aByteArray at: i put: self next ].
	^aByteArray asString.
! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 18:14'!
nextStringPut: s 
	"Append the string, s, to the receiver.  Only used by DataStream.  Max size of 64*256*256*256."

	| length |
	(length := s size) < 192
		ifTrue: [self nextPut: length]
		ifFalse: 
			[self nextPut: (length digitAt: 4)+192.
			self nextPut: (length digitAt: 3).
			self nextPut: (length digitAt: 2).
			self nextPut: (length digitAt: 1)].
	self nextPutAll: s.
	^s! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:12'!
reset
	outputBufferPos := 1.! !

NXTObject subclass: #NXTSystem
	instanceVariableNames: 'programs selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSystem commentStamp: 'mab 3/12/2009 16:54' prior: 0!
My instance is capable of showing a menu of installed applications and lets the user choose, which the system shall execute. Thus, it manages the user interface at a basic level.

Instance Variables
	programs:		<NXTOrderedCollection>
	selected:		<NXTSmallInteger>

programs
	- List of installed programs.

selected
	- Index of the currently selected program.
!

!NXTSystem methodsFor: 'executing' stamp: 'mab 3/4/2009 19:20'!
execute: application
	self display clear.
	(Smalltalk at: application entrypoint key) new perform: application entrypoint value.
	self display show: ('Finished ', application name, '. Press any key'); cr.
	500 milliSeconds asDelay wait.
	NXTButton waitForAnyKey.! !

!NXTSystem methodsFor: 'menu handling' stamp: 'mab 8/13/2008 15:29'!
menuDown
	self selected: self selected + 1.
	self selected > self programs size ifTrue: [
		self selected: 1 ].! !

!NXTSystem methodsFor: 'menu handling' stamp: 'mab 3/16/2009 10:17'!
menuUp
	self selected: self selected - 1.
	self selected isZero ifTrue: [
		self selected: self programs size ].! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
programs
	^ programs! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
programs: anObject
	programs := anObject! !

!NXTSystem methodsFor: 'menu handling' stamp: 'mab 3/4/2009 18:48'!
reloadPrograms
	self programs: (Smalltalk packageManager applications).
	self selected: 1.! !

!NXTSystem methodsFor: 'system' stamp: 'mab 3/10/2009 10:44'!
run
	| key |
	self reloadPrograms. 
	[ 	
		self showMenu.
		key := self buttons waitForAny.
		key isCancel ifTrue: [ self shutdown ].
		key isLeft ifTrue: [ self menuUp ].
		key isRight ifTrue: [ self menuDown ].
		key isOk ifTrue: [ self execute: self selectedProgram. self reloadPrograms ].
	] repeat.! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
selected
	^ selected! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
selected: anObject
	selected := anObject! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 3/4/2009 19:18'!
selectedProgram
	^ self programs at: self selected! !

!NXTSystem methodsFor: 'menu handling' stamp: 'mab 3/4/2009 18:18'!
showMenu
	| index |
	self environment display clear.
	index := 0.
	self programs do: [ :prog |
		index := index + 1.
		self selected = index 
			ifTrue: [ self display show: '> ' ]
			ifFalse: [ self display show: '  ' ].
		self display show: prog name; cr.
	].! !

!NXTSystem methodsFor: 'system' stamp: 'mab 3/10/2009 11:46'!
shutdown
	| button |
	self display 
		clear;
		show: 'Save image? (Ok/Cancel)'; cr.
	[
		button := self buttons waitForAny.
		button = self buttons enter ifTrue: [ Smalltalk shutdown: true ].
		button = self buttons exit ifTrue: [ Smalltalk shutdown: false ].
	] repeat.! !

NXTObject subclass: #NXTTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

NXTTestCase subclass: #NXTArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTArrayTest methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 14:40'!
testSize
	self assert: (NXTArray new: 5) size = 5
	! !

NXTTestCase subclass: #NXTBlockTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 15:23'!
closure
	| temp |
	temp := #kickass.
	^ [ temp = #kickass ]! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:36'!
testBlockStacks
	"This should work without crashes"
	[ self error: 'mist' ] on: NXTError do: [].
	[ :block | block ] value: [ ].
	[ ] value.
	true or: [ ].
	[ ]  isBlock.
	self assert: true.! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 11:51'!
testClosure
	| block |
	block := self closure.
	self assert: block value! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 13:33'!
testTemporaryAssignmentFromBlock
	| temp |
	temp := 10.
	[ temp := 5 ] value.
	self assert: temp = 5.! !

NXTTestCase subclass: #NXTClassTest
	instanceVariableNames: ''
	classVariableNames: 'AlwaysFortyTwo ClassVar'
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTClassTest class methodsFor: 'as yet unclassified' stamp: 'mab 11/22/2008 17:44'!
initialize
	"self initialize"
	super initialize.
	AlwaysFortyTwo := 42.! !

!NXTClassTest methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 21:34'!
testClassVar
	self assert: AlwaysFortyTwo = 42.
	ClassVar := 10.
	self assert: ClassVar = 10.! !

!NXTClassTest methodsFor: 'as yet unclassified' stamp: 'mab 3/5/2009 19:19'!
testSubclassRelationship
	self assert: (NXTObject subclasses includes: NXTTestCase).
	self assert: (NXTTestCase superclass subclasses includes: NXTTestCase).! !

NXTTestCase subclass: #NXTDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:32'!
testAdd
	
	| dict |
	dict := NXTDictionary new.
	dict add: #a -> 1.
	dict add: #b -> 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2! !

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 11/16/2008 15:04'!
testAddAll
	
	| dict1 dict2 |
	dict1 := NXTDictionary new.
	dict1 at: #a put:1 ; at: #b put: 2. 
	dict2 := NXTDictionary new.
	dict2 at: #a put: 3 ; at: #c put: 4.
	dict1 addAll: dict2.
	self assert: (dict1 at: #a) = 3.
	self assert: (dict1 at: #b) = 2.
	self assert: (dict1 at: #c) = 4.! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:32'!
testAddAssociation
	"self run:#testAddAssociation"
	"self debug:#testAddAssociation"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2.
	
	dict at: #a put: 10.
	dict at: #c put: 2.
	
	self assert: (dict at: #a) = 10.
	self assert: (dict at: #b) = 2.
	self assert: (dict at: #c) = 2
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/19/2008 14:24'!
testAssociationsSelect
	| answer d |
	d := NXTDictionary new.
	d at: (NXTArray with: #hello with: #world)
	  put: #fooBar.
	d at: Smalltalk put: #'Smalltalk is the key'.
	d at: #Smalltalk put: Smalltalk.
	answer := d
				associationsSelect: [:assoc | assoc key == #Smalltalk
						and: [assoc value == Smalltalk]].
	self
		should: [answer isKindOf: NXTDictionary].
	self
		should: [answer size == 1].
	self
		should: [(answer at: #Smalltalk)
				== Smalltalk].
	answer := d
				associationsSelect: [:assoc | assoc key == #NoSuchKey
						and: [assoc value == #NoSuchValue]].
	self
		should: [answer isKindOf: NXTDictionary].
	self
		should: [answer size == 0]! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtError
	"self run: #testAtError"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 666.
	self shouldnt: [ dict at: #a ] raise: NXTError.
	self should: [ dict at: #b ] raise: NXTError.
	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtIfAbsent
	"self run: #testAtIfAbsent"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 666.
	
	self assert: (dict at: #a ifAbsent: [nil]) = 666.
	
	self assert: (dict at: #b ifAbsent: [nil]) isNil.

	! !

!NXTDictionaryTest methodsFor: 'implementation tests' stamp: 'mab 8/18/2008 18:34'!
testAtNil
	"(self run: #testAtNil)"
	"nil is a valid key in squeak. In VW nil is not a valid key"
	"Ansi 1.9 p, 168
    		5.7.2.5 Message: at: key put: newElement
    		Synopsis
    			Store newElement at key in the receiver. Answer newElement.
    		Definition: <abstractDictionary>
    		If lookup succeeds for key, then newElement replaces the element previously stored at key.
    		Otherwise, the newElement is stored at the new key. In either case, subsequent successful
    		lookups for key will answer newElement.  Answer newElement.

    		The result is undefined if the key is nil.

		This clearly indicates that different smalltalks where doing different assumptions."
	
	
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [ dict1 at: nil put: #none] raise: NXTError.
	self assert: (dict1 at: nil) = #none. 
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtPut
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| adictionary |
	adictionary := NXTDictionary new.
	adictionary at: #a put: 3.
	self assert: (adictionary at: #a) = 3.
	adictionary at: #a put: 3.
	adictionary at: #a put: 4.
	self assert: (adictionary at: #a) = 4.
	adictionary at: nil put: 666.
	self assert: (adictionary at: nil) = 666! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtPutNil
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| dict |
	dict := NXTDictionary new.
	dict at: nil put: 1.
	self assert: (dict at: nil) = 1.
	dict at: #a put: nil.
	self assert: (dict at: #a) = nil.
	dict at: nil put: nil.
	self assert: (dict at: nil) = nil.
	
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesAssociation
	"self run:#testIncludesAssociation"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict includesAssociation: (#a -> 1)).
	self assert: (dict includesAssociation: (#b -> 2)).
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesAssociationNoValue
	"self run:#testIncludesAssociationNoValue"
	"self debug:#testIncludesAssociationNoValue"
	
	| dict a1 a3 |
	a1 := NXTAssociation key: #Italie.
	a3 := NXTAssociation key: #France value: 'Paris'.
	
	self assert: (a1 key = #Italie).
	self assert: (a1 value isNil).
	
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: #Italie).
	self assert: (dict at: #Italie) isNil.
	self assert: (dict at: #France) = 'Paris'

	
	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesKey
	"self run:#testIncludesKey"
	"self debug:#testIncludesKey"
	
	| dict a1 a2 a3 |
	a1 := NXTAssociation key: 'Italie'.
	a2 := NXTAssociation new.
	a3 := NXTAssociation key: 'France' value: 'Paris'.
	
	dict := NXTDictionary new.
	dict add: a1 .
	dict add: a2.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: 'France').
	self assert: (dict includesKey: #Italie).
	self assert: (dict includesKey: nil).	
		
	self assert: (dict at: 'France' ) = 'Paris'.
! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 16:04'!
testKeyAtValue
	"self run: #testKeyAtValue"
	"self debug: #testKeyAtValue"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 3.
	self assert: (dict keyAtValue: 2) = #b.
	self assert: (dict keyAtValue: 1) = #a.
	self should: [dict keyAtValue: 0] raise: NXTError.
! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 15:58'!
testKeys

	"self run:#testKeys "
	
	| a1 a2  dict | 
	a1 := NXTAssociation key: 'France' value: 'Paris'.
	a2 := NXTAssociation key: 'Italie' value: 'Rome'.
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a2.
	self assert: (dict keys size) = 2.
	self assert: (dict keys includes: #France).! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 16:09'!
testKeysDo
	"self run: #testKeysDo"
	"self debug: #testKeysDo"
	
	| dict res |
	dict := NXTDictionary new.
	
	dict at: #a put: 33.
	dict at: #b put: 66.
	
	res := NXTOrderedCollection new.
	dict keysDo: [ :each | res add: each ].
	
	self assert: res asSet = #(a b) asSet.


	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:36'!
testOccurrencesOf
	"self run:#testOccurrencesOf"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 1.
	dict at: #d put: 3.
	dict at: nil put: nil.
	dict at: #z put: nil.
	
	
	self assert: (dict occurrencesOf: 1 ) = 2.
	self assert: (dict occurrencesOf: nil ) = 2.
	
	
	
	! !

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:37'!
testPseudo
	"(self run: #testPseudo)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [dict1 at: true put: #true] raise: NXTError.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: NXTError.
	self assert: (dict1 at: false) = #false.! !

!NXTDictionaryTest methodsFor: 'implementation tests' stamp: 'mab 8/18/2008 18:37'!
testPseudoVariablesAreValidKeys
	"(self run: #testPseudoVariablesAreValidKeys)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [dict1 at: true put: #true] raise: NXTError.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: NXTError.
	self assert: (dict1 at: false) = #false.! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 13:41'!
testRemoveKey
		"self run:#testRemoveKey "
	| dict | 
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict keys size) = 2.
	dict removeKey: #a.
	self assert: dict keys size  = 1.

	self should: [dict at: #a] raise: NXTError.
	self assert: (dict at: #b) = 2


	
	! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 15:43'!
testValues
	"self run:#testValues "
	
	| a1 a2 a3 dict | 
	a1 := NXTAssociation key: 'France' value: 'Paris'.
	a2 := NXTAssociation key: 'Italie' value: 'Rome'.
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a2.
	
	self assert: (dict values size ) = 2.
	self assert: (dict values includes: 'Paris').
	a3 := NXTAssociation new.
	dict add: a3.
	self assert: (dict values size ) = 3.
	self assert: (dict values includes: nil).! !

NXTTestCase subclass: #NXTExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:08'!
testEnsureSimple

	[10 * 10.
	50 + 50] ensure: [^ nil ].
	self assert: false.
	! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 21:25'!
testEnsureWithError

	[10 * 10.
	NXTNotification signal.
	50 + 50] ensure: [^ nil ].
	self assert: false.
	! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 15:03'!
testResumableOuter

	| result |
	result := [NXTNotification signal. 4] 
		on: NXTNotification 
		do: [:ex | ex outer. ex return: 5].
	self assert: result == 5! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 19:19'!
testResumablePass

	| result |
	result := [NXTNotification signal. 4] 
		on: NXTNotification 
		do: [:ex | ex pass. ex return: 5].
	self assert: result == 4
! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:04'!
testSimpleResume
	| it |
	[it := NXTNotification signal.
	self assert: it == 3 ] on: NXTNotification do: [:ex | ex resume: 3]! !

NXTTestCase subclass: #NXTExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:10'!
helper: anObject
	^ anObject! !

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 15:43'!
testAutomaticEndOfExecutionWithRecursiveBlocks
	"If this does not crash, the test is ok"
	| array |
	array := NXTArray new: 10.
	1 to: 10 do: [ :index | array at: index put: index ].
	array do: [ :each | self helper: each ].! !

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 13:48'!
testNonLocalReturnInNestedBlocks
	[ [ ^ self ] value ] value.
	"if we get here, something went wrong"
	self fail.! !

NXTTestCase subclass: #NXTMetaclassesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:14'!
testInheritance
	self assert: NXTBoolean class superclass = NXTObject class.
	self assert: NXTObject class superclass = NXTClass.
	self assert: NXTClass superclass = NXTObject.! !

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:13'!
testInstanceOfRelationships
	self assert: NXTObject class class = NXTMetaclass.
	self assert: NXTMetaclass class class = NXTMetaclass.! !

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 3/5/2009 19:50'!
testSubclassRelationship
	self assert: (NXTObject class subclasses includes: NXTTestCase class).
	self assert: (NXTTestCase class superclass subclasses includes: NXTTestCase class).
! !

NXTTestCase subclass: #NXTSymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testCreationFromString
	self assert: #test == 'test' asSymbol.
	self assert: #readSymbol == ('read', 'Symbol') asSymbol.
	self assert: #writeUndefinedObject: == #writeUndefinedObject asMutator.! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testEquality
	self assert: #test = #test.
	self assert: #test == #test.! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testLiteralArraySymbols
	| array |
	array := #(#NXTArray).
	self assert: (array at: 1) = #NXTArray! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 18:04'!
testSymbolTableCleanup
	| symbolTable oldTableSize reference |
	self display show: '1'.
	Smalltalk garbageCollect.
	self display show: '2'.
	symbolTable := NXTSymbol classPool at: #SymbolTable.
	oldTableSize := symbolTable realSize.
	"Create a new symbol"
	self display show: '3'.
	reference := 'blubberwabberdingsdongs' asSymbol.
	self assert: symbolTable realSize = (oldTableSize + 1).
	reference := nil.
	Smalltalk garbageCollect.
	self display show: '4'.
	symbolTable rehash.
	self display show: '5'.
	self assert: symbolTable realSize = oldTableSize.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:13'!
assert: aBoolean
	aBoolean ifFalse: [ NXTTestFailure new signal: 'Assertion failed' ].! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 13:45'!
fail
	^ self assert: false! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:18'!
run
	| testSelectors failed |
	failed := NXTOrderedCollection new.
	testSelectors := self class selectors select: [ :each | each startsWith: #test ].
	self display show: 'Testing class ' , self class name, ': '.
	testSelectors do: [ :testSelector |
		[
		self perform: testSelector. self display show: '.' ] on: NXTTestFailure do: [ :ex | 
			self display show: 'F'.
			failed add: testSelector ]].
	self display cr.
	failed do: [ :selector |
		self display show: selector, ' failed'; cr ].! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:21'!
should: assertionBlock
	self assert: assertionBlock value.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:13'!
should: aBlock raise: anExceptionalEvent
	[ aBlock value. self assert: false ] on: anExceptionalEvent do: [ :ex | ^ true ].
	self assert: false.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:13'!
shouldnt: aBlock raise: anExceptionalEvent
	[ aBlock value ] on: anExceptionalEvent do: [ :ex | self assert: false ].! !

NXTTestCase subclass: #NXTWeakPointerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTWeakPointerTest methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 23:44'!
testWeakArrayClearing
	| weakArray |
	weakArray := NXTWeakArray new: 1.
	weakArray at: 1 put: NXTObject new.
	Smalltalk garbageCollect.
	self assert: (weakArray at: 1) isNil! !

NXTObject subclass: #NXTTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTTestRunner methodsFor: 'as yet unclassified' stamp: 'mab 2/17/2009 18:45'!
run
	NXTTestCase allSubclassesDo: [ :testCase |
		testCase new run ].! !

NXTObject subclass: #NXTThreadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTThreadTest methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 18:17'!
output: name
	500 timesRepeat: [ self display show: name ].! !

!NXTThreadTest methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 13:42'!
run
	| s1 s2 |
	s1 := NXTSemaphore forMutualExclusion.
	s2 := NXTSemaphore forMutualExclusion.
	[ self output: '2'. s1 signal. ] fork.
	[ self output: '3'. s2 signal. ] fork.
	self output: '1'.
	"Wait for all three"
	s1 wait.
	s2 wait.! !

NXTObject subclass: #NXTTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTTime class methodsFor: 'as yet unclassified' stamp: 'mab 10/8/2008 18:28'!
millisecondClockValue
	<NXTPrimitive: 39>
	^ Time millisecondClockValue! !

!NXTTime class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:51'!
millisecondsToRun: timedBlock 
	"Answer the number of milliseconds timedBlock takes to return its value."

	| initialMilliseconds |
	initialMilliseconds := self millisecondClockValue.
	timedBlock value.
	^ self millisecondClockValue - initialMilliseconds! !

NXTObject subclass: #NXTTimer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:03'!
now
	<NXTPrimitive: 10>! !

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:23'!
sleepFor: milliseconds
	<NXTPrimitive: 46>! !

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:04'!
waitFor: seconds
	| start |
	start := self now.
	[ self now - start < seconds ] whileTrue.! !

NXTObject subclass: #NXTUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTUndefinedObject commentStamp: 'mab 3/12/2009 16:58' prior: 0!
My sole instance nil indicates non-used references.

Instance Variables
!

!NXTUndefinedObject methodsFor: 'error handling' stamp: 'mab 10/3/2008 17:03'!
handleSignal: exception
	"When no more handler (on:do:) context left in sender chain this gets called.  Return from signal with default action."

	^ exception resumeUnchecked: exception defaultAction! !

!NXTUndefinedObject methodsFor: 'testing' stamp: 'mab 7/22/2008 18:15'!
ifNil: aBlock
	^ aBlock value! !

!NXTUndefinedObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:27'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block for nil because I'm == nil"

	^ nilBlock value! !

!NXTUndefinedObject methodsFor: 'testing' stamp: 'mab 10/3/2008 21:42'!
ifNotNil: nilBlock
	^ self! !

!NXTUndefinedObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:27'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am nil, so evaluate the block nilBlock"

	^ nilBlock value! !

!NXTUndefinedObject methodsFor: 'testing' stamp: 'mab 5/20/2008 14:22'!
isNil
	^ true! !

NXTObject subclass: #NXTUsb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 6/19/2008 15:10'!
isConnected
	<NXTPrimitive: 26>
	^ false! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:03'!
packetSize
	^ 64! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:08'!
read
	"Blocking. Reads the next incoming packet from the USB port"
	<NXTPrimitive: 27>! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:31'!
send: aByteArray
	"Blocking. Sends a packet to the USB port"
	<NXTPrimitive: 33>! !

NXTObject subclass: #NXTUsbManager
	instanceVariableNames: 'connection running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTUsbManager methodsFor: 'accessing' stamp: 'mab 7/25/2008 18:43'!
connection
	^ connection! !

!NXTUsbManager methodsFor: 'accessing' stamp: 'mab 7/25/2008 18:43'!
connection: anObject
	connection := anObject! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:14'!
exit
	running := false.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 17:04'!
getClassList
	^ Smalltalk keys asArray! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:53'!
run
	self display show: 'Waiting for USB connection...'; cr.
	[ NXTUsb isConnected not ] whileTrue: [ 10 ].
	self display show: 'Got one - waiting for messages'; cr.
	self connection: (NXTDataStream on: NXTUsbStream new).
	(NXTDispatcher 
		for: Smalltalk packageManager
		on: self connection) receive.
	self connection close! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 17:59'!
storeClass: aClass
	| newClass |
	(Smalltalk at: aClass name) become: aClass.
	newClass := Smalltalk at: aClass name.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:00'!
storeClass: aClass metaclass: aMetaclass
	| newClass |
	(Smalltalk at: aClass name) become: aClass.
	newClass := Smalltalk at: aClass name.
	newClass class: aMetaclass.
	aMetaclass class: NXTMetaclass.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 3/4/2009 16:52'!
test: n1 write: n2
	self display show: n1; cr.
	self display show: n2; cr.! !

Object subclass: #NXTObjectTable
	instanceVariableNames: 'objects positions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTObjectTable commentStamp: 'mab 3/13/2009 11:28' prior: 0!
My instances represent the object table for an image and can store themselves on a byte stream.

Instance Variables
	objects:		<OrderedCollection>
	positions:		<OrderedCollection>

objects
	- Objects in the order the are written to the stream.

positions
	- Positions of the objects on the stream in the same order.
!

!NXTObjectTable class methodsFor: 'constants' stamp: 'mab 10/29/2008 16:44'!
maxObjectId
	^ 32767! !

!NXTObjectTable class methodsFor: 'instance creation' stamp: 'mab 3/17/2008 17:15'!
on: objectList
	^ self new objects: objectList! !

!NXTObjectTable methodsFor: 'object management' stamp: 'mab 12/15/2008 09:09'!
addObject: anObject
	self objects add: anObject.
	self positions add: nil.
	^ anObject! !

!NXTObjectTable methodsFor: 'hashing' stamp: 'mab 12/15/2008 13:19'!
hashFor: anObject
	^ (self idFor: anObject) \\ (NXTSmallInteger maxVal + 1)! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 10/29/2008 16:44'!
idFor: anObject
	^ self class maxObjectId - ((self indexOf: anObject) - 1)! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 9/26/2008 18:15'!
indexOf: anObject
	"OrderedCollection>>#indexOf: uses #= but we need #=="
	self objects doWithIndex: [ :each :index |
		each == anObject ifTrue: [ ^ index ]].
	self error: 'Non-mappable object'.! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 12/15/2008 08:55'!
objects
	^ objects ifNil: [ objects := OrderedCollection new ]! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:15'!
objects: anObject
	objects := anObject! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 12/12/2008 20:59'!
positions
	^ positions ifNil: [ positions := OrderedCollection new ]! !

!NXTObjectTable methodsFor: 'object management' stamp: 'mab 12/12/2008 20:58'!
update: anObject position: aPosition
	self positions at: (self indexOf: anObject) put: aPosition! !

Object subclass: #NXTPackageCompiler
	instanceVariableNames: 'packageDescription package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTPackageCompiler commentStamp: 'mab 3/13/2009 11:33' prior: 0!
My instances compile whole packages and invoke other compilers as necessary.

Instance Variables
	package:		<NXTPackage>
	packageDescription:		<NXTPackageDescription>

package
	- The package object we're building for the NXT.

packageDescription
	- The description guiding us what to build.
!

!NXTPackageCompiler class methodsFor: 'compiling' stamp: 'mab 3/5/2009 16:14'!
compilePackage: aPackageDescription
	^ self new compile: aPackageDescription ! !

!NXTPackageCompiler methodsFor: 'accessing' stamp: 'mab 11/19/2008 19:19'!
classNamed: aName
	(self isMetaclassName: aName) ifTrue: [ ^ self metaclassNamed: aName ].
	^ self package classes at: aName ifAbsent: [
		(self packageDescription classes includes: aName) 
			ifTrue: [ self compileClass: aName ]
			ifFalse: [ NXTClassProxy for: aName ]]! !

!NXTPackageCompiler methodsFor: 'compiling' stamp: 'mab 11/19/2008 15:46'!
compile: aPackageDescription
	self packageDescription: aPackageDescription.
	self package: NXTPackage new.
	self package name: aPackageDescription name asNXTObject.
	aPackageDescription isApplication ifTrue: [
		self package entrypoint: aPackageDescription entrypoint asNXTObject ].
	self compileClasses.
	^ self package! !

!NXTPackageCompiler methodsFor: 'compiling' stamp: 'mab 11/17/2008 13:49'!
compileClass: className
	| newClass newMetaclass |
	self package classes at: className ifPresent: [ :class | ^ class ].
	newClass := self package classes at: className put: NXTClass new.
	newMetaclass := self package metaclasses at: newClass put: NXTMetaclass new.
	newMetaclass thisClass: newClass.
	NXTClassCompiler new
		compilerContext: self;
		compile: (Smalltalk at: className) into: newClass.
	NXTClassCompiler new
		compilerContext: self;
		compile: (Smalltalk at: className) class into: newMetaclass.
	^ newClass! !

!NXTPackageCompiler methodsFor: 'compiling' stamp: 'mab 3/5/2009 15:22'!
compileClasses
	self packageDescription classes do: [ :className | self compileClass: className ] displayingProgress: 'Compiling ', self packageDescription name.! !

!NXTPackageCompiler methodsFor: 'testing' stamp: 'mab 11/17/2008 13:59'!
isMetaclassName: aName
	^ aName endsWith: ' class'! !

!NXTPackageCompiler methodsFor: 'accessing' stamp: 'mab 11/19/2008 19:20'!
metaclassNamed: aName
	| class |
	class := self package classes 
		at: (aName allButLast: 6) asSymbol 
		ifAbsent: [ ^ NXTClassProxy for: aName ].
	^ self package metaclasses at: class! !

!NXTPackageCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 11:07'!
package
	^ package! !

!NXTPackageCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 11:07'!
package: aPackage
	package := aPackage! !

!NXTPackageCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 10:59'!
packageDescription
	^ packageDescription! !

!NXTPackageCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 11:00'!
packageDescription: aPackageDescription
	packageDescription := aPackageDescription! !

Object subclass: #NXTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTalk commentStamp: 'mab 3/4/2009 16:05' prior: 0!
I am a release helper class. I can generate a SAR file from the NXTalk source ready for distribution. See my class side.!

!NXTalk class methodsFor: 'sar creation' stamp: 'mab 3/16/2009 10:25'!
addInfoTextTo: zip
	zip addString: 'Welcome to NXTalk. You just filed in the SAR distribution for Squeak 3.10. 
	
NXTalk is a programming environment for the Lego Mindstorms NXT robot using Squeak. In contrast to other robot programming environments, it comes with its own Smalltalk virtual machine for the NXT. Hence, it is capable to execute real Smalltalk bytecodes directly on the robot instead of sending remote commands.
	
With the installation of this SAR, a file named ''nxtalkvm.bin'' should have been extracted to your Squeak image directory. You have to install this file with the original Lego NXT-G firmware updater or using any other SAMBA-Flash tool. To flash the NXT, you need to reset it using its Flash-button as described in the manual. If you don''t own any compatible Flash tool, use the NXTalk VM sources at http://www.hpi.uni-potsdam.de/hirschfeld/NXTalk in order to compile your own. Please note, that it might be necessary to take the batteries out of the NXT and reinsert them, if the VM does not start up correctly.

After having installed and started the firmware, any further interaction happens via Squeak. However, currently only Linux is known to support that as Bluetooth and USB connections have to be mapped through serial ports in order to be accessable by Squeak. In Linux, you have to do a ''modprobe usbserial vendor=0x0694 product=0xff00'' as root. The necessary kernel module needs to be installed. If you now connect the NXT brick to your USB port, you can symlink it to the third serial port via ''ln -sf /dev/ttyUSB0 /dev/ttyS3''. This port is used for USB connections in NXTalk.

If you start the NXT it will present you the main menu of NXTalk. With a press on the right button, you can install a new image. From Squeak, this can be done by evaluating ''NXTUsbConnection flashImage''. Now you can play with the NXTalk applications menu, which only has an USB and a Bluetooth entry. Both of them can be started to accept incoming connections and package installations. Installing a package can be done by executing the following instructions in Squeak while having one of the applications open:

stream := NXTDataStream on: NXTUsbConnection connect.
packageManager := NXTProxy on: stream.
packageManager installPackage: (NXTPackageCompiler compilePackage: NXSnakeApp new).
packageManager exit.
stream close.

Note, that this may take some time, which is used up by NXTalk side on the NXT deserializing the classes and methods. See the classes in the NXTalk package and their documentation for further code examples. If you exchange NXTUsbConnection with the class NXTBluetoothConnection, NXTalk uses /dev/ttyS2 for its connections. Thus, if you map an rfcomm Bluetooth connection to the serial port 2, you can also use Bluetooth to transfer packages and other data. However, this currently on works, if the Bluetooth application is explicitly started. Nevertheless, all the code can easily be changed.

When want to shutdown NXTalk using the Cancel button, it asks you, whether it should save the image or not. Pressing the Ok button invokes the saving, which kills all processes and stores the remaining live data like new packages in the Flash memory. This may take some time, depending on the size of the modified data. A press on Cancel will leave the Flash as it is and simply shutdown the NXT brick.

So for now, have fun with the code and feel free to ask questions!!' as: 'NXTalk 0.7'.
	zip addString: 'self openTextFile: ''NXTalk 0.7''.' as: 'install/postscript'.! !

!NXTalk class methodsFor: 'sar creation' stamp: 'mab 3/16/2009 02:27'!
createNXTalkSAR
	| zip nxtalk ast newparser smacc delimiter |
	zip := ZipArchive new.
	nxtalk := (MCWorkingCopy forPackage: (MCPackage new name: 'NXTalk')) ancestry ancestors first name, '.mcz'.
	ast := (MCWorkingCopy forPackage: (MCPackage new name: 'AST')) ancestry ancestors first name, '.mcz'.
	newparser := (MCWorkingCopy forPackage: (MCPackage new name: 'NewParser')) ancestry ancestors first name, '.mcz'.
	smacc := (MCWorkingCopy forPackage: (MCPackage new name: 'SmaCC')) ancestry ancestors first name, '.mcz'.
	delimiter := FileDirectory pathNameDelimiter asString.
	(zip addFile: 'package-cache', delimiter , nxtalk as: nxtalk) desiredCompressionLevel: 0.
	(zip addFile: 'package-cache/', delimiter, ast as: ast) desiredCompressionLevel: 0.
	(zip addFile: 'package-cache/', delimiter, newparser as: newparser) desiredCompressionLevel: 0.
	(zip addFile: 'package-cache/', delimiter, smacc as: smacc) desiredCompressionLevel: 0.
	(zip addFile: 'nxtalkvm.bin' as: 'nxtalkvm.bin') desiredCompressionLevel: 0.
	zip addString: 'self fileInMonticelloZipVersionNamed: ''', ast, '''.
		self fileInMonticelloZipVersionNamed: ''', smacc, '''.
		self fileInMonticelloZipVersionNamed: ''', newparser, '''.
		self fileInMonticelloZipVersionNamed: ''', nxtalk, '''.
		self extractMember: ''nxtalkvm.bin''' as: 'install/preamble'.
	self addInfoTextTo: zip.
	zip writeToFileNamed: 'NXTalk.sar'.! !

!Object methodsFor: '*nxtalk' stamp: 'mab 8/15/2008 16:22'!
isNXTObject
	^ false! !

!SystemDictionary methodsFor: '*nxtalk' stamp: 'mab 9/17/2008 11:33'!
isNXTalk
	^ false! !

!UndefinedObject methodsFor: '*nxtalk' stamp: 'mab 11/13/2008 16:09'!
asNXTObject
	^ NXTUndefinedObject new! !

!ClassDescription methodsFor: '*nxtalk' stamp: 'mab 11/16/2008 15:02'!
hasClassVar: aName
	(self classPool includesKey: aName) ifTrue: [ ^ true ].
	self superclass ifNil: [ ^ false ].
	^ self superclass hasClassVar: aName! !

!Dictionary methodsFor: '*nxtalk' stamp: 'mab 12/30/2008 12:27'!
asNXTObject
	| dict |
	dict := NXTDictionary new: self size.
	self associationsDo: [ :assoc |
		dict at: assoc key asNXTObject put: assoc value asNXTObject ].
	^ dict! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 12:28'!
asNXTLargeInteger: positive
	| size nxtObject |
	size := self digitLength.
	nxtObject := positive 
		ifTrue: [ NXTLargePositiveInteger new: size ]
		ifFalse: [ NXTLargeNegativeInteger new: size ].
	1 to: size do: [ :i | nxtObject at: i put: (self digitAt: i) ].
	^ nxtObject! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:46'!
asNXTObject
	self > NXTSmallInteger maxVal ifTrue: [
		^ self asNXTLargeInteger: true ].
	self < NXTSmallInteger minVal ifTrue: [
		^ self asNXTLargeInteger: false ].
	^ self! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/17/2008 19:32'!
isClassProxy
	^ false! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 11:07'!
isNXTObject
	^ self <= NXTSmallInteger maxVal and: [ self >= NXTSmallInteger minVal ]! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/17/2008 19:15'!
referencesDo: aBlock! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 10:07'!
referencesReplace: aBlock! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/1/2008 18:21'!
writeAsReferenceOn: aByteStream within: image
	(self < -16r4000 or: [ self > 16r3FFF ]) ifTrue: [ self error: 'Too large smallint!!' ].
	self >= 0 
		ifTrue: [ aByteStream littleEndianWord: (self bitShift: 1) ]
		ifFalse: [ aByteStream 
			littleEndianWord: (16r8000 + self bitShift: 1) ]! !

!Association methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 11:06'!
asNXTObject
	^ NXTAssociation key: self key asNXTObject value: self value asNXTObject! !

PositionableStream subclass: #NXTConnection
	instanceVariableNames: 'outputBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTConnection commentStamp: 'mab 3/16/2009 03:35' prior: 0!
I represent a connection to a running NXTalk VM from within Squeak. I implement stream behavior. In an output buffer, I fetch all bytes to be sent to the NXT in a so-called NXTalk packet. If am told to flush the buffer, I first send the size of it in a 4 byte packet and afterwards the full NXTalk data.

Instance Variables
	outputBuffer:		<OrderedCollection>

outputBuffer
	- Collects the bytes for an NXTalk packet.
!

!NXTConnection class methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 17:53'!
flashImage
	"Flash standard image"
	self flashImage: NXTImageBuilder new.! !

!NXTConnection class methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 17:52'!
flashImage: imageBuilder
	| imageStream objectTableStream connection |
	imageStream := RWBinaryOrTextStream on: ByteArray new.
	objectTableStream := RWBinaryOrTextStream on: ByteArray new.
	connection := self connect.
	[
		imageBuilder createImageOn: connection.
		imageBuilder image writeObjectTableToStream: objectTableStream.
		connection flushDisplayingProgress: 'Transferring image'.
		connection nextPutAll: objectTableStream contents; flushDisplayingProgress: 'Transferring object table'.
	] ensure: [ connection close ].! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:54'!
ascii
	"NXT connections are always binary for now"! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:53'!
binary
	"NXT connections are always binary for now"! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 10:43'!
close
	^ self stream close! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/4/2008 17:26'!
flush
	^ self stream flush! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 10:22'!
initialize
	outputBuffer := OrderedCollection new.! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:43'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:43'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 13:14'!
next
	^ self stream next! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:44'!
nextLittleEndianNumber: n 
	"Answer the next n bytes as a positive Integer or LargePositiveInteger, where the bytes are ordered from least significant to most significant."

	| bytes s |
	bytes := self next: n.
	s := 0.
	n to: 1 by: -1 do: [:i | s := (s bitShift: 8) bitOr: (bytes at: i)].
	^ s
! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:44'!
nextLittleEndianNumber: n put: value
	"Answer the next n bytes as a positive Integer or LargePositiveInteger, where the bytes are ordered from least significant to most significant."
	| bytes |
	bytes := ByteArray new: n.
	1 to: n do: [: i | bytes at: i put: (value digitAt: i)].
	self nextPutAll: bytes! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 3/10/2009 10:16'!
nextPut: anInteger
	outputBuffer add: anInteger asInteger! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 3/10/2009 10:15'!
nextPutAll: aCollection
	aCollection do: [ :element |
		self nextPut: element ].! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 10:16'!
position
	^ outputBuffer size! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:51'!
sendData: aStringOrByteArray
	self subclassResponsibility! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:09'!
stream
	self subclassResponsibility! !

NXTConnection subclass: #NXTSerialConnection
	instanceVariableNames: 'serialPort inputBuffer inputBufferPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTSerialConnection commentStamp: 'mab 3/16/2009 03:39' prior: 0!
I am the base class for the serial connections needed due to Squeak's lack of Bluetooth and USB support. I insert a 30 ms delay after each packet is sent because of timing issues with the NXT and protocol synchronization problems, which are not fully understood yet.

Instance Variables
	inputBuffer:		<ByteArray>
	inputBufferPos:		<Integer>
	serialPort:		<SerialPort>

inputBuffer
	- Current buffer holding the last incoming byte packet.

inputBufferPos
	- Position in the input buffer.

serialPort
	- The serial port I am using.
!

NXTSerialConnection subclass: #NXTBluetoothConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTBluetoothConnection commentStamp: 'mab 3/16/2009 03:40' prior: 0!
I represent a Bluetooth connection over a serial port. I assume, that the Bluetooth rfcomm connection is mapped to SerialPort new: 2.!

!NXTBluetoothConnection class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:20'!
port
	^ 2! !

!NXTBluetoothConnection methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 14:32'!
wait
	100 milliSeconds asDelay wait.! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 11:42'!
bufferSize
	^ 64! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:20'!
connect
	^ self new serialPort: (SerialPort new openPort: self port)! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 8/14/2008 11:47'!
new
	^ self basicNew initialize! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 8/14/2008 11:51'!
close
	^ self serialPort close! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/9/2009 20:28'!
flush
	| bytes |
	bytes := ByteArray new: 4.
	1 to: 4 do: [: i | bytes at: i put: (outputBuffer size digitAt: i)].
	self serialPort nextPutAll: bytes.
	self wait.
	1 to: outputBuffer size by: 64 do: [ :index |
		self serialPort nextPutAll: (outputBuffer copyFrom: index to: (index + 63 min: outputBuffer size)) asByteArray.
		self wait ].
	outputBuffer := OrderedCollection new.! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/9/2009 20:48'!
flushDisplayingProgress: text
	| bytes |
	bytes := ByteArray new: 4.
	1 to: 4 do: [: i | bytes at: i put: (outputBuffer size digitAt: i)].
	self serialPort nextPutAll: bytes.
	self wait.
	text
		displayProgressAt: Sensor cursorPoint
		from: 0 to: outputBuffer size
		during: [ :bar |.
			1 to: outputBuffer size by: 64 do: [ :index |
				self serialPort nextPutAll: (outputBuffer copyFrom: index to: (index + 63 min: outputBuffer size)) asByteArray.
				self wait.
				bar value: (index + 63 min: outputBuffer size) ]].
	outputBuffer := OrderedCollection new.! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/9/2009 22:15'!
initialize
	outputBuffer := OrderedCollection new.! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 16:00'!
next
	| value |
	(inputBuffer isNil or: [ inputBufferPos > inputBuffer size ]) ifTrue: [
		[ inputBuffer := self serialPort readByteArray ] doWhileTrue: [ inputBuffer isEmpty ].
		inputBufferPos := 1 ].
	value := inputBuffer at: inputBufferPos.
	inputBufferPos := inputBufferPos + 1.
	^ value! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 17:12'!
serialPort
	^ serialPort! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 17:12'!
serialPort: anObject
	serialPort := anObject! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/9/2009 18:21'!
wait
	30 milliSeconds asDelay wait.! !

NXTSerialConnection subclass: #NXTUsbConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTUsbConnection commentStamp: 'mab 3/16/2009 03:40' prior: 0!
I represent an USB connection over a serial port. I assume, that the USB connection is mapped to SerialPort new: 3.!

!NXTUsbConnection class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:20'!
port
	^ 3! !

NXTConnection subclass: #NXTSocketConnection
	instanceVariableNames: 'socketStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTSocketConnection commentStamp: 'mab 3/16/2009 03:41' prior: 0!
I represent a connection to the NXTalk VM over a sockets. This is only used for the Linux VM simulation. I assume, that the Linux VM uses port 10000. Over me, a USB connection is emulated.

Instance Variables
	socketStream:		<SocketStream>

socketStream
	- The socket stream I am using.
!

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 14:01'!
connect
	^ self localhost! !

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:47'!
localhost
	^ self on: (SocketStream openConnectionToHostNamed: '127.0.0.1' port: 10000) binary! !

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 14:32'!
on: socket
	^ self basicNew 
		initialize;
		socketStream: socket! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 10:31'!
flush
	| bytes |
	bytes := ByteArray new: 4.
	1 to: 4 do: [: i | bytes at: i put: (outputBuffer size digitAt: i)].
	self stream nextPutAll: bytes.
	self stream nextPutAll: outputBuffer.
	self stream flush.
	outputBuffer := OrderedCollection new.! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 3/10/2009 10:17'!
flushDisplayingProgress: text
	self flush! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:52'!
sendData: aStringOrByteArray
	self socketStream
		nextPutAll: aStringOrByteArray;
		flush.! !

!NXTSocketConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 14:18'!
socketStream
	^ socketStream! !

!NXTSocketConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 14:18'!
socketStream: anObject
	socketStream := anObject! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:09'!
stream
	^ self socketStream! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 7/2/2008 17:50'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 7/2/2008 17:50'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

!LargeNegativeInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:30'!
asNXTObject
	| size nxtObject |
	size := self digitLength.
	nxtObject := NXTLargeNegativeInteger new: size.
	1 to: size do: [ :i | nxtObject at: i put: (self at: i) ].
	^ nxtObject! !

!Metaclass methodsFor: '*nxtalk' stamp: 'mab 11/16/2008 15:21'!
elementSize
	^ 2! !

!Array methodsFor: '*nxtalk' stamp: 'mab 7/21/2008 15:41'!
asNXTObject
	| nxtArray |
	nxtArray := NXTArray new: self size.
	self doWithIndex: [ :element :index |
		nxtArray at: index put: element asNXTObject ].
	^ nxtArray! !

RBProgramNodeVisitor subclass: #NXTAbstractCodeCompiler
	instanceVariableNames: 'literals bytecodes arguments temporaries compilerContext stackSize stackPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTAbstractCodeCompiler commentStamp: 'mab 3/12/2009 17:45' prior: 0!
I am the base class for NXTalk's compilers. I provide the facilities to generate bytecode from source code.

Instance Variables
	arguments:		<OrderedCollection>
	bytecodes:		<OrderedCollection>
	compilerContext:		<Object>
	literals:		<OrderedCollection>
	stackPos:	<Integer>
	stackSize:	<Integer>
	temporaries:		<OrderedCollectiont>

arguments
	- List of the argument names

bytecodes
	- List of the generated bytecodes

compilerContext
	- Surrounding compiler

literals
	- List of literals

stackPos
	- Current position of stack top
	
stackSize
	- Maximum position of stack top
	
temporaries
	- List of temporary names
!

!NXTAbstractCodeCompiler class methodsFor: 'constants' stamp: 'mab 11/3/2008 10:51'!
bytecodes
	^ Dictionary new
		at: #return put: 2r00000000;
		at: #dup put: 2r00000001;
		at: #pop put: 2r00000010;
		at: #pushSelf put: 2r00000011;
		at: #pushNil put: 2r000000100;
		at: #pushTrue put: 2r00000101;
		at: #pushFalse put: 2r00000110;
		at: #pushThisContext put: 2r00000111;
		at: #pushArg put: 2r00001000;
		at: #blockReturn put: 2r00001111;
		at: #pushTemp put: 2r00010000;
		at: #popTemp put: 2r00011000;
		at: #pushInst put: 2r00100000;
		at: #popInst put: 2r01000000;
		at: #pushLiteral put: 2r01100000;
		at: #pushBlock put: 2r10000000;
		at: #superSend put: 2r10100000;
		at: #send put: 2r11000000;
		at: #jumpIfTrue put: 2r11100000;
		at: #jumpBack put: 2r11110000;
		yourself! !

!NXTAbstractCodeCompiler class methodsFor: 'constants' stamp: 'mab 11/3/2008 10:04'!
inlineableSelectors
	^ #(#ifTrue: #ifFalse: #ifTrue:ifFalse #ifFalse:ifTrue:)! !

!NXTAbstractCodeCompiler class methodsFor: 'constants' stamp: 'mab 11/3/2008 15:16'!
inlineableSelectorsWithReceiver
	^ #(#whileTrue: #to:do:)! !

!NXTAbstractCodeCompiler class methodsFor: 'constants' stamp: 'mab 11/3/2008 13:24'!
maxArguments
	^ 7! !

!NXTAbstractCodeCompiler class methodsFor: 'constants' stamp: 'mab 9/10/2008 18:59'!
maxInstVars
	^ 32! !

!NXTAbstractCodeCompiler class methodsFor: 'constants' stamp: 'mab 11/3/2008 15:49'!
maxTemps
	^ 7! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 11/13/2008 11:01'!
acceptArrayNode: arrayNode
	self error: 'Not implemented yet'! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 1/12/2009 10:40'!
acceptAssignmentNode: anAssignmentNode
	| pushNeeded |
	self ifClassVar: anAssignmentNode variable name do: [
		^ self assignClassVar: anAssignmentNode variable with: anAssignmentNode value].
	self visitNode: anAssignmentNode value.
	pushNeeded := anAssignmentNode parent isSequence not or: [ self lastStatement ].
	pushNeeded ifTrue: [ self dup ].
	self popVariable: anAssignmentNode variable name.
	^ pushNeeded! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 1/12/2009 10:41'!
acceptBlockNode: aBlockNode
	| block |
	block := NXTBlockCompiler new
		compilerContext: self;
		compile: aBlockNode.
	self pushBlock: block.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 1/12/2009 10:40'!
acceptCascadeNode: cascadeNode
	self visitNode: cascadeNode receiver.
	cascadeNode messages size - 1 timesRepeat: [ self dup ].
	cascadeNode messages 
		do: [ :message | self visitNode: message ]
		separatedBy: [ self pop ].
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 10/9/2008 09:49'!
acceptLiteralNode: aLiteralNode
	self processLiteral: aLiteralNode value.
	^ true
	! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 1/12/2009 10:31'!
acceptMessageNode: aMessageNode
	self primitive ifNotNil: [ ^ self ].
	aMessageNode isCascaded not ifTrue: [
		(self tryInlining: aMessageNode) ifTrue: [ ^true ].
		self visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | self visitNode: each].
	(aMessageNode receiver isVariable and: [ aMessageNode receiver name = 'super' ])
		ifTrue: [ self superSend: aMessageNode selector]
		ifFalse: [ self send: aMessageNode selector ].
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 1/12/2009 10:39'!
acceptReturnNode: aReturnNode
	super acceptReturnNode: aReturnNode.
	self return.
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 10/9/2008 09:49'!
acceptVariableNode: variableNode
	self pushVariable: variableNode name.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 10/9/2008 09:49'!
addBytecode: aSymbol
	self addBytecode: aSymbol argument: 0! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 11/3/2008 14:52'!
addBytecode: aSymbol argument: aNumber
	self bytecodes add: (self class bytecodes at: aSymbol) + aNumber.
	! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:26'!
allArguments
	^ arguments! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:12'!
allTemporaries
	^ temporaries! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:12'!
arguments
	^ arguments! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:12'!
arguments: anObject
	arguments := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 1/12/2009 11:32'!
assignClassVar: variableNode with: valueNode
	self pushSelf.
	self send: #class.
	self pushLiteral: variableNode name asSymbol asNXTObject.
	self visitNode: valueNode.
	self send: #classPoolAt:put:.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 10:38'!
blockReturn
	self addBytecode: #blockReturn! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
bytecodes
	^ bytecodes! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
bytecodes: anObject
	bytecodes := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 15:11'!
classNamed: aName
	^ self compilerContext classNamed: aName! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/3/2008 09:36'!
compileForInlining: aBlockNode
	^ NXTInlineBlockCompiler compile: aBlockNode in: self! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 10/9/2008 09:55'!
compiledClass
	^ self compilerContext compiledClass! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
compilerContext
	^ compilerContext! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
compilerContext: anObject
	compilerContext := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 10/9/2008 09:50'!
compilesBlock
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'literals' stamp: 'mab 11/17/2008 13:23'!
convertLiteralArray: array
	| nxtArray |
	nxtArray := NXTArray new: array size.
	array doWithIndex: [ :element :index |
		nxtArray at: index put: (self extractLiteralValue: element) ].
	^ nxtArray! !

!NXTAbstractCodeCompiler methodsFor: 'stack management' stamp: 'mab 1/12/2009 11:36'!
decStackPos
	self decStackPosBy: 1.! !

!NXTAbstractCodeCompiler methodsFor: 'stack management' stamp: 'mab 1/12/2009 11:36'!
decStackPosBy: aNumber
	stackPos := stackPos - aNumber.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:18'!
dup
	self addBytecode: #dup.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'literals' stamp: 'mab 11/19/2008 16:04'!
extractLiteralValue: value
	value isNil | (value isKindOf: Boolean) | value isString | value isInteger 
		ifTrue: [ ^ value asNXTObject ].
	value isArray ifTrue: [
		^ self convertLiteralArray: value ].
	self error: 'Unknown literal value'.! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 10/9/2008 09:50'!
ifArgument: aName doWithIndex: aBlock
	| index |
	index := self allArguments indexOf: aName.
	index > self class maxArguments ifTrue: [
		self error: ' Too many arguments' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 10/9/2008 09:50'!
ifClassVar: aName do: aBlock
	(self compiledClass hasClassVar: aName) ifTrue: [ aBlock value ].! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 10/9/2008 09:50'!
ifInstVar: aName doWithIndex: aBlock
	| index |
	index := self instVarNames indexOf: aName.
	index > self class maxInstVars ifTrue: [
		self error: 'Too many instance variables' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 11/16/2008 13:49'!
ifNXTClass: aName doWithName: aBlock
	| class |
	class := [ Smalltalk at: aName asSymbol ] on: Error do: [ ^ nil ].
	class isBehavior ifFalse: [ ^ nil ].
	((class inheritsFrom: NXTObject)  or: [ class = NXTObject ])
		ifTrue: [ aBlock value: aName ].
		! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 10/9/2008 09:50'!
ifTemporary: aName doWithIndex: aBlock
	| index |
	index := self allTemporaries indexOf: aName.
	index > self class maxTemps ifTrue: [
		self error: 'Too many temps' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'stack management' stamp: 'mab 1/12/2009 11:16'!
incStackPos
	stackPos := stackPos + 1.
	stackPos > stackSize ifTrue: [ stackSize := stackPos ].! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/19/2008 16:13'!
indexOfLiteral: value ifAbsent: aBlock
	self literals doWithIndex: [ :literal :index |
		(literal isSymbol and: [ value isSymbol ] and: [ literal asSqueakObject = value asSqueakObject ]) ifTrue: [
			^ index ].
		value = literal ifTrue: [ ^ index ]].
	^ aBlock value
	! !

!NXTAbstractCodeCompiler methodsFor: 'initializing' stamp: 'mab 1/12/2009 11:16'!
initialize
	literals := OrderedCollection new.
	bytecodes := OrderedCollection new.
	arguments := OrderedCollection new.
	temporaries := OrderedCollection new.
	stackPos := 0.
	stackSize := 0.! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/3/2008 17:21'!
inline: startNode to: endNode do: actionBlock
	| inlineableActionBlock forwardJump backwardJump |
	true ifTrue: [ ^ false ].
	inlineableActionBlock := self compileForInlining: actionBlock.
	forwardJump := inlineableActionBlock bytecodes size  + 5.
	backwardJump := inlineableActionBlock bytecodes size + 8.
	(self jumpIfTrueAllowedFor: forwardJump) ifFalse: [ ^ false ].
	(self jumpBackAllowedFor: backwardJump) ifFalse: [ ^ false ].
	(self temporaries size + inlineableActionBlock temporaries size + 1 > self class maxTemps) ifTrue: [
		^ false ].
	(self temporaries includes: '__') ifTrue: [ ^ false].
	self temporaries add: '__'.

	self visitNode: startNode.
	self popTemp: self temporaries size + 1.
	self visitNode: endNode.
	self popVariable: '__'.
	
	self pushTemp: self temporaries size + 1.
	self pushVariable: '__'.
	self send: #>.
	self jumpIfTrue: forwardJump.
	inlineableActionBlock inlineIn: self.
	self pushTemp: self temporaries size + 1.
	self pushLiteral: 1.
	self send: #+.
	self popTemp: self temporaries size + 1.
	self jumpBack: backwardJump.
	
	self temporaries addAll: inlineableActionBlock temporaries.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 1/12/2009 13:29'!
inline: conditionBlock whileTrue: actionBlock
	| inlineableConditionBlock inlineableActionBlock forwardJump backwardJump |
	true ifTrue: [ ^ false ].
	inlineableConditionBlock := self compileForInlining: conditionBlock.
	inlineableActionBlock := self compileForInlining: actionBlock.
	forwardJump := inlineableActionBlock bytecodes size  + 2.
	backwardJump := inlineableConditionBlock bytecodes size + 2 + inlineableActionBlock bytecodes size.
	(self jumpIfTrueAllowedFor: forwardJump) ifFalse: [ ^ false ].
	(self jumpBackAllowedFor: backwardJump) ifFalse: [ ^ false ].
	inlineableConditionBlock inlineIn: self.
	self send: #not.
	self jumpIfTrue: forwardJump.
	inlineableActionBlock inlineIn: self.
	self jumpBack: backwardJump.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/3/2008 10:03'!
inlineIfFalse: falseBlock
	^ self inlineIfTrue: nil ifFalse: falseBlock! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/3/2008 10:03'!
inlineIfFalse: falseBlock ifTrue: trueBlock
	^ self inlineIfTrue: trueBlock ifFalse: falseBlock! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/3/2008 10:03'!
inlineIfTrue: trueBlock
	^ self inlineIfTrue: trueBlock ifFalse: nil! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 1/12/2009 13:29'!
inlineIfTrue: trueBlock ifFalse: falseBlock
	| inlineableTrueBlock inlineableFalseBlock |
	true ifTrue: [ ^ false ].
	inlineableTrueBlock := self compileForInlining: trueBlock.
	inlineableFalseBlock := self compileForInlining: falseBlock.
	(inlineableTrueBlock bytecodes size  <= 16 and: [ 
		inlineableFalseBlock bytecodes size + 2 <= 16]) ifFalse: [ ^ false ].
	self jumpIfTrue: inlineableFalseBlock bytecodes size + 2.
	inlineableFalseBlock inlineIn: self.
	self pushTrue.
	self jumpIfTrue: inlineableTrueBlock bytecodes size..
	inlineableTrueBlock inlineIn: self.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:18'!
instVarNames
	^ self compilerContext instVarNames! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:18'!
jumpBack: distance
	self decStackPos.
	^ self addBytecode: #jumpBack argument: distance - 1! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 11/3/2008 13:46'!
jumpBackAllowedFor: distance
	^ distance <= 16! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:20'!
jumpIfTrue: distance
	self addBytecode: #jumpIfTrue argument: distance - 1.
	self decStackPos..! !

!NXTAbstractCodeCompiler methodsFor: 'testing' stamp: 'mab 11/3/2008 10:17'!
jumpIfTrueAllowedFor: distance
	^ distance <= 16! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:05'!
lastStatement
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
literals
	^ literals! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
literals: anObject
	literals := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'literals' stamp: 'mab 11/19/2008 16:03'!
mapLiteral: aLiteral
	| index |
	index := (self indexOfLiteral: aLiteral ifAbsent: [ self literals add: aLiteral. self literals size ]) - 1.
	index > 31 ifTrue: [ self error: 'Too many literals' ].
	^ index! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:20'!
pop
	self addBytecode: #pop.
	self decStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:29'!
popInst: index
	index > self class maxInstVars ifTrue: [ self error: 'Instance variable out of index' ].
	self addBytecode: #popInst argument: index - 1.
	self decStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:21'!
popTemp: index
	index > self class maxTemps ifTrue: [ self error: 'Temporary out of index' ].
	self addBytecode: #popTemp argument: index - 1.
	self decStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'stack management' stamp: 'mab 1/12/2009 11:29'!
popVariable: aName
	self ifTemporary: aName doWithIndex: [ :index |
		^ self popTemp: index + 1 ].
	self ifInstVar: aName doWithIndex: [ :index |
		^ self popInst:index + 1 ].
	self error: 'Unknown variable'.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 15:37'!
primitive
	^ nil! !

!NXTAbstractCodeCompiler methodsFor: 'literals' stamp: 'mab 1/12/2009 10:39'!
processLiteral: value
	value ifNil: [ ^ self pushNil ].
	(value isKindOf: Boolean) ifTrue: [ value 
			ifTrue: [ ^ self pushTrue ]
			ifFalse: [ ^ self pushFalse ]].
	value isSymbol ifTrue: [ ^ self pushLiteral: value asNXTObject ].
	value isString ifTrue: [ ^ self pushLiteral: value asNXTObject ].
	value isInteger ifTrue: [ ^ self pushLiteral: value asNXTObject ].
	value isArray ifTrue: [
		^ self pushLiteral: (self convertLiteralArray: value) ].
	self error: 'Unknown literal value'.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:30'!
pushBlock: aBlock
	self addBytecode: #pushBlock argument: (self mapLiteral: aBlock).
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'stack management' stamp: 'mab 1/12/2009 11:32'!
pushClassVar: aName
	self pushSelf.
	self send: #class.
	self pushLiteral: aName asSymbol asNXTObject.
	self send: #classPoolAt:! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:31'!
pushFalse
	self addBytecode: #pushFalse.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:32'!
pushLiteral: literal
	self addBytecode: #pushLiteral argument: (self mapLiteral: literal).
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:32'!
pushNil
	self addBytecode: #pushNil.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:34'!
pushSelf
	self addBytecode: #pushSelf.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:35'!
pushTemp: index
	index > self class maxTemps ifTrue: [ self error: 'Temporary out of index' ].
	self addBytecode: #pushTemp argument: index - 1.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:35'!
pushTrue
	self addBytecode: #pushTrue.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'stack management' stamp: 'mab 11/18/2008 09:05'!
pushVariable: aName
	aName = 'self' ifTrue: [ ^ self addBytecode: #pushSelf ].
	aName = 'Smalltalk' ifTrue: [ 
		^ self pushLiteral: (NXTClassProxy for: #Smalltalk asNXTObject) ].
	aName = 'super' ifTrue: [ ^ self addBytecode: #pushSelf ].
	aName = 'thisContext' ifTrue: [ ^ self addBytecode: #pushThisContext ].
	aName = 'Processor' ifTrue: [ ^ self pushLiteral: (NXTClassProxy 
		for: #Processor asNXTObject) ].
	self ifClassVar: aName do: [ ^ self pushClassVar: aName ].
	self ifArgument: aName doWithIndex: [ :index |
		^ self addBytecode: #pushArg argument: index ].
	self ifTemporary: aName doWithIndex: [ :index |
		^ self addBytecode: #pushTemp argument: index ].
	self ifInstVar: aName doWithIndex: [ :index |
		^ self addBytecode: #pushInst argument: index ].
	self ifNXTClass: aName doWithName: [ :newName |
		^ self pushLiteral: (self compilerContext classNamed: newName asSymbol) ].
	self error: 'Unknown variable'.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 10:36'!
return
	self addBytecode: #return! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:38'!
send: aSymbol
	self addBytecode: #send argument: (self mapLiteral: aSymbol asNXTObject).
	self decStackPosBy: aSymbol numArgs.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 1/12/2009 11:44'!
stackSize
	^ stackSize! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:38'!
superSend: aSymbol
	self addBytecode: #superSend argument: (self mapLiteral: aSymbol asNXTObject).
	self decStackPosBy: aSymbol numArgs.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
temporaries
	^ temporaries! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
temporaries: anObject
	temporaries := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'inlining' stamp: 'mab 11/7/2008 02:19'!
tryInlining: aMessageNode
	true ifTrue: [ ^ false ].
	(self class inlineableSelectorsWithReceiver includes: aMessageNode selector) ifTrue: [ ^ self 
		perform: ('inline:', aMessageNode selector) asSymbol 
		withArguments: (Array with: aMessageNode receiver), aMessageNode arguments ].
	(self class inlineableSelectors includes: aMessageNode selector) ifTrue: [ 
		self visitNode: aMessageNode receiver.
		^ self 
			perform: ('inline', aMessageNode selector capitalized) asSymbol 
			withArguments: aMessageNode arguments ].
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 10/9/2008 09:50'!
visitArgument: argumentNode
	self arguments add: argumentNode name! !

!NXTAbstractCodeCompiler methodsFor: 'ast visiting' stamp: 'mab 10/9/2008 09:50'!
visitTemporaryVariable: aNode
	self temporaries add: aNode name.! !

NXTAbstractCodeCompiler subclass: #NXTBlockCompiler
	instanceVariableNames: 'lastStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTBlockCompiler commentStamp: 'mab 3/13/2009 10:49' prior: 0!
My instances have the purpose of compiling blocks.

Instance Variables
	lastStatement:		<Boolean>

lastStatement
	- Indicates, whether we're currently compiling the last statement, which means no final pop has to be generated.
!

!NXTBlockCompiler methodsFor: 'ast visiting' stamp: 'mab 1/29/2009 13:09'!
acceptSequenceNode: aSequenceNode 
	self visitTemporaryVariables: aSequenceNode temporaries.
	aSequenceNode statements
		ifNotEmpty: [ aSequenceNode statements 
			allButLastDo: [:each | (self visitNode: each) 
				ifTrue: [self pop]].
			self lastStatement: true.
			self visitNode: (aSequenceNode statements last)]
		ifEmpty: [ self pushNil ].
	self addBytecode: #return.! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:27'!
allArguments
	^ self arguments, self compilerContext allArguments! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:27'!
allTemporaries
	^ self temporaries, self compilerContext allTemporaries! !

!NXTBlockCompiler methodsFor: 'compiling' stamp: 'mab 1/12/2009 11:44'!
compile: aBlockNode
	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.
	^ NXTBlock 
		bytecodes: { self stackSize }, self bytecodes
		literals: self literals
		numTemps: self temporaries size
		numArgs: self arguments size! !

!NXTBlockCompiler methodsFor: 'testing' stamp: 'mab 6/12/2008 15:20'!
compilesBlock
	^ true! !

!NXTBlockCompiler methodsFor: 'initializing' stamp: 'mab 5/7/2008 17:44'!
initialize
	super initialize.
	lastStatement := false.! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:04'!
lastStatement
	^ lastStatement! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:04'!
lastStatement: anObject
	lastStatement := anObject! !

!NXTBlockCompiler methodsFor: 'bytecodes' stamp: 'mab 1/29/2009 13:08'!
return
	self blockReturn! !

NXTBlockCompiler subclass: #NXTInlineBlockCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTInlineBlockCompiler commentStamp: 'mab 3/13/2009 10:52' prior: 0!
My instances are used to compile block in such a way, that they can be inlined into other methods. My functionality is currently not in use, but should be integrated again.

Instance Variables
!

!NXTInlineBlockCompiler class methodsFor: 'constants' stamp: 'mab 11/2/2008 22:38'!
bytecodesUsingLiterals
	^ OrderedCollection 
		with: (self bytecodes at: #pushLiteral)
		with: (self bytecodes at: #pushBlock)
		with: (self bytecodes at: #send)
		with: (self bytecodes at: #superSend)! !

!NXTInlineBlockCompiler class methodsFor: 'constants' stamp: 'mab 11/3/2008 16:10'!
bytecodesUsingTemporaries
	^ OrderedCollection 
		with: (self bytecodes at: #pushTemp)
		with: (self bytecodes at: #popTemp)
! !

!NXTInlineBlockCompiler class methodsFor: 'compiling' stamp: 'mab 11/3/2008 09:51'!
compile: block in: aCodeCompiler
	^ self new
		compilerContext: aCodeCompiler;
		compile: block
	! !

!NXTInlineBlockCompiler methodsFor: 'accessing' stamp: 'mab 11/2/2008 23:17'!
allArguments
	^ self compilerContext allArguments! !

!NXTInlineBlockCompiler methodsFor: 'accessing' stamp: 'mab 11/3/2008 15:43'!
allTemporaries
	^ self temporaries, self compilerContext allTemporaries! !

!NXTInlineBlockCompiler methodsFor: 'compiling' stamp: 'mab 11/3/2008 10:00'!
compile: aBlockNode
	aBlockNode ifNil: [ ^ self compileAsEmpty ].
	aBlockNode isVariable ifTrue: [ ^ self compileForVariable: aBlockNode ].
	aBlockNode isBlock ifFalse: [ self error: 'Block expected' ].
	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.
	self bytecodes removeLast.! !

!NXTInlineBlockCompiler methodsFor: 'compiling' stamp: 'mab 11/3/2008 10:01'!
compileAsEmpty
	self pushNil.! !

!NXTInlineBlockCompiler methodsFor: 'compiling' stamp: 'mab 11/3/2008 09:54'!
compileForVariable: aVarNode
	self acceptVariableNode: aVarNode.
	self send: #value.! !

!NXTInlineBlockCompiler methodsFor: 'inlining' stamp: 'mab 11/3/2008 16:21'!
inline: bytecode in: aCodeCompiler
	(self usesLiteral: bytecode) ifTrue: [
		^ aCodeCompiler bytecodes add: (self withoutLiteralIndex: bytecode)
			+ (aCodeCompiler mapLiteral: (self literalFor: bytecode)) ].
	(self usesTemporary: bytecode) ifTrue: [
		^ aCodeCompiler bytecodes add: (self relocateTemporary: bytecode for: aCodeCompiler) ].
	aCodeCompiler bytecodes add: bytecode.
		
		! !

!NXTInlineBlockCompiler methodsFor: 'inlining' stamp: 'mab 11/2/2008 22:33'!
inlineIn: aCodeCompiler
	self bytecodes do: [ :bytecode |
		self inline: bytecode in: aCodeCompiler ].! !

!NXTInlineBlockCompiler methodsFor: 'literals' stamp: 'mab 11/2/2008 22:48'!
literalFor: bytecode
	^ self literals at: (bytecode - (self withoutLiteralIndex: bytecode) + 1)
		
		! !

!NXTInlineBlockCompiler methodsFor: 'temporaries' stamp: 'mab 11/3/2008 16:20'!
onlyTemporaryIndex: bytecode
	^ bytecode bitAnd: 2r00000111! !

!NXTInlineBlockCompiler methodsFor: 'temporaries' stamp: 'mab 11/3/2008 17:21'!
relocateTemporary: bytecode for: aCodeCompiler
	self temporaries size = 0 ifTrue: [ ^ bytecode].
	(self onlyTemporaryIndex: bytecode) >= self temporaries size 
		ifTrue: [ ^ (self withoutTemporaryIndex: bytecode)
			+ (self onlyTemporaryIndex: bytecode) - self temporaries size ]
		ifFalse: [ ^ (self withoutTemporaryIndex: bytecode)
			+ aCodeCompiler temporaries size + (self onlyTemporaryIndex: bytecode) ]
	! !

!NXTInlineBlockCompiler methodsFor: 'bytecodes' stamp: 'mab 1/29/2009 13:08'!
return
	self addBytecode: #return! !

!NXTInlineBlockCompiler methodsFor: 'literals' stamp: 'mab 11/3/2008 16:09'!
usesLiteral: bytecode
	^ self class bytecodesUsingLiterals includes: (self withoutLiteralIndex: bytecode)
		! !

!NXTInlineBlockCompiler methodsFor: 'temporaries' stamp: 'mab 11/3/2008 16:11'!
usesTemporary: bytecode
	^ self class bytecodesUsingTemporaries includes: (self withoutTemporaryIndex: bytecode)
		! !

!NXTInlineBlockCompiler methodsFor: 'ast visiting' stamp: 'mab 11/3/2008 15:43'!
visitArgument: argumentNode
	self temporaries add: argumentNode name! !

!NXTInlineBlockCompiler methodsFor: 'ast visiting' stamp: 'mab 11/3/2008 15:43'!
visitTemporaryVariable: aNode
	self temporaries add: aNode name.! !

!NXTInlineBlockCompiler methodsFor: 'literals' stamp: 'mab 11/2/2008 22:45'!
withoutLiteralIndex: bytecode
	^ bytecode bitAnd: 2r11100000! !

!NXTInlineBlockCompiler methodsFor: 'temporaries' stamp: 'mab 11/3/2008 16:10'!
withoutTemporaryIndex: bytecode
	^ bytecode bitAnd: 2r11111000! !

NXTAbstractCodeCompiler subclass: #NXTMethodCompiler
	instanceVariableNames: 'primitive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTMethodCompiler commentStamp: 'mab 3/13/2009 10:57' prior: 0!
My instances are capable of compiling whole methods and start necessary block compilers on demand.

Instance Variables
	primitive:		<Integer>

primitive
	- The number of system primitive, if one is found in the method.
!

!NXTMethodCompiler methodsFor: 'ast visiting' stamp: 'mab 5/29/2008 14:59'!
acceptMethodNode: aMethodNode
	aMethodNode pragmas do: [:each | self visitNode: each].
	self visitMethodArguments: aMethodNode arguments.
	self visitNode: aMethodNode body! !

!NXTMethodCompiler methodsFor: 'ast visiting' stamp: 'mab 5/29/2008 15:25'!
acceptPragmaNode: aPragmaNode
	| pragma newMethodNode |
	pragma := aPragmaNode pragma.
	pragma keyword = #NXTPrimitive: ifTrue: [
		self primitive: (pragma argumentAt: 1) ].
	pragma keyword = #nxtTakeMethodFrom: ifTrue: [ 
		newMethodNode := SqueakParser parseMethod: ((Smalltalk at: (pragma argumentAt: 1))
			compiledMethodAt: (aPragmaNode parent selector )) getSource.
		aPragmaNode parent arguments: newMethodNode arguments.
		aPragmaNode parent body: newMethodNode body ].! !

!NXTMethodCompiler methodsFor: 'ast visiting' stamp: 'mab 1/12/2009 10:36'!
acceptSequenceNode: aSequenceNode 
	self primitive ifNotNil: [ ^ nil ].
	self visitTemporaryVariables: aSequenceNode temporaries.
	aSequenceNode statements do: [:each | (self visitNode: each) ifTrue: [self pop]].
	(aSequenceNode statements isEmpty or: [
		aSequenceNode statements last isReturn not]) ifTrue: [ 
			self pushSelf. self return ].! !

!NXTMethodCompiler methodsFor: 'compiling' stamp: 'mab 1/12/2009 11:45'!
compileMethod: aCompiledMethod
	| ast |
	ast := SqueakParser parseMethod: aCompiledMethod getSource.
	self visitNode: ast.
	self primitive ifNil: [ ^ NXTMethod 
		bytecodes: { self stackSize }, self bytecodes 
		literals: self literals , (OrderedCollection 
			with: aCompiledMethod selector asNXTObject
			with: self compilerContext nxtClass)
		numTemps: self temporaries size
		numArgs: self arguments size ].
	^ NXTMethod primitive: self primitive numArgs: self arguments size! !

!NXTMethodCompiler methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:37'!
primitive
	^ primitive! !

!NXTMethodCompiler methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:08'!
primitive: anObject
	primitive := anObject! !

!Message methodsFor: '*nxtalk' stamp: 'mab 11/13/2008 15:42'!
asNXTObject
	^ NXTMessage selector: self selector asNXTObject arguments: (NXTArray withAll: self arguments)

	! !
NXTSymbol initialize!
NXTObject initialize!
NXTClassTest initialize!
